// Dr. Brown's Background Remover.jsx
// 10/17/2007 12:24
// For Dr. Brown

/*
@@@BUILDINFO@@@ Dr. Brown's Background Remover.jsx 1.0.0.0
*/


/*
<javascriptresource>
<about>$$$/JavaScripts/DrBrownBackgroundRemover/About=Dr. Brown's Background Remover^r^rCopyright 2007 Adobe Systems Incorporated. All rights reserved.^r^r</about>
<category>DrBrown</category>
</javascriptresource>
*/

// Use this script to remove a solid color background from a movie layer

// The user will be asked via the Color Range dialog for a color selection

// That will be supplied in turn to each frame in the movie



// We also do a hue saturation smash to help out green and blue screen removal

// it is currently set up for green and blue screen removal, and I try to auto

// detect the color



// Get the color range from the user

// loop start

//	delete selection contents

//  delete selection

//	hue/saturation green(blue) channel blast to -100%

//	next frame <- this may error, that is ok

//	do selection from first color range

// repeat



var doHueSat = true;

var doGreen = true; // false is for Blue screen removal

var magicParamsForGreen = [ 3,  75, 105, 135, 165 ];

var magicParamsForBlue =  [ 5, 195, 225, 255, 285 ];



try {



	if ( ! app.featureEnabled("photoshop/extended") ) {
		
		throw("You need the Extended version of Adobe Photoshop CS3 to run this script.");
	
	}

	if ( documents.length == 0 ) {

		throw("You need a file open and a video layer selected.");

	}

	
	if ( activeDocument.activeLayer.kind != LayerKind.VIDEO ) {

		throw("You need a video layer.");

	}


	var colorRangeDesc = DoColorRange( true );

	

	doGreen = IsItGreen( colorRangeDesc );

	

	// if we had some way to get the frame count we could loop on that

	var keepGoing = true;

	while ( keepGoing ) {

		activeDocument.selection.cut();

		// activeDocument.selection.clear();

		if ( doHueSat ) {

			if ( doGreen ) {

				DoHueSaturation( magicParamsForGreen );

			} else {

				DoHueSaturation( magicParamsForBlue );

			}

		}

		keepGoing = GotoNextFrame();

		if ( keepGoing ) {

			DoColorRange( colorRangeDesc );

			// checking the current selection is not needed as goto next frame will get it

			var b = activeDocument.selection.bounds;

			if ( ( b.right - b.left ) == 0 ) {

				keepGoing = false;

				alert('Stopping because there is no selection, possible out of frames or the Color Range settings do not work on this frame.');

			}

		}

	}

}

catch(e) {

	alert(e);

}



function DoColorRange(descriptorOrPopDialog) {

	if ( descriptorOrPopDialog.typename == "ActionDescriptor" ) {

		return executeAction( charIDToTypeID( "ClrR" ), descriptorOrPopDialog, DialogModes.NO );

	} else {

		return executeAction( charIDToTypeID( "ClrR" ), undefined, DialogModes.ALL );

	}

}



// I used the 'insert menu item' command from the actions palette

// to get this! A great way to capture things that do not show

// in the actions palette during normal recording

function GotoNextFrame() {

	var thatWorked = undefined;

	try {

		var id69 = charIDToTypeID( "slct" );

		var desc16 = new ActionDescriptor();

		var id70 = charIDToTypeID( "null" );

			var ref9 = new ActionReference();

			var id71 = charIDToTypeID( "Mn  " );

			var id72 = charIDToTypeID( "MnIt" );

			var id73 = stringIDToTypeID( "timelineGoToNextFrame" );

			ref9.putEnumerated( id71, id72, id73 );

		desc16.putReference( id70, ref9 );

		executeAction( id69, desc16, DialogModes.NO );

		thatWorked = true;

	}

	catch(e) {

		thatWorked = false;

		alert('All frames are processed.');

	}

	return thatWorked;

}



function DoHueSaturation( inValues ) {

	var id3 = charIDToTypeID( "HStr" );

    var desc2 = new ActionDescriptor();

    var id4 = charIDToTypeID( "Clrz" );

    desc2.putBoolean( id4, false );

    var id5 = charIDToTypeID( "Adjs" );

        var list1 = new ActionList();

            var desc3 = new ActionDescriptor();

            var id6 = charIDToTypeID( "LclR" );

            desc3.putInteger( id6, inValues[0] );

            var id7 = charIDToTypeID( "BgnR" );

            desc3.putInteger( id7, inValues[1] );

            var id8 = charIDToTypeID( "BgnS" );

            desc3.putInteger( id8, inValues[2] );

            var id9 = charIDToTypeID( "EndS" );

            desc3.putInteger( id9, inValues[3] );

            var id10 = charIDToTypeID( "EndR" );

            desc3.putInteger( id10, inValues[4] );

            var id11 = charIDToTypeID( "H   " );

            desc3.putInteger( id11, 0 );

            var id12 = charIDToTypeID( "Strt" );

            desc3.putInteger( id12, -100 );

            var id13 = charIDToTypeID( "Lght" );

            desc3.putInteger( id13, 0 );

        var id14 = charIDToTypeID( "Hst2" );

        list1.putObject( id14, desc3 );

    desc2.putList( id5, list1 );

	executeAction( id3, desc2, DialogModes.NO );

}



function IsItGreen( crDesc ) {

	var isGreen = true;

	if ( crDesc.typename == "ActionDescriptor" ) {

		if ( crDesc.hasKey( charIDToTypeID( "Mnm " ) ) ) {

			var labColor = new SolidColor;

			labColor.model = ColorModel.LAB;

			var minDesc = crDesc.getObjectValue( charIDToTypeID( "Mnm " ) );

			if ( minDesc.hasKey( charIDToTypeID( "Lmnc" ) ) ) {

				labColor.lab.l = minDesc.getDouble(  charIDToTypeID( "Lmnc" ) );

				labColor.lab.a = minDesc.getDouble(  charIDToTypeID( "A   " ) );

				labColor.lab.b = minDesc.getDouble(  charIDToTypeID( "B   " ) );

				if ( labColor.rgb.blue > 150 ) {

					isGreen = false;

				}

			}

		}

	}

	return isGreen;

}