// 5/17/2006 13:07

// (c) 2007 Adobe Systems, Inc. All rights reserved.
// Produced and Directed by Dr. Brown ( a.k.a Russell Preston Brown )
// Written by Tom Ruark
// Special thanks to Peter Krogh for all his help on this project
// UI Design stolen from Image Processor 
// which was done by Julie Meridian and improved on by Russell

/*
<javascriptresource>
<about>$$$/JavaScripts/DrBrownCaptionMaker/About=Dr. Brown's Caption Maker^r^rCopyright 2007 Adobe Systems Incorporated. All rights reserved.^r^r</about>
<category>DrBrown</category>
</javascriptresource>
*/

// enable double clicking from the Macintosh Finder or the Windows Explorer
#target photoshop

// in case we double clicked the file
app.bringToFront();

// debug level: 0-2 (0:disable, 1:break on error, 2:break at beginning)
// $.level = 1;
// debugger; // launch debugger on next line

// on localized builds we pull the $$$/Strings from a .dat file, see documentation for more details
// Caption Maker is not localized $.localize = true; 
// It would not take much to localize it as most of the strings are from Image Processor

// the main routine
// the CaptionMaker object does most of the work
try { 

	GlobalVariables();

	CheckVersion();
	
	if ( IsWindowsOS() ) {
		gShortFileNameLength = gShortFileNameLengthWin;
	}

	var gCM = new CaptionMaker();

	gCM.LoadParamsFromDisk( GetDefaultParamsFile() );
	
	gCM.CreateDialog();
	
	if ( gCM.RunDialog() ) {

		gCM.Execute();
		
	}

	gCM.GetParamsFromDialog();

	gCM.SaveParamsToDisk( GetDefaultParamsFile() );

}

// Lot's of things can go wrong
// Give a generic alert and see if they want the details
catch( e ) {
	if ( confirm( strSorry ) ) {
		alert( e + " : " + e.line );
	}
	alert( "Dr. Brown recommends you delete your preferences for this script. The location is: " + GetDefaultParamsFile().fsName );
}

// restore the prefs
app.displayDialogs = gSaveDialogMode;
app.preferences.rulerUnits = gSaveUnits;
app.preferences.typeUnits = gSaveTypeUnits;
app.preferences.numberOfHistoryStates = gSaveNumberHistory;


//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////
// Function: GlobalVariables
// Usage: all of my globals
// Input: <none>
// Return: <none>
///////////////////////////////////////////////////////////////////////////////
function GlobalVariables() {

	// a version for possible expansion issues
	gVersion = "1.3";
	
	// A list of file extensions I will skip, keep them lower case
	gFilesToSkip = Array( "db", "xmp", "thm", "txt", "doc", "md0", "tb0", 
	                      "adobebridgedb", "adobebridgedbt", "bc", "bct" );

	// A list of fonts and their post script names
	gFontList = [ [ 'Courier New', 'CourierNewPSMT' ], 
	              [ 'Helvetica', 'Helvetica' ], 
	              [ 'Helvetica Bold', 'Helvetica-Bold' ], 
				  [ 'Times New Roman', 'TimesNewRomanPSMT' ], ];

	// A list of font sizes: "Name for UI", "caption percentage", "pro percentage"
	gFontSizeList = [ [ 'Small',  0.70, 0.50 ],
		              [ 'Medium', 1.00, 0.70 ],
					  [ 'Large',  1.50, 0.90 ] ];

	gCustomMenuList = [ 'Create Custom Text', 'Edit Custom Text', 'Delete Custom Text' ];

	// list of files to populate the PDF save dialog with
	gFilesForPDF = [];

	// the location of the custom text index(s) in the drop down lists
	gCustomTextNewIndex = 1;
	gCustomTextEditIndex = 1;
	gCustomTextDeleteIndex = 1;

	// limit the length of text in edit boxes by this length
	gShortFileNameLengthWin = 30;
	gShortFileNameLengthMac = 22;
	gShortFileNameLength = gShortFileNameLengthMac;

	gVerboseSeperator = " \\\\ "; // two slashes create one slash
	
	// remember the dialog modes
	gSaveDialogMode = app.displayDialogs;
	app.displayDialogs = DialogModes.NO;

	// some numbers to tweak your results
	gBorderPercentageCaption = 0.06;
	gMaxFontSize = 120;
	gMinFontSize = 8;
	gUsePrettyDate = true;
	gShowTime = false;
	gCloseAfterSave = true;

	// some colors
	gColorWhite = new SolidColor();
	gColorWhite.model = ColorModel.RGB;
	gColorWhite.rgb.red = 255;
	gColorWhite.rgb.green = 255;
	gColorWhite.rgb.blue = 255;

	gColorLightGray = new SolidColor();
	gColorLightGray.model = ColorModel.RGB;
	gColorLightGray.rgb.red = 180;
	gColorLightGray.rgb.green = 180;
	gColorLightGray.rgb.blue = 180;

	gColorGray = new SolidColor();
	gColorGray.model = ColorModel.RGB;
	gColorGray.rgb.red = 127;
	gColorGray.rgb.green = 127;
	gColorGray.rgb.blue = 127;

	gColorDarkGray = new SolidColor();
	gColorDarkGray.model = ColorModel.RGB;
	gColorDarkGray.rgb.red = 100;
	gColorDarkGray.rgb.green = 100;
	gColorDarkGray.rgb.blue = 100;

	gColorBlack = new SolidColor();
	gColorBlack.model = ColorModel.RGB;
	gColorBlack.rgb.red = 0;
	gColorBlack.rgb.green = 0;
	gColorBlack.rgb.blue = 0;
	
	// A list of border colors: "Color Name for UI", "Caption Color", "Pro Print Ring Color"
	gBorderColors = [ [ 'White', gColorWhite, gColorLightGray, gColorBlack ], 
		              [ 'Light Gray', gColorLightGray, gColorGray, gColorBlack ], 
					  [ 'Black', gColorBlack, gColorDarkGray, gColorWhite ] ];

	// alignment variables
	gAlignBottomEdges = charIDToTypeID( "AdBt" );
	gAlignTopEdges = charIDToTypeID( "AdTp" );
	gAlignLeftEdges = charIDToTypeID( "AdLf" );
	gAlignHorizontalCenters = charIDToTypeID( "AdCH" );
	gAlignRightEdges = charIDToTypeID( "AdRg" );

	gAlignLeft = charIDToTypeID( "Left" );
	gAlignCenter = charIDToTypeID( "Cntr" );
	gAlignRight = charIDToTypeID( "Rght" );

	// remember the dialog modes
	gSaveDialogMode = app.displayDialogs;
	gSaveUnits = app.preferences.rulerUnits;
	gSaveTypeUnits = app.preferences.typeUnits;
	gSaveNumberHistory = app.preferences.numberOfHistoryStates;

	// set my preferences 
	app.displayDialogs = DialogModes.NO;
	app.preferences.rulerUnits = Units.PIXELS;
	app.preferences.typeUnits = TypeUnits.PIXELS;
	app.preferences.numberOfHistoryStates = 20;

	// all the strings that need localized
	// first set are ones that are different from CaptionMaker
	strTitle = localize( "$$$/JavaScript/CaptionMaker/Title=Dr. Brown's Caption Maker" );
	strBorderStyle = localize( "$$$/JavaScript/CaptionMaker/BorderStyle=Border Style" );
	strCaptionPrint = localize( "$$$/JavaScript/CaptionMaker/CaptionPrint=Captioned Print" );
	strProImageDelivery = localize( "$$$/JavaScript/CaptionMaker/ProImageDelivery=Professional Image Delivery" );
	strFont = localize( "$$$/JavaScript/CaptionMaker/Font=Font:" );
	strFontSize = localize( "$$$/JavaScript/CaptionMaker/FontSize=Font Size:" );
	strBorderColor = localize( "$$$/JavaScript/CaptionMaker/BorderColor=Border Color:" );
	strScripts = localize( "$$$/JavaScripts/CaptionMaker/Scripts=Scripts" );
	strIcons = localize( "$$$/JavaScripts/CaptionMaker/Icons=Icons" );
	strCouldNotFind = localize( "$$$/JavaScripts/CaptionMaker/CouldNotFind=Could not find " );
	strSelectMetadata = localize( "$$$/JavaScripts/CaptionMaker/SelectMetadata=Select metadata for captions" );
	str640px = localize( "$$$/JavaScripts/CaptionMaker/px640=640 px wide (email)" );
	str1024px = localize( "$$$/JavaScripts/CaptionMaker/px1024=1024 px wide (presentation)" );
	str1800px = localize( "$$$/JavaScripts/CaptionMaker/px1800=1800 px wide (4x6 @ 300 PPI)" );
	str3000px = localize( "$$$/JavaScripts/CaptionMaker/px3000=3000 px wide (8x10 @ 300 PPI)" );
	strMakePDF = localize( "$$$/JavaScripts/CaptionMaker/MakePDF=&Make PDF Presentation" );

	// these are the same as the ones in ImageProcessor so we could steal them for localization use
	strLabelSource = localize( "$$$/JavaScripts/ImageProcessor/Source=Select the images to process" );
	strNoImagesSelected = localize( "$$$/JavaScripts/ImageProcessor/NoImagesSelected=No images have been selected" );
	strNoFolderSelected = localize( "$$$/JavaScripts/ImageProcessor/NoFolderSelected=No folder has been selected" );
	strLabelSourceHelp = localize( "$$$/JavaScripts/ImageProcessor/SourceHelp=Location of files to process" );
	strLabelDestination = localize( "$$$/JavaScripts/ImageProcessor/Destination=Select location to save processed images" );
	strSaveInSameLocation = localize( "$$$/JavaScripts/ImageProcessor/SaveInSameLocation=S&ave in Same Location" );
	strSaveInSameLocationHelp = localize( "$$$/JavaScripts/ImageProcessor/SaveInSameLocationHelp=Save the new documents next to the original documents" );
	strUseOpen = localize( "$$$/JavaScripts/ImageProcessor/UseOpen=Use Open &Images" );
	strUseOpenHelp = localize( "$$$/JavaScripts/ImageProcessor/UseOpenHelp=Use the images that are currently open" );
	strButtonBrowse1 = localize( "$$$/JavaScripts/ImageProcessor/Browse1=Select &Folder..." );
	strButtonBrowse2 = localize( "$$$/JavaScripts/ImageProcessor/Browse2=Sele&ct Folder..." );
	strButtonRun = localize( "$$$/JavaScripts/ImageProcessor/Run=Run" );
	strBridge = localize( "$$$/JavaScripts/ImageProcessor/Bridge=Process files from Bridge only" );
	strBridgeHelp = localize( "$$$/JavaScripts/ImageProcessor/BridgeHelp=Selected files from Bridge will be processed" );
	strButtonCancel = localize("$$$/JavaScripts/ImageProcessor/Cancel=Cancel");
	strButtonLoad = localize("$$$/JavaScripts/ImageProcessor/Load=&Load...");
	strButtonLoadHelp = localize("$$$/JavaScripts/ImageProcessor/LoadHelp=Load a settings file from disk");
	strButtonSave = localize("$$$/JavaScripts/ImageProcessor/Save=&Save...");
	strButtonSaveHelp = localize("$$$/JavaScripts/ImageProcessor/SaveHelp=Save the current dialog settings to disk");
	strFileType = localize( "$$$/JavaScripts/ImageProcessor/FileType=File Type" );
	strSaveAsJPEG = localize( "$$$/JavaScripts/ImageProcessor/SaveAsJPEG=Save as &JPEG" );
	strSaveAsJPEGHelp = localize( "$$$/JavaScripts/ImageProcessor/SaveAsJPEGHelp=Save a file to the JPEG format" );
	strQuality = localize( "$$$/JavaScripts/ImageProcessor/Quality=Quality:" );
	strConvertICC = localize( "$$$/JavaScripts/ImageProcessor/Convert=Con&vert Profile to sRGB" );
	strConvertICCHelp = localize( "$$$/JavaScripts/ImageProcessor/ConvertHelp=Convert the ICC profile to sRGB before saving" );
	strResizeToFit1 = localize( "$$$/JavaScripts/ImageProcessor/ResizeToFit1=&Resize to Fit" );
	strResizeToFitHelp = localize( "$$$/JavaScripts/ImageProcessor/ResizeToFitHelp=Select to resize for this format" );
	strSaveAsTIFF = localize( "$$$/JavaScripts/ImageProcessor/SaveAsTIFF=Save as &TIFF" );
	strSaveAsTIFFHelp = localize( "$$$/JavaScripts/ImageProcessor/SaveAsTIFFHelp=Save a file to the TIFF format" );
	strLZW = localize( "$$$/JavaScripts/ImageProcessor/LZW=LZ&W Compression" );
	strLZWHelp = localize( "$$$/JavaScripts/ImageProcessor/LZWHelp=Use LZW compression when saving in TIFF format" );
	strPresets = localize( "$$$/JavaScripts/ImageProcessor/Presets=Presets" );
	strPickXML = localize( "$$$/JavaScripts/ImageProcessor/PickXML=Pick a XML file to load" );
	strPickXMLWin = localize( "$$$/JavaScripts/ImageProcessor/PickXMLWin=XML Files: *.xml" );
	strPickXMLSave = localize( "$$$/JavaScripts/ImageProcessor/PickXMLSave=Pick a XML file to save" );
	strPickSource = localize( "$$$/JavaScripts/ImageProcessor/PickSource=Pick a source folder" );
	strPickDest = localize( "$$$/JavaScripts/ImageProcessor/PickDest=Pick a destination folder" );
	strSpecifySource = localize( "$$$/JavaScripts/ImageProcessor/SpecifySource=Please specify a source folder." );
	strSpecifyDest = localize( "$$$/JavaScripts/ImageProcessor/SpecifyDest=Please specify a destination folder." );
	strJPEGQuality = localize( "$$$/JavaScripts/ImageProcessor/JPEGQuality=JPEG Quality must be between 0 and 12." );
	strOneType = localize( "$$$/JavaScripts/ImageProcessor/OneType=You must save to at least one file type." );
	strMustUse = localize( "$$$/JavaScripts/ImageProcessor/MustUse=You must use Photoshop CS 2 or later to run this script!" );
	strSorry = localize( "$$$/JavaScripts/ImageProcessor/Sorry=Sorry, something major happened and I can't continue! Would you like to see more info?" );
	strMustSaveOpen = localize( "$$$/JavaScripts/ImageProcessor/MustSaveOpen=Open files must be saved before they can be used by the Image Processor." );
	strFollowing = localize( "$$$/JavaScripts/ImageProcessor/Following=The following files will not be saved." );

	gIcnOne = GetImage( 'one.png', 'Step1Icon' );
	gIcnTwo = GetImage( 'two.png', 'Step2Icon' );
	gIcnThree = GetImage( 'three.png', 'Step3Icon' );
	gIcnFour = GetImage( 'four.png', 'Step4Icon' );
	gIcnFive = GetImage( 'five.png', 'Step4Icon' );
	gIcnProBK = GetImage( 'Pro_BK.png', undefined );
	gIcnProLG = GetImage( 'Pro_LG.png', undefined );
	gIcnProWh = GetImage( 'Pro_Wh.png', undefined );
	gIcnCapLftCtrRtBK = GetImage( 'Captioned_Lft_Ctr_Rt_BK.png', undefined );
	gIcnCapLftCtrRtLG = GetImage( 'Captioned_Lft_Ctr_Rt_LG.png', undefined );
	gIcnCapLftCtrRtWh = GetImage( 'Captioned_Lft_Ctr_Rt_Wh.png', undefined );
	gIcnCapLftCtrBK = GetImage( 'Captioned_Lft_Ctr_BK.png',    undefined );
	gIcnCapLftCtrLG = GetImage( 'Captioned_Lft_Ctr_LG.png',    undefined );
	gIcnCapLftCtrWh = GetImage( 'Captioned_Lft_Ctr_Wh.png',    undefined );
	gIcnCapLftBK = GetImage( 'Captioned_Lft_BK.png', undefined );
	gIcnCapLftLG = GetImage( 'Captioned_Lft_LG.png', undefined );
	gIcnCapLftWh = GetImage( 'Captioned_Lft_Wh.png', undefined );
	gIcnCapCtrRtBK = GetImage( 'Captioned_Ctr_Rt_BK.png', undefined );
	gIcnCapCtrRtLG = GetImage( 'Captioned_Ctr_Rt_LG.png', undefined );
	gIcnCapCtrRtWh = GetImage( 'Captioned_Ctr_Rt_Wh.png', undefined );
	gIcnCapCtrBK = GetImage( 'Captioned_Ctr_BK.png', undefined );
	gIcnCapCtrLG = GetImage( 'Captioned_Ctr_LG.png', undefined );
	gIcnCapCtrWh = GetImage( 'Captioned_Ctr_Wh.png', undefined );
	gIcnCapRtBK = GetImage( 'Captioned_Rt_BK.png', undefined );
	gIcnCapRtLG = GetImage( 'Captioned_Rt_LG.png', undefined );
	gIcnCapRtWh = GetImage( 'Captioned_Rt_Wh.png', undefined );
	gIcnCapLftRtBK = GetImage( 'Captioned_Lft_Rt_BK.png', undefined );
	gIcnCapLftRtLG = GetImage( 'Captioned_Lft_Rt_LG.png', undefined );
	gIcnCapLftRtWh = GetImage( 'Captioned_Lft_Rt_Wh.png', undefined );
	gIcnCapNoneBK = GetImage( 'Captioned_NONE_BK.png', undefined );
	gIcnCapNoneLG = GetImage( 'Captioned_NONE_LG.png', undefined );
	gIcnCapNoneWh = GetImage( 'Captioned_NONE_Wh.png', undefined );
	gIcnCapNoneF = GetImage( 'Captioned_NONE_F.png', undefined );

	gLastText = [];
	gLastIndex = [];
}


///////////////////////////////////////////////////////////////////////////////
// Function: CaptionMaker
// Usage: The main object for this script
///////////////////////////////////////////////////////////////////////////////
function CaptionMaker() {

	
	///////////////////////////////////////////////////////////////////////////////
	// Function: InitParams
	// Usage: My params that are saved off to disk and work wit load / unload
	///////////////////////////////////////////////////////////////////////////////
	this.InitParams = function() {
		var params = new Object();
		params.version = gVersion;
		params.useopen = false;
		params.source = "";
		params.saveinsame = true;
		params.dest = "";
		params.makePDF = false;
		params.jpeg = true;
		params.tiff = false;
		params.lzw = false;
		params.converticc = false;
		params.q = 8;
		params.resize = false;
		params.icc = true;
		params.captioned = true;
		params.font = "Helvetica";
		params.fontsize = "Medium";
		params.bordercolor = "White";
		params.checkbox = [ true, true, true, true, true, true, true, true, true ];
		params.meta = [ "Filename", "Copyright Notice", "Headline", "Description", "Credit",
		                "Instructions", "Color Profile", "Color Mode", "Document Kind"  ];
		params.addText = [ ];
		params.px = [ false, false, true, false ];
		params.unsharp = false;
		params.amount = 50;
		params.radius = 1.0;
		params.threshold = 0;
		params.metadatalist = [ "Filename", "Author", "Copyright Notice", "Headline", 
	                            "Description", "Credit", "Instructions", "Color Profile", 
	                            "Color Mode", "Document Kind", "Document Creator", "Date", 
	                            "Date Created", "Date File Modified", "City", "State/Province", 
	                            "Keywords", "Exposure Time", "Model", "Focal Length", "Current Date" ];

		// Here are others to add to the list, just add them to the array above. 
		// Make sure you remove your preferences. Mine is located here 
		// C:\Documents and Settings\username\Application Data\Adobe\Photoshop\9.0\Adobe Photoshop CS2 Settings

		// Make, Model, Exposure Time, F-Stop, Exposure Program, ISO Speed Ratings, Date Time Original,
		// Shutter Speed, Aperture Value, Exposure Bias Value, Max Aperture Value, Metering Mode, Flash,
		// Focal Length

		// NOTE: Your camera may have more or less. See activeDocument.info.exif for the file you are using.

		return params;
	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: InitDialog
	// Usage: Init the dialog with my params
	///////////////////////////////////////////////////////////////////////////////
	this.InitDialog = function() {
		var d = this.dlgMain;
		var p = this.params;
		this.dlgMain.cm = this;
		if ( ! this.runningFromBridge ) {
			if ( app.documents.length > 0 ) {
				d.rbUseOpen.value = p.useopen;
			} else {
				d.rbUseOpen.enabled = false;
				d.rbUseOpen.value = false;
			}
			d.rbUseFolder.value = ! d.rbUseOpen.value;
			d.stSource.text = CreateShortFileName( p.source );
			if ( d.stSource.text == "" ) {
				d.stSource.text = strNoImagesSelected;
			}
		}
		d.sourceLongText = p.source;
		d.rbSaveInSame.value = p.saveinsame;
		d.rbSaveInNew.value = ! d.rbSaveInSame.value;		
		d.stDest.text = CreateShortFileName( p.dest );
		if ( d.stDest.text == "" ) {
			d.stDest.text = strNoFolderSelected;
		}
		d.destLongText = p.dest;
		d.cbMakePDF.value = p.makePDF;
		d.cbJPEG.value = p.jpeg;
		d.cbTIFF.value = p.tiff;
		d.cbTIFFLZW.value = p.lzw;
		d.cbConvertICC.value = p.converticc;
		d.etQuality.text = p.q;
		d.cbResize.value = p.resize;
		d.rbCaption.value = p.captioned;
		d.rbPro.value = ! d.rbCaption.value;
		// do this only once to get the dropdowns initial size		
		if ( this.firstTimeLoad ) {
			this.firstTimeLoad = false;
			for ( var i = 0; i < d.metaDDs.length; i++ ) {
				for ( var j = 0; j < p.metadatalist.length; j++ ) {
					d.metaDDs[i].add( "item", p.metadatalist[j] );
				}
			}
		}
		d.SetDropDown( d.ddFont, p.font );
		d.SetDropDown( d.ddFontSize, p.fontsize );
		d.SetDropDown( d.ddBorderColor, p.bordercolor );
		for ( var i = 0; i < d.metaCBs.length; i++ ) {
			d.metaCBs[i].value = p.checkbox[i];
		} 
		d.rbPX1.value = p.px[0];
		d.rbPX2.value = p.px[1];
		d.rbPX3.value = p.px[2];
		d.rbPX4.value = p.px[3]; 
		d.cbUnsharpMask.value = p.unsharp;
		d.etAmount.text = p.amount;
		d.etRadius.text = p.radius;
		d.etThreshold.text = p.threshold;
	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: ForceDialogUpdate
	// Usage: pretend like i clicked it to get the other items to respond to 
	//        the current settings
	///////////////////////////////////////////////////////////////////////////////
	this.ForceDialogUpdate = function() {	
		if ( ! this.runningFromBridge ) {
			this.dlgMain.rbUseOpen.onClick();
		}
		this.dlgMain.rbSaveInSame.onClick();
		this.dlgMain.rbCaption.onClick();
		this.dlgMain.rbPro.onClick();
		this.dlgMain.cbJPEG.onClick();
		this.dlgMain.cbTIFF.onClick();
		for ( var i = 0; i < this.dlgMain.metaCBs.length; i++ ) {
			this.dlgMain.metaCBs[i].onClick();
		}
		this.dlgMain.cbResize.onClick();
		this.dlgMain.rbPX1.onClick();
		this.dlgMain.rbPX2.onClick();
		this.dlgMain.rbPX3.onClick();
		this.dlgMain.rbPX4.onClick();
		this.dlgMain.cbUnsharpMask.onClick();
	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: GetParamsFromDialog
	// Usage: transfer from the dialog widgets to my internal params
	///////////////////////////////////////////////////////////////////////////////
	this.GetParamsFromDialog = function() {
		var p = this.params;
		var d = this.dlgMain;
		if ( ! this.runningFromBridge ) {
			p.useopen = d.rbUseOpen.value;
			p.source = d.sourceLongText;
		}
		p.saveinsame = d.rbSaveInSame.value;
		p.dest = d.destLongText;
		p.makePDF = d.cbMakePDF.value;
		p.jpeg = d.cbJPEG.value;
		p.tiff = d.cbTIFF.value;
		p.lzw = d.cbTIFFLZW.value;
		p.converticc = d.cbConvertICC.value;
		p.q = d.etQuality.text;
		p.font = d.ddFont.selection.text;
		p.fontsize = d.ddFontSize.selection.text;
		p.bordercolor = d.ddBorderColor.selection.text;
		p.captioned = d.rbCaption.value;
		p.custom = [];
		for ( var i = 0; i < d.metaCBs.length; i++ ) {
			p.checkbox[i] = d.metaCBs[i].value;
			p.meta[i] = d.metaDDs[i].selection.text;
			p.custom[i] = d.metaDDs[i].selection.index > gCustomTextDeleteIndex;
		}
		p.resize = d.cbResize.value;
		p.px[0] = d.rbPX1.value;
		p.px[1] = d.rbPX2.value;
		p.px[2] = d.rbPX3.value;
		p.px[3] = d.rbPX4.value;
		p.unsharp = d.cbUnsharpMask.value;
		p.amount = d.etAmount.text;
		p.radius = d.etRadius.text;
		p.threshold = d.etThreshold.text;
	}
	

	///////////////////////////////////////////////////////////////////////////////
	// Function: RunDialog
	// Usage: routine for running the dialog and it's interactions
	///////////////////////////////////////////////////////////////////////////////
	this.RunDialog = function () {

		this.dlgMain.btnCancel.onClick = function() { 
			var d = FindDialog( this );
			d.close( false );
		}

		// after the layout add reset the drop downs to their full list
		this.dlgMain.onShow = function() {
			ResetAllDropDowns( this, 'meta' ); 
		}
		
		if ( ! this.runningFromBridge ) {
			this.dlgMain.rbUseOpen.onClick = function() {
				var d = FindDialog( this );
				d.rbUseFolder.value = ! this.value;
				d.btnSource.enabled = ! this.value;
				d.stSource.enabled = ! this.value;
			}

			this.dlgMain.rbUseFolder.onClick = function() {
				var d = FindDialog( this );
				d.rbUseOpen.value = ! this.value;
				d.btnSource.enabled = this.value;
				d.stSource.enabled = this.value;
			}

			this.dlgMain.btnSource.onClick = function() { 
				var d = FindDialog( this );
				var selFolder = Folder.selectDialog( strPickSource, this.parent.parent.sourceLongText );
				if ( selFolder != null ) {
					d.sourceLongText = selFolder.fsName.toString()
					d.stSource.text = CreateShortFileName( d.sourceLongText );
				}
				d.defaultElement.active = true;
			}
		}

		this.dlgMain.rbSaveInSame.onClick = function() {
			var d = FindDialog( this );
			d.rbSaveInNew.value = ! this.value;
			d.btnDest.enabled = ! this.value;
			d.stDest.enabled = ! this.value;
		}
		
		this.dlgMain.rbSaveInNew.onClick = function() {
			var d = FindDialog( this );
			d.rbSaveInSame.value = ! this.value;
			d.btnDest.enabled = this.value;
			d.stDest.enabled = this.value;
		}

		this.dlgMain.SetDropDown = function ( dd, strSet ) {
			var index = 0;
			for ( var i = 0; i < dd.items.length; i++ ) {
				if ( dd.items[ i ].toString() == strSet ) {
					index = i;
					break;
				}
			}
			if ( dd.items.length > 0 ) {
				dd.items[ index ].selected = true;
				dd.helpTip = dd.items[ index ].text;
			}
			return index;
		}

		this.dlgMain.btnLoad.onClick = function() { 
			var d = FindDialog( this );
			var loadFile = null;
			Folder.current = Folder( "~/" );
			if ( File.fs == "Windows" ) {
				loadFile = File.openDialog( strPickXML, strPickXMLWin );
			} else {
				loadFile = File.openDialog( strPickXML, MacXMLFilter );
			}
			if ( loadFile != null ) {
				d.cm.LoadParamsFromDisk( loadFile );
				d.cm.InitDialog();
				d.cm.ForceDialogUpdate();
				ResetAllDropDowns( d, 'meta' );
			}
			d.defaultElement.active = true;
		}
		
		this.dlgMain.btnSave.onClick = function() { 
			var d = FindDialog( this );
			var saveFile = null;
			Folder.current = Folder( "~/" );
			if ( File.fs == "Windows" ) {
				saveFile = File.saveDialog( strPickXMLSave, strPickXMLWin );
			} else {
				saveFile = File.saveDialog( strPickXMLSave, MacXMLFilter );
			}
			if ( saveFile != null ) {
				d.cm.GetParamsFromDialog();
				d.cm.SaveParamsToDisk( saveFile );
			}
			d.defaultElement.active = true;
		}

		this.dlgMain.btnDest.onClick = function() { 
			var d = FindDialog( this );
			var selFolder = Folder.selectDialog( strPickDest, this.parent.parent.destLongText );
			if ( selFolder != null ) {
				d.destLongText = selFolder.fsName.toString()
				d.stDest.text = CreateShortFileName( d.destLongText );
			}
			d.defaultElement.active = true;
		}
		
		this.dlgMain.cbTIFF.onClick = function() {
			var d = FindDialog( this );
			d.cbTIFFLZW.enabled = this.value;
		}
		
		this.dlgMain.cbJPEG.onClick = function() {
			var d = FindDialog( this );
			d.stQuality.enabled = this.value;
			d.etQuality.enabled = this.value;
			d.cbConvertICC.enabled = this.value;
		}
	
		this.dlgMain.etQuality.onChanging = function() {
			if ( this.text == 'ellipses' ) {
				var d = FindDialog( this );
				HideAllPreview( d );
				d.previews[d.previews.length - 1].show();
			}
		}

		this.dlgMain.rbCaption.value = true;

		var i;
		var j;

		for ( i = 0; i < gFontList.length; i++ ) {
			this.dlgMain.ddFont.add( "item", gFontList[i][0] );
		}
		this.dlgMain.ddFont.items[0].selected = true;

		for ( i = 0; i < gFontSizeList.length; i++ ) {
			this.dlgMain.ddFontSize.add( "item", gFontSizeList[i][0] );
		}
		this.dlgMain.ddFontSize.items[0].selected = true;

		for ( i = 0; i < gBorderColors.length; i++ ) {
			this.dlgMain.ddBorderColor.add( "item", gBorderColors[i][0] );
		}
		this.dlgMain.ddBorderColor.items[0].selected = true;

		this.dlgMain.rbCaption.onClick = function() {
			var d = FindDialog( this );
			for ( var i = 0; i < d.metaCBs.length; i++ ) {
				if ( i < 3 || ! this.value ) {
					d.metaCBs[i].onClick();
				}
				if ( i > 2 ) {
					d.metaCBs[i].enabled = ! this.value;
					if ( this.value ) {
						d.metaDDs[i].enabled = false;
					}
				}
			}
			EnableOnePreview( d );
		}
		
		this.dlgMain.rbPro.onClick = function() {
			var d = FindDialog( this );
			for ( var i = 0; i < d.metaCBs.length; i++ ) {
				if ( i > 2 ) {
					d.metaCBs[i].enabled = this.value;
				}
				if ( i < 3 || this.value ) {
					d.metaCBs[i].onClick();
				}
			}
			EnableOnePreview( d );
		}
		
		this.dlgMain.cbM1.onClick = function() {
			MetaDataCheckBoxOnClick( this, 0, true );
		}
		
		this.dlgMain.cbM2.onClick = function() {
			MetaDataCheckBoxOnClick( this, 1, true );
		}
		
		this.dlgMain.cbM3.onClick = function() {
			MetaDataCheckBoxOnClick( this, 2, true );
		}
		
		this.dlgMain.cbM4.onClick = function() {
			MetaDataCheckBoxOnClick( this, 3, false );
		}
		
		this.dlgMain.cbM5.onClick = function() {
			MetaDataCheckBoxOnClick( this, 4, false );
		}
		
		this.dlgMain.cbM6.onClick = function() {
			MetaDataCheckBoxOnClick( this, 5, false );
		}
		
		this.dlgMain.cbM7.onClick = function() {
			MetaDataCheckBoxOnClick( this, 6, false );
		}
		
		this.dlgMain.cbM8.onClick = function() {
			MetaDataCheckBoxOnClick( this, 7, false );
		}
		
		this.dlgMain.cbM9.onClick = function() {
			MetaDataCheckBoxOnClick( this, 8, false );
		}
		
		this.dlgMain.ddBorderColor.onChange = function() {
			EnableOnePreview( FindDialog( this ) );
		}

		this.dlgMain.ddM1.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM2.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM3.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM4.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM5.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM6.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM7.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM8.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.ddM9.onChange = function() {
			UpdateForCustomText( this );
		}

		this.dlgMain.cbResize.onClick = function() {
			var d = FindDialog( this );
			d.rbPX1.enabled = this.value;
			d.rbPX2.enabled = this.value;
			d.rbPX3.enabled = this.value;
			d.rbPX4.enabled = this.value;
		}
		
		this.dlgMain.rbPX1.onClick = function() {
			var d = FindDialog( this );
			if ( this.value ) {
				d.rbPX3.value = false;
				d.rbPX4.value = false;
			}
		}
		
		this.dlgMain.rbPX2.onClick = function() {
			var d = FindDialog( this );
			if ( this.value ) {
				d.rbPX3.value = false;
				d.rbPX4.value = false;
			}
		}
		
		this.dlgMain.rbPX3.onClick = function() {
			var d = FindDialog( this );
			if ( this.value ) {
				d.rbPX1.value = false;
				d.rbPX2.value = false;
			}
		}
		
		this.dlgMain.rbPX4.onClick = function() {
			var d = FindDialog( this );
			if ( this.value ) {
				d.rbPX1.value = false;
				d.rbPX2.value = false;
			}
		}
		
		this.dlgMain.cbUnsharpMask.onClick = function() {
			var d = FindDialog( this );
			d.stAmount.enabled = this.value;
			d.etAmount.enabled = this.value;
			d.stRadius.enabled = this.value;
			d.etRadius.enabled = this.value;
			d.stThreshold.enabled = this.value;
			d.etThreshold.enabled = this.value;
		}
		
		this.dlgMain.btnRun.onClick = function () {
			var testFolder = null;
			var d = FindDialog( this );
			if ( ! d.cm.runningFromBridge ) {
				if ( d.rbUseFolder.value ) {
					if ( d.sourceLongText.length > 0 && d.sourceLongText[0] != '.' ) {
						testFolder = new Folder( d.sourceLongText );
						if ( !testFolder.exists ) {
							alert( strSpecifySource );
							return;
						}
					} else {
						alert( strSpecifySource );
						return;
					}
				}
			}

			if ( d.rbSaveInNew.value ) {
				if ( d.destLongText.length > 0 && d.destLongText[0] != '.' ) {
					testFolder = new Folder( d.destLongText );
					if ( !testFolder.exists ) {
						alert( strSpecifyDest );
						return;
					}
				} else {
					alert( strSpecifyDest );
					return;
				}
			}
						
			if ( d.cbJPEG.value ) {
				var q = Number( d.etQuality.text );
				if ( q < 0 || q > 12 || isNaN( q ) ) {
					alert( strJPEGQuality );
					return;
				}
			}
			
			// make sure they have at least one file format specified for output
			var outputCount = 0;
			if ( d.cbJPEG.value ) {
				outputCount++;
			}
			if ( d.cbTIFF.value ) {
				outputCount++;
			}

			if ( outputCount == 0 ) {
				alert( strOneType );
				return;
			}

			// make sure the unsharp mask params are valid
			if ( d.cbUnsharpMask.value ) {
				var a = Number( d.etAmount.text );
				if ( a < 1 || a > 500 || isNaN( a ) ) {
					alert( "Unsharp mask amount must be between 1 and 500." );
					return;
				}
				a = Number( d.etRadius.text );
				if ( a < 0.1 || a > 250.0 || isNaN( a ) ) {
					alert( "Unsharp mask radius must be between 0.1 and 250.0." );
					return;
				}
				a = Number( d.etThreshold.text );
				if ( a < 0 || a > 255 || isNaN( a ) ) {
					alert( "Unsharp mask threshold must be between 0 and 255." );
					return;
				}
			}
			
			d.cm.GetParamsFromDialog()
			
			d.close( true );
		}

		this.InitDialog();

		this.ForceDialogUpdate();
		
		this.dlgMain.center();
		
		return this.dlgMain.show();

	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: Execute
	// Usage: if I get here then the dialog params are ok and it is time
	//        to do what they want
	///////////////////////////////////////////////////////////////////////////////
	this.Execute = function()  {
		var firstFileAsLowerCaseString = '';
		var inputFiles;
		if ( this.runningFromBridge ) {
			inputFiles = this.filesFromBridge;
		} else if ( this.params.useopen ) {
			inputFiles = OpenDocs();
		} else {
			inputFiles = Folder( this.params.source ).getFiles();
		}
		for ( var i = 0; i < inputFiles.length; i++ ) {
			if ( ( inputFiles[i] instanceof File && 
				! inputFiles[i].hidden && 
				! IsFileOneOfThese( inputFiles[i], gFilesToSkip ) ) ||
				this.params.useopen ) {
				    
				if ( this.params.useopen && ! this.runningFromBridge ) {
					app.activeDocument = inputFiles[ i ];
					if ( this.params.saveinsame ) {
						var destFolder = app.activeDocument.fullName.parent.toString();
					}
					app.activeDocument.duplicate();
				} else {
					open( inputFiles[ i ] );
					if ( this.params.saveinsame ) {
						var destFolder = app.activeDocument.fullName.parent.toString();
					}
				}
				app.activeDocument.resizeImage( undefined, undefined, 300, ResampleMethod.NONE );
				app.activeDocument.selection.selectAll();
				MakeSelectionPathAndDeselect( "Photo crop" );
				app.activeDocument.selection.deselect();
				if ( this.params.captioned ) {
					CaptionPrint( this.params );
				} else {
					ProPrint( this.params );
				}
				if ( ! this.params.saveinsame ) {
					var destFolder = this.params.dest;
				}
				this.SaveFile( app.activeDocument.name, destFolder );
				if ( gCloseAfterSave ) {
					app.activeDocument.close( SaveOptions.DONOTSAVECHANGES );
				}
			}
		}
		if ( this.params.makePDF ) {
			MakePDFPresentation( gFilesForPDF );
		}
	}
	
	
	///////////////////////////////////////////////////////////////////////////////
	// Function: SaveFile
	// Usage: I can save in JPEG and TIFF
	///////////////////////////////////////////////////////////////////////////////
	this.SaveFile = function ( inFileName, inFolderLocation ) {
		var lastDot = inFileName.lastIndexOf( "." );
		if ( lastDot == -1 ) {
			lastDot = inFileName.length;
		}
		var fileNameNoPath = inFileName.substr( 0, lastDot );
		var lastSlash = fileNameNoPath.lastIndexOf( "/" );
		fileNameNoPath = fileNameNoPath.substr( lastSlash + 1, fileNameNoPath.length );
		if ( this.params.jpeg ) {
			var subFolderText = inFolderLocation + "/JPEG/";
			Folder( subFolderText ).create();
			var historyState = app.activeDocument.activeHistoryState;
			app.activeDocument.flatten();
			app.activeDocument.bitsPerChannel = BitsPerChannelType.EIGHT;
			RemoveAlphaChannels();
			if ( DocumentMode.RGB != app.activeDocument.mode ) {
				ConditionalModeChangeToRGB();
			}
			if ( this.params.converticc ) {
				ConvertTosRGBProfile();
			}
			if ( this.params.resize ) {
				var fi = FitImage( this.params ); 
				var ringColor = false;
				if ( this.params.captioned ) {
					app.foregroundColor = GetBorderColor( this.params.bordercolor, ringColor );
					CanvasSize( false, fi[0], fi[1], true, "Cntr", "Cntr" );
				} else {
					app.foregroundColor = GetBorderColor( this.params.bordercolor, ringColor );
					CanvasSize( false, fi[0], fi[1], true, "Cntr", "Top " );
				}
			}
			if ( this.params.unsharp ) {
				activeDocument.pathItems["Photo crop"].makeSelection();
				activeDocument.activeLayer.applyUnSharpMask( this.params.amount, this.params.radius, this.params.threshold );	
				app.activeDocument.selection.deselect();
			}
			var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".jpg" );
			if ( this.params.makePDF ) {
				gFilesForPDF.push( File( uniqueFileName ) );
			}
			SaveAsJPEG( uniqueFileName, this.params.q, this.params.icc );
			app.activeDocument.activeHistoryState = historyState;
		}

		if ( this.params.tiff ) {
			var subFolderText = inFolderLocation + "/TIFF/";
			Folder( subFolderText ).create();
			var historyState = app.activeDocument.activeHistoryState;
			app.activeDocument.flatten();
			if ( this.params.resize ) {
				var fi = FitImage( this.params ); 
				var ringColor = false;
				if ( this.params.captioned ) {
					app.foregroundColor = GetBorderColor( this.params.bordercolor, ringColor );
					CanvasSize( false, fi[0], fi[1], true, "Cntr", "Cntr" );
				} else {
					app.foregroundColor = GetBorderColor( this.params.bordercolor, ringColor );
					CanvasSize( false, fi[0], fi[1], true, "Cntr", "Top " );
				}
			}
			if ( this.params.unsharp ) {
				activeDocument.pathItems["Photo crop"].makeSelection();
				activeDocument.activeLayer.applyUnSharpMask( this.params.amount, this.params.radius, this.params.threshold );	
				app.activeDocument.selection.deselect();
			}
			var uniqueFileName = CreateUniqueFileName( subFolderText, fileNameNoPath, ".tif" );
			if ( this.params.makePDF && ! this.params.jpeg ) {
				gFilesForPDF.push( File( uniqueFileName ) );
			}
			SaveAsTIFF( uniqueFileName, this.params.icc, this.params.lzw );
			app.activeDocument.activeHistoryState = historyState;
		}
	}
		

	///////////////////////////////////////////////////////////////////////////////
	// Function: LoadParamsFromDisk
	// Usage: load my params from the xml file on disk if it exists
	//        this.params.myoptionname = myoptionvalue
	//        I wrote a very simple xml parser, I'm sure it needs work
	///////////////////////////////////////////////////////////////////////////////
	this.LoadParamsFromDisk = function( loadFile ) {
		if ( loadFile.exists ) {
			loadFile.open( "r" );
			var projectSpace = ReadHeader( loadFile );
			if ( projectSpace == GetScriptNameForXML() ) {
				while ( ! loadFile.eof ) {
					var starter = ReadHeader( loadFile );
					var data = ReadData( loadFile );
					var ender = ReadHeader( loadFile );
					if ( ( "/" + starter ) == ender ) {
						this.params[starter] = eval(data);
					}
				}
			}
			loadFile.close();
			if ( this.params.version != gVersion ) {
				// do something here to fix version conflicts
				// this should do it
				this.params.version = gVersion;
			}
		} 
	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: SaveParamsToDisk
	// Usage: save out my params, this is much easier
	///////////////////////////////////////////////////////////////////////////////
	this.SaveParamsToDisk = function( saveFile ) {
		saveFile.encoding = "UTF8";
		saveFile.open( "w", "TEXT", "????" );
		// unicode signature, this is UTF16 but will convert to UTF8 "EF BB BF"
		saveFile.write("\uFEFF"); 
		var scriptNameForXML = GetScriptNameForXML();
		saveFile.writeln( "<" + scriptNameForXML + ">" );
		var dataString;
		var props = this.params.reflect.properties;
		for ( var i = 0; i < props.length; i++ ) {
			var prop = props[i];
			if ( prop == "__proto__" || prop == "__count__" || prop == "__class__" || prop == "reflect" ) {
				continue;
			}

			var value = this.params[prop.name];
			
			if ( value == undefined ) {
				continue;
			}

			if ( typeof value == "object" ) {
				dataString = value.toSource();
			} else {
				if ( typeof value == "string" ) {
					dataString = '"' + value.toString().replace (/\\/g, '\\\\') + '"';
					// multiple with one ??? dataString = dataString.replace (/"/g, '\\"');
				} else {
					dataString = value.toString();
				}
			}
			
			saveFile.writeln( "\t<" + prop.name + ">" + dataString + "</" + prop.name + ">" );
		}
		saveFile.writeln( "</" + scriptNameForXML + ">" );
		saveFile.close();
	}


	///////////////////////////////////////////////////////////////////////////////
	// Function: CreateDialog
	// Usage: create the dialog
	///////////////////////////////////////////////////////////////////////////////
	this.CreateDialog = function() {
	
		// create the main dialog window, this holds all our data
		this.dlgMain = new Window( 'dialog', strTitle + " " + gVersion );

		// create a shortcut for easier typing
		var d = this.dlgMain;
		d.orientation = 'row';
		d.alignChildren = 'fill';
		
		// to keep everything as compatible as possible with Dr. Brown's Image Processor
		// I will keep most of the important dialog items at the same level
		// and use auto layout

		// some interesting numbers to help the auto layout
		var wAndhEtLength = 40;
		var wAndhStLength = 18;
		var qEtLength = 30;
		
		d.marginLeft = 15;

		// I use some hidden items to help auto layout
		// change this to see them
		var showHidden = false;
		
		d.grpLeft = d.add( 'group' );
		
		// create a shortcut for easier typing
		var l = d.grpLeft;
		
		l.orientation = 'column';
		l.alignChildren = 'fill';
		l.spacing = 5;
		
		///////////////////////////////////////////////////////////////////////
		// section 1
		///////////////////////////////////////////////////////////////////////

		l.grp1 = l.add( 'group' );
		l.grp1.orientation = 'row';
		l.grp1.alignChildren = 'center';

		d.icnOne = l.grp1.add( 'image', undefined, gIcnOne );
		d.icnOne.helpTip = strLabelSource;

		d.stSourceLabel = l.grp1.add( 'statictext', undefined, strLabelSource );
		d.stSourceLabel.helpTip = strLabelSource;

		l.grp1Info = l.add( 'group' );
		l.grp1Info.orientation = 'row';
		l.grp1Info.alignChildren = 'fill';
		l.grp1Info.margins = [d.marginLeft, 0, 0, 0];

		l.grp1Info.grpLeft = l.grp1Info.add( 'group' );
		l.grp1Info.grpLeft.orientation = 'row';
		l.grp1Info.grpLeft.alignChildren = 'fill';

		d.icnSource = l.grp1Info.grpLeft.add( 'image', undefined, 'SourceFolderIcon' );
		d.icnSource.helpTip = strLabelSource;

		l.grp1Info.grpRight = l.grp1Info.add( 'group' );
		l.grp1Info.grpRight.orientation = 'column';
		l.grp1Info.grpRight.alignChildren = 'left';

		if ( this.runningFromBridge ) {
			d.stBridge = l.grp1Info.grpRight.add( 'statictext', undefined, strBridge + " (" + this.filesFromBridge.length + ")" );
			d.stBridge.helpTip = strBridgeHelp;
		} else {
			d.rbUseOpen = l.grp1Info.grpRight.add( 'radiobutton', undefined, strUseOpen );
			d.rbUseOpen.helpTip = strUseOpenHelp;

			l.grpSelect = l.grp1Info.grpRight.add( 'group' );
			l.grpSelect.orientation = 'row';
			l.grpSelect.alignChildren = 'fill';

			d.rbUseFolder = l.grpSelect.add( 'radiobutton', undefined, '' );
			d.rbUseFolder.helpTip = strUseOpenHelp;
			
			d.btnSource = l.grpSelect.add( 'button', undefined, strButtonBrowse1 );
			d.btnSource.helpTip = strLabelSource;
			
			d.stSource = l.grpSelect.add( 'statictext', undefined, strNoImagesSelected );
			d.stSource.helpTip = strLabelSourceHelp;
		}

		d.line1 = l.add( 'panel', undefined, undefined, {borderStyle: 'sunken'} );
		
		///////////////////////////////////////////////////////////////////////
		// section 2
		///////////////////////////////////////////////////////////////////////

		l.grp2 = l.add( 'group' );
		l.grp2.orientation = 'row';
		l.grp2.alignChildren = 'center';

		d.icnTwo = l.grp2.add( 'image', undefined, gIcnTwo );
		d.icnTwo.helpTip = strLabelDestination;

		d.stDestination = l.grp2.add( 'statictext', undefined, strLabelDestination );
		d.stDestination.helpTip = strLabelDestination;

		l.grp2Info = l.add( 'group' );
		l.grp2Info.orientation = 'row';
		l.grp2Info.alignChildren = 'fill';
		l.grp2Info.margins = [d.marginLeft, 0, 0, 0];

		l.grp2Info.grpLeft = l.grp2Info.add( 'group' );
		l.grp2Info.grpLeft.orientation = 'row';
		l.grp2Info.grpLeft.alignChildren = 'left';

		d.icnDest = l.grp2Info.grpLeft.add( 'image', undefined, 'DestinationFolderIcon' );
		d.icnDest.helpTip = strLabelDestination;

		l.grp2Info.grpRight = l.grp2Info.add( 'group' );
		l.grp2Info.grpRight.orientation = 'column';
		l.grp2Info.grpRight.alignChildren = 'left';

		l.grp2Info.grpRight.grpSaveIn = l.grp2Info.grpRight.add( 'group' );
		l.grp2Info.grpRight.grpSaveIn.orientation = 'row';
		l.grp2Info.grpRight.grpSaveIn.alignChildren = 'center';

		d.rbSaveInSame = l.grp2Info.grpRight.grpSaveIn.add( 'radiobutton', undefined, strSaveInSameLocation + '     ' );
		d.rbSaveInSame.helpTip = strSaveInSameLocationHelp;

		d.cbMakePDF = l.grp2Info.grpRight.grpSaveIn.add( 'checkbox', undefined, strMakePDF );
		d.cbMakePDF.helpTip = strMakePDF;

		l.grpDestBrowse = l.grp2Info.grpRight.add( 'group' );
		l.grpDestBrowse.orientation = 'row';
		l.grpDestBrowse.alignChildren = 'center';

		d.rbSaveInNew = l.grpDestBrowse.add( 'radiobutton', undefined, '' );
		d.rbSaveInNew.helpTip = strLabelDestination;

		d.btnDest = l.grpDestBrowse.add( 'button', undefined, strButtonBrowse2 );
		d.btnDest.helpTip = strLabelDestination;
		
		d.stDest = l.grpDestBrowse.add( 'statictext', undefined, strNoFolderSelected );
		d.stDest.helpTip = strLabelDestination;

		d.line2 = l.add( 'panel', undefined, undefined, {borderStyle: 'sunken'} );
		
		///////////////////////////////////////////////////////////////////////
		// section 3
		///////////////////////////////////////////////////////////////////////

		l.grp3 = l.add( 'group' );
		l.grp3.orientation = 'row';
		l.grp3.alignChildren = 'top';
		
		l.grp3.grpLeft = l.grp3.add( 'group' );
		l.grp3.grpLeft.orientation = 'column';
		l.grp3.grpLeft.alignChildren = 'left';

		d.icnThree = l.grp3.grpLeft.add( 'image', undefined, gIcnThree );
		d.icnThree.helpTip = strBorderStyle;

		l.grp3.grpRight = l.grp3.add( 'group' );
		l.grp3.grpRight.orientation = 'column';
		l.grp3.grpRight.alignChildren = 'left';

		d.stBorderStyle = l.grp3.grpRight.add( 'statictext', undefined, strBorderStyle );
		d.stBorderStyle.helpTip = strBorderStyle;

		l.grp3Info = l.grp3.grpRight.add( 'group' );
		l.grp3Info.orientation = 'row';
		l.grp3Info.alignChildren = 'top';
		
		l.grp3Info.grpLeft = l.grp3Info.add( 'group' );
		l.grp3Info.grpLeft.orientation = 'column';
		l.grp3Info.grpLeft.alignChildren = 'left';

		l.grpCaptionOrPro = l.grp3Info.grpLeft.add( 'group' );
		l.grpCaptionOrPro.orientation = 'row';
		l.grpCaptionOrPro.alignChildren = 'center';

		d.rbCaption = l.grpCaptionOrPro.add( 'radiobutton' );
		d.rbCaption.text = strCaptionPrint;
		d.rbCaption.helpTip = strCaptionPrint;
		
		d.rbPro = l.grpCaptionOrPro.add( 'radiobutton' );
		d.rbPro.text = strProImageDelivery;
		d.rbPro.helpTip = strProImageDelivery;

		l.grpFont = l.grp3Info.grpLeft.add( 'group' );
		l.grpFont.orientation = 'row';
		l.grpFont.alignChildren = 'center';

		d.stFont = l.grpFont.add( 'statictext', undefined, strFont );
		d.stFont.helpTip = strFont;
		
		d.ddFont = l.grpFont.add( 'dropdownlist' );
		d.ddFont.helpTip = strFont;

		d.hidden4 = l.grpFont.add( 'dropdownlist' );
		d.hidden4.preferredSize.width = 1;
		d.hidden4.visible = showHidden;

		d.stFontSize = l.grpFont.add( 'statictext', undefined, strFontSize );
		d.stFontSize.helpTip = strFontSize;
		
		d.ddFontSize = l.grpFont.add( 'dropdownlist' );
		d.ddFontSize.helpTip = strFont;

		// extra to help with spacing and layout
		d.ddFontSizeh = l.grpFont.add( 'dropdownlist' );
		d.ddFontSizeh.visible = showHidden;

		l.grpBorderColor = l.grp3Info.grpLeft.add( 'group' );
		l.grpBorderColor.orientation = 'row';
		l.grpBorderColor.alignChildren = 'center';

		d.stBorderColor = l.grpBorderColor.add( 'statictext', undefined, strBorderColor );
		d.stBorderColor.helpTip = strBorderColor;

		d.ddBorderColor = l.grpBorderColor.add( 'dropdownlist' );
		d.ddBorderColor.helptTip = strBorderColor;

		l.grp3Info.grpRight = l.grp3Info.add( 'group', undefined, undefined, {borderStyle: 'none'}  );
		l.grp3Info.grpRight.orientation = 'stack';
		l.grp3Info.grpRight.alignChildren = 'left';

		d.previews = new Array();

		d.grpIcnCapLftCtrRtBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftCtrRtBK.tag = "CapLftCtrRtBK";
		d.icnCapLftCtrRtBK = d.grpIcnCapLftCtrRtBK.add( 'image', undefined, gIcnCapLftCtrRtBK );
		d.previews.push( d.grpIcnCapLftCtrRtBK );

		d.grpIcnCapLftCtrRtLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftCtrRtLG.tag = "CapLftCtrRtLG";
		d.icnCapLftCtrRtLG = d.grpIcnCapLftCtrRtLG.add( 'image', undefined, gIcnCapLftCtrRtLG );
		d.previews.push( d.grpIcnCapLftCtrRtLG );

		d.grpIcnCapLftCtrRtWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftCtrRtWh.tag = "CapLftCtrRtWh";
		d.icnCapLftCtrRtWh = d.grpIcnCapLftCtrRtWh.add( 'image', undefined, gIcnCapLftCtrRtWh );
		d.previews.push( d.grpIcnCapLftCtrRtWh );

		d.grpIcnCapLftCtrBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftCtrBK.tag = "CapLftCtrBK";
		d.icnCapLftCtrBK = d.grpIcnCapLftCtrBK.add( 'image', undefined, gIcnCapLftCtrBK );
		d.previews.push( d.grpIcnCapLftCtrBK );

		d.grpIcnCapLftCtrLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftCtrLG.tag = "CapLftCtrLG";
		d.icnCapLftCtrLG = d.grpIcnCapLftCtrLG.add( 'image', undefined, gIcnCapLftCtrLG );
		d.previews.push( d.grpIcnCapLftCtrLG );

		d.grpIcnCapLftCtrWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftCtrWh.tag = "CapLftCtrWh";
		d.icnCapLftCtrWh = d.grpIcnCapLftCtrWh.add( 'image', undefined, gIcnCapLftCtrWh );
		d.previews.push( d.grpIcnCapLftCtrWh );

		d.grpIcnCapLftBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftBK.tag = "CapLftBK";
		d.icnCapLftBK = d.grpIcnCapLftBK.add( 'image', undefined, gIcnCapLftBK );
		d.previews.push( d.grpIcnCapLftBK );

		d.grpIcnCapLftLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftLG.tag = "CapLftLG";
		d.icnCapLftLG = d.grpIcnCapLftLG.add( 'image', undefined, gIcnCapLftLG );
		d.previews.push( d.grpIcnCapLftLG );

		d.grpIcnCapLftWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftWh.tag = "CapLftWh";
		d.icnCapLftWh = d.grpIcnCapLftWh.add( 'image', undefined, gIcnCapLftWh );
		d.previews.push( d.grpIcnCapLftWh );

		d.grpIcnCapCtrRtBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapCtrRtBK.tag = "CapCtrRtBK";
		d.icnCapCtrRtBK = d.grpIcnCapCtrRtBK.add( 'image', undefined, gIcnCapCtrRtBK );
		d.previews.push( d.grpIcnCapCtrRtBK );

		d.grpIcnCapCtrRtLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapCtrRtLG.tag = "CapCtrRtLG";
		d.icnCapCtrRtLG = d.grpIcnCapCtrRtLG.add( 'image', undefined, gIcnCapCtrRtLG );
		d.previews.push( d.grpIcnCapCtrRtLG );

		d.grpIcnCapCtrRtWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapCtrRtWh.tag = "CapCtrRtWh";
		d.icnCapCtrRtWh = d.grpIcnCapCtrRtWh.add( 'image', undefined, gIcnCapCtrRtWh );
		d.previews.push( d.grpIcnCapCtrRtWh );

		d.grpIcnCapCtrBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapCtrBK.tag = "CapCtrBK";
		d.icnCapCtrBK = d.grpIcnCapCtrBK.add( 'image', undefined, gIcnCapCtrBK );
		d.previews.push( d.grpIcnCapCtrBK );

		d.grpIcnCapCtrLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapCtrLG.tag = "CapCtrLG";
		d.icnCapCtrLG = d.grpIcnCapCtrLG.add( 'image', undefined, gIcnCapCtrLG );
		d.previews.push( d.grpIcnCapCtrLG );

		d.grpIcnCapCtrWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapCtrWh.tag = "CapCtrWh";
		d.icnCapCtrWh = d.grpIcnCapCtrWh.add( 'image', undefined, gIcnCapCtrWh );
		d.previews.push( d.grpIcnCapCtrWh );

		d.grpIcnCapRtBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapRtBK.tag = "CapRtBK";
		d.icnCapRtBK = d.grpIcnCapRtBK.add( 'image', undefined, gIcnCapRtBK );
		d.previews.push( d.grpIcnCapRtBK );

		d.grpIcnCapRtLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapRtLG.tag = "CapRtLG";
		d.icnCapRtLG = d.grpIcnCapRtLG.add( 'image', undefined, gIcnCapRtLG );
		d.previews.push( d.grpIcnCapRtLG );

		d.grpIcnCapRtWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapRtWh.tag = "CapRtWh";
		d.icnCapRtWh = d.grpIcnCapRtWh.add( 'image', undefined, gIcnCapRtWh );
		d.previews.push( d.grpIcnCapRtWh );

		d.grpIcnCapLftRtBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftRtBK.tag = "CapLftRtBK";
		d.icnCapLftRtBK = d.grpIcnCapLftRtBK.add( 'image', undefined, gIcnCapLftRtBK );
		d.previews.push( d.grpIcnCapLftRtBK );

		d.grpIcnCapLftRtLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftRtLG.tag = "CapLftRtLG";
		d.icnCapLftRtLG = d.grpIcnCapLftRtLG.add( 'image', undefined, gIcnCapLftRtLG );
		d.previews.push( d.grpIcnCapLftRtLG );

		d.grpIcnCapLftRtWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapLftRtWh.tag = "CapLftRtWh";
		d.icnCapLftRtWh = d.grpIcnCapLftRtWh.add( 'image', undefined, gIcnCapLftRtWh );
		d.previews.push( d.grpIcnCapLftRtWh );

		d.grpIcnCapNoneBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapNoneBK.tag = "CapNoneBK";
		d.icnCapNoneBK = d.grpIcnCapNoneBK.add( 'image', undefined, gIcnCapNoneBK );
		d.previews.push( d.grpIcnCapNoneBK );

		d.grpIcnCapNoneLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapNoneLG.tag = "CapNoneLG";
		d.icnCapNoneLG = d.grpIcnCapNoneLG.add( 'image', undefined, gIcnCapNoneLG );
		d.previews.push( d.grpIcnCapNoneLG );

		d.grpIcnCapNoneWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnCapNoneWh.tag = "CapNoneWh";
		d.icnCapNoneWh = d.grpIcnCapNoneWh.add( 'image', undefined, gIcnCapNoneWh );
		d.previews.push( d.grpIcnCapNoneWh );

		d.grpIcnProBK = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnProBK.tag = "ProBK";
		d.icnProBK = d.grpIcnProBK.add( 'image', undefined, gIcnProBK );
		d.previews.push( d.grpIcnProBK );

		d.grpIcnProLG = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnProLG.tag = "ProLG";
		d.icnProLG = d.grpIcnProLG.add( 'image', undefined, gIcnProLG );
		d.previews.push( d.grpIcnProLG );

		d.grpIcnProWh = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnProWh.tag = "ProWh";
		d.icnProWh = d.grpIcnProWh.add( 'image', undefined, gIcnProWh );
		d.previews.push( d.grpIcnProWh );

		d.grpIcnProF = l.grp3Info.grpRight.add( 'group' );
		d.grpIcnProF.tag = "ProF";
		d.icnProF = d.grpIcnProF.add( 'image', undefined, gIcnCapNoneF );
		d.previews.push( d.grpIcnProF );

		d.line3 = l.add( 'panel', undefined, undefined, {borderStyle: 'sunken'} );

		///////////////////////////////////////////////////////////////////////
		// section 4
		///////////////////////////////////////////////////////////////////////

		l.grp4 = l.add( 'group' );
		l.grp4.orientation = 'row';
		l.grp4.alignChildren = 'top';
		
		l.grp4.grpLeft = l.grp4.add( 'group' );
		l.grp4.grpLeft.orientation = 'column';
		l.grp4.grpLeft.alignChildren = 'left';

		d.icnFour = l.grp4.grpLeft.add( 'image', undefined, gIcnFour );
		d.icnFour.helpTip = strSelectMetadata;

		l.grp4.grpRight = l.grp4.add( 'group' );
		l.grp4.grpRight.orientation = 'column';
		l.grp4.grpRight.alignChildren = 'left';

		d.stBorderStyle = l.grp4.grpRight.add( 'statictext', undefined, strSelectMetadata );
		d.stBorderStyle.helpTip = strSelectMetadata;

		l.grp4Info = l.grp4.grpRight.add( 'group' );
		l.grp4Info.orientation = 'row';
		l.grp4Info.alignChildren = 'top';
		
		l.grp4Info.grpLeft = l.grp4Info.add( 'group' );
		l.grp4Info.grpLeft.orientation = 'column';
		l.grp4Info.grpLeft.alignChildren = 'left';

		l.grpLine1 = l.grp4Info.grpLeft.add( 'group' );
		l.grpLine1.orientation = 'row';
		l.grpLine1.alignChildren = 'center';
		l.grpLine1.spacing = 1;

		// the extra hidden drop down gives us spacing
		
		d.metaCBs = [];
		d.metaDDs = [];

		d.cbM1 = l.grpLine1.add( 'checkbox', undefined, '' );
		d.ddM1 = l.grpLine1.add( 'dropdownlist' );
		d.ddM1.tag = "1";

		d.metaCBs.push( d.cbM1 );
		d.metaDDs.push( d.ddM1 );

		d.ddM1h = l.grpLine1.add( 'dropdownlist' );
		d.ddM1h.visible = showHidden;

		d.cbM2 = l.grpLine1.add( 'checkbox', undefined, '' );
		d.ddM2 = l.grpLine1.add( 'dropdownlist' );
		d.ddM2.tag = "2";

		d.metaCBs.push( d.cbM2 );
		d.metaDDs.push( d.ddM2 );

		d.ddM2h = l.grpLine1.add( 'dropdownlist' );
		d.ddM2h.visible = showHidden;

		d.cbM3 = l.grpLine1.add( 'checkbox', undefined, '' );
		d.ddM3 = l.grpLine1.add( 'dropdownlist' );
		d.ddM3.tag = "3";

		d.metaCBs.push( d.cbM3 );
		d.metaDDs.push( d.ddM3 );

		l.grpLine2 = l.grp4Info.grpLeft.add( 'group' );
		l.grpLine2.orientation = 'row';
		l.grpLine2.alignChildren = 'center';
		l.grpLine2.spacing = 1;

		d.cbM4 = l.grpLine2.add( 'checkbox', undefined, '' );
		d.ddM4 = l.grpLine2.add( 'dropdownlist' );
		d.ddM4.tag = "4";

		d.metaCBs.push( d.cbM4 );
		d.metaDDs.push( d.ddM4 );

		d.ddM4h = l.grpLine2.add( 'dropdownlist' );
		d.ddM4h.visible = showHidden;

		d.cbM5 = l.grpLine2.add( 'checkbox', undefined, '' );
		d.ddM5 = l.grpLine2.add( 'dropdownlist' );
		d.ddM5.tag = "5";

		d.metaCBs.push( d.cbM5 );
		d.metaDDs.push( d.ddM5 );

		d.ddM5h = l.grpLine2.add( 'dropdownlist' );
		d.ddM5h.visible = showHidden;

		d.cbM6 = l.grpLine2.add( 'checkbox', undefined, '' );
		d.ddM6 = l.grpLine2.add( 'dropdownlist' );
		d.ddM6.tag = "6";

		d.metaCBs.push( d.cbM6 );
		d.metaDDs.push( d.ddM6 );

		l.grpLine3 = l.grp4Info.grpLeft.add( 'group' );
		l.grpLine3.orientation = 'row';
		l.grpLine3.alignChildren = 'center';
		l.grpLine3.spacing = 1;

		d.cbM7 = l.grpLine3.add( 'checkbox', undefined, '' );
		d.ddM7 = l.grpLine3.add( 'dropdownlist' );
		d.ddM7.tag = "7";

		d.metaCBs.push( d.cbM7 );
		d.metaDDs.push( d.ddM7 );

		d.ddM7h = l.grpLine3.add( 'dropdownlist' );
		d.ddM7h.visible = showHidden;

		d.cbM8 = l.grpLine3.add( 'checkbox', undefined, '' );
		d.ddM8 = l.grpLine3.add( 'dropdownlist' );
		d.ddM8.tag = "8";

		d.metaCBs.push( d.cbM8 );
		d.metaDDs.push( d.ddM8 );

		d.ddM8h = l.grpLine3.add( 'dropdownlist' );
		d.ddM8h.visible = showHidden;

		d.cbM9 = l.grpLine3.add( 'checkbox', undefined, '' );
		d.ddM9 = l.grpLine3.add( 'dropdownlist' );
		d.ddM9.tag = "9";

		d.metaCBs.push( d.cbM9 );
		d.metaDDs.push( d.ddM9 );

		d.line4 = l.add( 'panel', undefined, undefined, {borderStyle: 'sunken'} );

		///////////////////////////////////////////////////////////////////////
		// section 5
		///////////////////////////////////////////////////////////////////////
		
		l.grp5 = l.add( 'group' );
		l.grp5.orientation = 'row';
		l.grp5.alignChildren = 'center';

		d.icnFive = l.grp5.add( 'image', undefined, gIcnFive );
		d.icnFive.helpTip = strFileType;

		d.stFileType = l.grp5.add( 'statictext', undefined, strFileType );
		d.stFileType.helpTip = strFileType;

		l.grp5Info = l.add( 'group' );
		l.grp5Info.orientation = 'row';
		l.grp5Info.alignChildren = 'fill';
		l.grp5Info.margins = [d.marginLeft, 0, 0, 0];

		l.grp5Info.grpLeft = l.grp5Info.add( 'group' );
		l.grp5Info.grpLeft.orientation = 'column';
		l.grp5Info.grpLeft.alignChildren = 'left';

		d.icnSpace = l.grp5Info.grpLeft.add( 'image', undefined, 'DestinationFolderIcon' );
		d.icnSpace.helpTip = strLabelDestination;
		d.icnSpace.visible = showHidden;

		l.grp5Info.grpRight = l.grp5Info.add( 'group' );
		l.grp5Info.grpRight.orientation = 'column';
		l.grp5Info.grpRight.alignChildren = 'left';

		d.grpFileType = l.grp5Info.grpRight.add( 'group', undefined, strFileType );
		
		// more shortcuts
		var p = d.grpFileType;
		
		p.orientation = 'column';
		p.alignChildren = 'fill';
		
		p.grpJPEG = p.add( 'group' );
		p.grpJPEG.orientation = 'row';
		p.grpJPEG.alignChildren = 'fill';

		p.grpJPEG.grpLeft = p.grpJPEG.add( 'group' );
		p.grpJPEG.grpLeft.orientation = 'column';
		p.grpJPEG.grpLeft.alignChildren = 'fill';

		d.cbJPEG = p.grpJPEG.grpLeft.add( 'checkbox', undefined, strSaveAsJPEG );
		d.cbJPEG.helpTip = strSaveAsJPEGHelp;

		p.grpJPEG.grpLeft.grpJPEG = p.grpJPEG.grpLeft.add( 'group' );
		p.grpJPEG.grpLeft.grpJPEG.orientation = 'column';
		p.grpJPEG.grpLeft.grpJPEG.alignChildren = 'left';
		p.grpJPEG.grpLeft.grpJPEG.margins = [d.marginLeft, 0, 0, 0];

		p.grpJPEG.grpLeft.grpQ = p.grpJPEG.grpLeft.grpJPEG.add( 'group' );
		p.grpJPEG.grpLeft.grpQ.orientation = 'row';
		p.grpJPEG.grpLeft.grpQ.alignChildren = 'center';

		d.stQuality = p.grpJPEG.grpLeft.grpQ.add( 'statictext', undefined, strQuality );
		d.etQuality = p.grpJPEG.grpLeft.grpQ.add( 'edittext' );
		d.etQuality.preferredSize.width = qEtLength;
		
		p.grpJPEG.grpLeft.grpJPEG.grpICC = p.grpJPEG.grpLeft.grpJPEG.add( 'group' );
		p.grpJPEG.grpLeft.grpJPEG.grpICC.orientation = 'row';
		p.grpJPEG.grpLeft.grpJPEG.grpICC.alignChildren = 'center';
		
		d.cbConvertICC = p.grpJPEG.grpLeft.grpJPEG.grpICC.add( 'checkbox', undefined, strConvertICC );
		d.cbConvertICC.helpTip = strConvertICCHelp;
		
		d.hidden1 = p.grpJPEG.grpLeft.grpJPEG.grpICC.add( 'edittext' );
		d.hidden1.preferredSize.width = 1;
		d.hidden1.visible = showHidden;

		p.grpJPEG.grpRight = p.grpJPEG.add( 'group' );
		p.grpJPEG.grpRight.orientation = 'column';
		p.grpJPEG.grpRight.alignChildren = 'left';
		
		// the right side for caption maker is the 'save as TIFF stuff
		// all these need renamed once the layout is correct

		p.grpTIFF = p.grpJPEG.grpRight.add( 'group' );
		p.grpTIFF.orientation = 'row';
		p.grpTIFF.alignChildren = 'fill';

		p.grpTIFF.grpLeft = p.grpTIFF.add( 'group' );
		p.grpTIFF.grpLeft.orientation = 'column';
		p.grpTIFF.grpLeft.alignChildren = 'fill';

		d.cbTIFF = p.grpTIFF.grpLeft.add( 'checkbox', undefined, strSaveAsTIFF );
		d.cbTIFF.helpTip = strSaveAsTIFFHelp
		
		p.grpTIFF.grpLeft.grpTIFF = p.grpTIFF.grpLeft.add( 'group' );
		p.grpTIFF.grpLeft.grpTIFF.orientation = 'column';
		p.grpTIFF.grpLeft.grpTIFF.alignChildren = 'left';
		p.grpTIFF.grpLeft.grpTIFF.margins = [d.marginLeft, 0, 0, 0];

		p.grpTIFF.grpLeft.grpTIFF.grpLZW = p.grpTIFF.grpLeft.grpTIFF.add( 'group' );
		p.grpTIFF.grpLeft.grpTIFF.grpLZW.orientation = 'row';
		p.grpTIFF.grpLeft.grpTIFF.grpLZW.alignChildren = 'center';

		d.cbTIFFLZW = p.grpTIFF.grpLeft.grpTIFF.grpLZW.add( 'checkbox', undefined, strLZW );
		d.cbTIFFLZW.helpTip = strLZWHelp;
		
		d.line5 = p.add( 'panel', undefined, undefined, {borderStyle: 'sunken'} );
		d.line5.alignment = 'fill';
		
		p.grpResize = p.add( 'group' );
		p.grpResize.orientation = 'row';
		p.grpResize.alignChildren = 'fill';

		p.grpResize.grpLeft = p.grpResize.add( 'group' );
		p.grpResize.grpLeft.orientation = 'column';
		p.grpResize.grpLeft.alignChildren = 'fill';

		d.cbResize = p.grpResize.grpLeft.add( 'checkbox', undefined, strResizeToFit1 );
		d.cbResize.helpTip = strResizeToFitHelp;

		p.grpResize.grpRight = p.grpResize.add( 'group' );
		p.grpResize.grpRight.orientation = 'row';
		p.grpResize.grpRight.alignChildren = 'fill';

		p.grpResize.grpRight.grpLeft = p.grpResize.grpRight.add( 'group' );
		p.grpResize.grpRight.grpLeft.orientation = 'column';
		p.grpResize.grpRight.grpLeft.alignChildren = 'fill';
		p.grpResize.grpRight.grpLeft.spacing = 1;

		d.rbPX1 = p.grpResize.grpRight.grpLeft.add( 'radiobutton', undefined, str640px );
		d.rbPX2 = p.grpResize.grpRight.grpLeft.add( 'radiobutton', undefined, str1024px );

		p.grpResize.grpRight.grpRight = p.grpResize.grpRight.add( 'group' );
		p.grpResize.grpRight.grpRight.orientation = 'column';
		p.grpResize.grpRight.grpRight.alignChildren = 'fill';
		p.grpResize.grpRight.grpRight.spacing = 1;

		d.rbPX3 = p.grpResize.grpRight.grpRight.add( 'radiobutton', undefined, str1800px );
		d.rbPX4 = p.grpResize.grpRight.grpRight.add( 'radiobutton', undefined, str3000px );

		d.line6 = p.add( 'panel', undefined, undefined, {borderStyle: 'sunken'} );
		d.line6.alignment = 'fill';
		
		d.cbUnsharpMask = p.add( 'checkbox', undefined, "Unsharp Mask settings" );
		d.cbUnsharpMask.helpTip = "Unsharp Mask settings";

		d.grpUnsharpMask = p.add( 'group' );
		d.grpUnsharpMask.orientation = 'row';
		d.grpUnsharpMask.alignChildren = 'fill';
		d.grpUnsharpMask.alignment = 'fill';
		d.grpUnsharpMask.spacing = 1;
		
		d.stH2 = d.grpUnsharpMask.add( 'statictext', undefined, ' ' );
		d.stH2.visible = showHidden;
		
		d.stAmount = d.grpUnsharpMask.add( 'statictext', undefined, 'Amount: ' );
		d.etAmount = d.grpUnsharpMask.add( 'edittext' );
		d.etAmount.preferredSize.width = qEtLength;
		d.stAmountH = d.grpUnsharpMask.add( 'statictext', undefined, '    ' );
		d.stAmountH.visible = showHidden;
		d.stRadius = d.grpUnsharpMask.add( 'statictext', undefined, 'Radius: ' );
		d.etRadius = d.grpUnsharpMask.add( 'edittext' );
		d.etRadius.preferredSize.width = qEtLength;
		d.stRadiusH = d.grpUnsharpMask.add( 'statictext', undefined, '    ' );
		d.stRadiusH.visible = showHidden;
		d.stThreshold = d.grpUnsharpMask.add( 'statictext', undefined, 'Threshold: ' );
		d.etThreshold = d.grpUnsharpMask.add( 'edittext' );
		d.etThreshold.preferredSize.width = qEtLength;

		// buttons on the right side of the dialog
		
		d.grpRight = d.add( 'group' );
		d.grpRight.orientation = 'column';
		d.grpRight.alignChildren = 'fill';
		d.grpRight.alignment = 'fill';

		d.btnRun = d.grpRight.add( 'button', undefined, strButtonRun );
		d.btnCancel = d.grpRight.add( 'button', undefined, strButtonCancel );
		d.stFake = d.grpRight.add( 'statictext', undefined, '' );
		d.btnLoad = d.grpRight.add( 'button', undefined, strButtonLoad );
		d.btnLoad.helpTip = strButtonLoadHelp;
		d.btnSave = d.grpRight.add( 'button', undefined, strButtonSave );
		d.btnSave.helpTip = strButtonSaveHelp;

		d.defaultElement = d.btnRun;
		d.cancelElement = d.btnCancel;
	}


	///////////////////////////////////////////////////////////////////////////
	// Function: ConfigForBridge
	// Usage: see if the Bridge app is running this script
	// Input: gFilesFromBridge is a variable that is defined in photoshop.jsx
	// Return: runningFromBridge and filesFromBridge are initialized
	///////////////////////////////////////////////////////////////////////////
	this.ConfigForBridge = function() {
		try {
			this.filesFromBridge = gFilesFromBridge;
			if ( this.filesFromBridge.length > 0 ) {
				this.runningFromBridge = true;
			} else {
				this.runningFromBridge = false;
			}
		}
		catch( e ) { 
			this.runningFromBridge = false;
			this.filesFromBridge = undefined;
		}
	}


	this.firstTimeLoad = true;
	this.params = this.InitParams();
	this.ConfigForBridge();

}


/////////////////////////////////////////////////////////////////////
// Function: SaveAsJPEG
// Usage: Save the file in the JPEG format
/////////////////////////////////////////////////////////////////////
function SaveAsJPEG( inFileName, inQuality, inEmbedICC ) {
	var jpegOptions = new JPEGSaveOptions();
	jpegOptions.quality = inQuality;
	jpegOptions.embedColorProfile = inEmbedICC;
	app.activeDocument.saveAs( File( inFileName ), jpegOptions );
}

	
/////////////////////////////////////////////////////////////////////
// Function: SaveAsTIFF
// Usage: Save the file in the TIFF format
/////////////////////////////////////////////////////////////////////
function SaveAsTIFF( inFileName, inEmbedICC, inLZW ) {
	var tiffSaveOptions = new TiffSaveOptions();
    tiffSaveOptions.embedColorProfile = inEmbedICC;
    if ( inLZW ) {
		tiffSaveOptions.imageCompression = TIFFEncoding.TIFFLZW;
	} else {
		tiffSaveOptions.imageCompression = TIFFEncoding.NONE;
	}	
	app.activeDocument.saveAs( File( inFileName ), tiffSaveOptions );
}


/////////////////////////////////////////////////////////////////////
// Function: ReadHeader
// Usage: a very crude xml parser
//        this reads the "Tag" of the <Tag>Data</Tag>
/////////////////////////////////////////////////////////////////////
function ReadHeader( inFile ) {
	var returnValue = "";
	if ( ! inFile.eof ) {
		var c = "";
		while ( c != "<" && ! inFile.eof ) {
			c = inFile.read( 1 );
		}
		while ( c != ">" && ! inFile.eof ) {
			c = inFile.read( 1 );
			if ( c != ">" ) {
				returnValue += c;
			}
		}
	} else {
		returnValue = "end of file";
	}
	return returnValue;
}


/////////////////////////////////////////////////////////////////////
// Function: ReadData
// Usage: very crude xml parser
//        this reads the "Data" of the <Tag>Data</Tag>
/////////////////////////////////////////////////////////////////////
function ReadData( inFile ) {
	var returnValue = "";
	if ( ! inFile.eof ) {
		var c = "";
		while ( c != "<" && ! inFile.eof ) {
			c = inFile.read( 1 );
			if ( c != "<" ) {
				returnValue += c;
			}
		}
		inFile.seek( -1, 1 );
	}
	return returnValue;
}


/////////////////////////////////////////////////////////////////////
// Function: CheckVersion
// Usage: This script only works for CS2
/////////////////////////////////////////////////////////////////////
function CheckVersion() {
	var numberArray = version.split(".");
	if ( numberArray[0] < 9 ) {
		alert( strMustUse );
		throw( strMustUse );
	}
}


/////////////////////////////////////////////////////////////////////
// Function: CreateUniqueFileName
// Usage: Remove all the crap characters that some OS(s) don't like
//        and then make sure it is unique
/////////////////////////////////////////////////////////////////////
function CreateUniqueFileName( inFolder, inFileName, inExtension ) {
	inFileName = inFileName.replace(/[:\/\\*\?\"\<\>\|]/g, "_");  // '/\:*?"<>|' -> '_'
	var uniqueFileName = inFolder + inFileName + inExtension;
	var fileNumber = 1;
	while ( File( uniqueFileName ).exists ) {
		uniqueFileName = inFolder + inFileName + "_" + fileNumber + inExtension;
		fileNumber++;
	}
	return uniqueFileName;
}


/////////////////////////////////////////////////////////////////////
// Function: CreateShortFileName
// Input: If the characters are too long, remove some
//        I should to "Start...End" instead of removing from start
/////////////////////////////////////////////////////////////////////
function CreateShortFileName( inFileName ) {
	if ( inFileName.length > gShortFileNameLength ) {
		return "..." + inFileName.substr( inFileName.length - gShortFileNameLength + 3, gShortFileNameLength - 3 );
	}
	return inFileName;
}


/////////////////////////////////////////////////////////////////////
// Function: IsWindowsOS
// Input: Check the OS version
/////////////////////////////////////////////////////////////////////
function IsWindowsOS() {
	if ( $.os.search(/windows/i) != -1 ) {
		return true;
	} else {
		return false;
	}
}


/////////////////////////////////////////////////////////////////////
// Function: RemoveAlphaChannels
// Input: As the name says, remove all the alpha channels
//        Move up from the bottom so the index is good
/////////////////////////////////////////////////////////////////////
function RemoveAlphaChannels() {
	var channels = app.activeDocument.channels;
	var channelCount = channels.length - 1;
	while ( channels[channelCount].kind != ChannelType.COMPONENT ) {
		channels[channelCount].remove();
		channelCount--;
	}
}


/////////////////////////////////////////////////////////////////////
// Function: GetScriptNameForXML
// Input: Remove characters for the XML name
/////////////////////////////////////////////////////////////////////
function GetScriptNameForXML () {
	var scriptNameForXML = new String( strTitle );
	var charsToStrip = Array( " ", "'", "." );
	for (var a = 0; a < charsToStrip.length; a++ )  {
		var nameArray = scriptNameForXML.split( charsToStrip[a] );
		scriptNameForXML = "";
		for ( var b = 0; b < nameArray.length; b++ ) {
			scriptNameForXML += nameArray[b];
		}
	}
	return scriptNameForXML;
}


/////////////////////////////////////////////////////////////////////
// Function: MacXMLFilter
// Input: f, file or folder to check
// Return: true or false, true if file or folder is to be displayed
/////////////////////////////////////////////////////////////////////
function MacXMLFilter( f ) {
	var xmlExtension = ".xml";
	var lCaseName = f.name;
	lCaseName.toLowerCase();
	if ( lCaseName.indexOf( xmlExtension ) == f.name.length - xmlExtension.length )
		return true;
	else if ( f.type == 'TEXT' )
		return true;
	else if ( f instanceof Folder )
		return true;
	else
		return false;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetDefaultParamsFile
// Usage: Give me the full path to my params file
///////////////////////////////////////////////////////////////////////////////
function GetDefaultParamsFile() {
	return ( new File( app.preferencesFolder + "/" + strTitle + ".xml" ) );
}


///////////////////////////////////////////////////////////////////////////////
// Function: FindDialog
// Usage: Move up the parent chain until you find the dialog
//        Maybe i should just make the main dialog a global somewhere
//        as i call this _ALL_ the time
///////////////////////////////////////////////////////////////////////////////
function FindDialog( inItem ) {
	var w = inItem;
	while ( 'dialog' != w.type ) {
		if ( undefined == w.parent ) {
			w = null;
			break;
		}
		w = w.parent;
	}
	return w;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetFilesFromBridge
// Usage: Use the BridgeTalk interface to grab the current selection
// NOTE: This code has been tested but is not in use in this script
///////////////////////////////////////////////////////////////////////////////
function GetFilesFromBridge() {
	var fileList;
	if ( BridgeTalk.isRunning( "bridge" ) ) {
		var bt = new BridgeTalk();
		bt.target = "bridge";
		bt.body = "var theFiles = photoshop.getBridgeFileListForAutomateCommand();theFiles.toSource();";
		bt.onResult = function( inBT ) { fileList = eval( inBT.body ); }
		bt.onError = function( inBT ) { fileList = new Array(); }
		bt.send();
		bt.pump();
		$.sleep( 100 );
		var timeOutAt = ( new Date() ).getTime() + 5000;
		var currentTime = ( new Date() ).getTime();
		while ( ( currentTime < timeOutAt ) && ( undefined == fileList ) ) {
			bt.pump();
			$.sleep( 100 );
			currentTime = ( new Date() ).getTime();
		}
	}
	if ( undefined == fileList ) {
		fileList = new Array();
	}
	return fileList; 
}


///////////////////////////////////////////////////////////////////////////////
// Function: OpenDocs
// Usage: we want the current open documents that have a path. If I do 
//        inputFiles = documents then I have a reference and if I add documents
//        it also adds them to my inputFiles. I want to copy the current state
///////////////////////////////////////////////////////////////////////////////
function OpenDocs() {
	var docs = new Array();
	var i = 0;
	var docIndex = 0;
	var alertNonSavedDocs = false;
	var nonSavedDocs = new Array();
	for ( var i = 0; i < app.documents.length; i++ ) {
		try {
			var temp = app.documents[ i ].fullName;
			docs[ docIndex ] = app.documents[ i ];
			docIndex++;
		}
		catch( e ) {
			if ( e.number == 8103 ) { // this document has not been saved
				alertNonSavedDocs = true;
				nonSavedDocs.push( app.documents[ i ].name );
			} else {
				throw e;
			}
		}
	}
	if ( alertNonSavedDocs ) {
		alert( strMustSaveOpen + "\r" + strFollowing + "\r( " + nonSavedDocs + " )" );
	}
	return docs;
}


///////////////////////////////////////////////////////////////////////////////
// Function: CaptionPrint
// Usage: Create the caption print output with the given parameters
///////////////////////////////////////////////////////////////////////////////
function CaptionPrint( p ) {
	var ringColor = false;
	app.foregroundColor = GetBorderColor( p.bordercolor, ringColor );
	var originalWidth = app.activeDocument.width.value;
	var originalHeight = app.activeDocument.height.value;
	var right = app.activeDocument.width.value;
	var top = app.activeDocument.height.value;
	var useAdjuster = right;
	if ( top > right ) {
		useAdjuster = top;
	}
	var pixelBorder = parseInt( useAdjuster * gBorderPercentageCaption );
	var relative = true;
	var pixels = true;
	CanvasSize( relative, pixelBorder, pixelBorder, pixels, 'Cntr', 'Cntr' );
	var bottom = app.activeDocument.height.value;
	var increaseHeight = parseInt( ( app.activeDocument.height.value - originalHeight ) / 2 );
	top += increaseHeight;
	top += Math.round( originalHeight * 0.0061 ); // 10 px on a 1632 height doc; // this should be a percentage
	var increaseWidth = parseInt( ( app.activeDocument.width.value - originalWidth ) / 2 );
	var left = increaseWidth;
	var right = app.activeDocument.width.value - increaseWidth;
	var fontSize = parseInt( ( bottom - top ) / 1.5 );
	fontSize *= GetFontSize( p.fontsize, p.captioned );
	fontSize = Math.min( fontSize, gMaxFontSize );
	fontSize = Math.max( fontSize, gMinFontSize );
	// these are out of order to make the alignment correct
	// if the center one and one other is selected we need an extra box
	// so the center comes out correct
	var numBoxes = 0;
	if ( p.checkbox[0] ) {
		numBoxes++;
	}
	if ( p.checkbox[2] ) {
		numBoxes++;
	}
	if ( p.checkbox[1] ) {
		numBoxes++;
		if ( 2 == numBoxes ) {
			numBoxes++;
		}
	}
	var boxWidth = parseInt( ( right - left ) / numBoxes );
	var l = left;
	var r = left + boxWidth;
	if ( p.checkbox[0] ) {
		if ( p.custom[0] ) {
			var itemText = p.meta[0];
		} else {
			var itemText = GetMetaData( p.meta[0] );
		}
		MakeTextBox( itemText, l, top, r, bottom, p.font, fontSize, gAlignLeft, 
			         app.activeDocument.width.value, app.activeDocument.height.value, 
					 app.activeDocument.resolution, GetTextColor( p.bordercolor )  );
		MakeSelection( left, top, right, bottom );
		AlignEdges( gAlignTopEdges );
		AlignEdges( gAlignLeftEdges );
	}
	if ( p.checkbox[1] ) {
		if ( p.custom[1] ) {
			var itemText = p.meta[1];
		} else {
			var itemText = GetMetaData( p.meta[1] );
		}
		MakeTextBox( itemText, l, top, r, bottom, p.font, fontSize, gAlignCenter, 
			         app.activeDocument.width.value, app.activeDocument.height.value, 
					 app.activeDocument.resolution, GetTextColor( p.bordercolor ) );
		MakeSelection( left, top, right, bottom );
		AlignEdges( gAlignTopEdges );
		AlignEdges( gAlignHorizontalCenters );
	}
	if ( p.checkbox[2] ) {
		if ( p.custom[2] ) {
			var itemText = p.meta[2];
		} else {
			var itemText = GetMetaData( p.meta[2] );
		}
		MakeTextBox( itemText, l, top, r, bottom, p.font, fontSize, gAlignRight, 
			         app.activeDocument.width.value, app.activeDocument.height.value, 
					 app.activeDocument.resolution, GetTextColor( p.bordercolor ) );
		MakeSelection( left, top, right, bottom );
		AlignEdges( gAlignTopEdges );
		AlignEdges( gAlignRightEdges );
	}
	app.activeDocument.selection.deselect();
}


///////////////////////////////////////////////////////////////////////////////
// Function: ProPrint
// Usage: Create the pro print output with the given parameters
///////////////////////////////////////////////////////////////////////////////
function ProPrint( p ) {
	var ringColor = true;
	app.foregroundColor = GetBorderColor( p.bordercolor, ringColor );
	var originalWidth = app.activeDocument.width.value;
	var originalHeight = app.activeDocument.height.value;
	var top = app.activeDocument.height.value;
	var bottom = app.activeDocument.height.value;
	var useAdjuster = top;
	if ( bottom > top ) {
		useAdjuster = bottom;
	}
	var pixelBorder = parseInt( useAdjuster * 0.02 );
	var relative = true;
	var pixels = true;
	CanvasSize( relative, pixelBorder, pixelBorder, pixels, 'Cntr', 'Cntr' );
	ringColor = false;
	app.foregroundColor = GetBorderColor( p.bordercolor, ringColor );
	var top = app.activeDocument.height.value;
	top += Math.round( originalHeight * 0.011 ); // 18 px on a 1632 hght doc // 18; // this should be a percentage
	relative = true;
	pixels = false;
	CanvasSize( relative, 2, 12, pixels, 'Cntr', 'Top ' );
	var bottom = app.activeDocument.height.value;
	var increaseWidth = parseInt( ( app.activeDocument.width.value - originalWidth ) / 2 );
	var left = increaseWidth;
	var right = app.activeDocument.width.value - increaseWidth;
	var verbose = true;
	AddTextAtBottom( p, left, top, right, bottom, verbose );
	MakeSelection( left, top, right, bottom );
	AlignEdges( gAlignTopEdges );
	AlignEdges( gAlignHorizontalCenters );
	app.activeDocument.selection.deselect();
}


///////////////////////////////////////////////////////////////////////////////
// Function: AddTextAtBottom
// Usage: Gather all the metadata and put it in one big box at the bottom
///////////////////////////////////////////////////////////////////////////////
function AddTextAtBottom( p, left, top, right, bottom, verbose ) {
	app.foregroundColor = gColorBlack;
	var strText = GetTextFromParams( p, verbose );
	var divider = 1.5;
	if ( verbose ) {
		divider = 3;
	}
	var fontSize = parseInt( ( bottom - top ) / divider );
	fontSize *= GetFontSize( p.fontsize, p.captioned );
	fontSize = Math.min( fontSize, gMaxFontSize );
	fontSize = Math.max( fontSize, gMinFontSize );
	MakeTextBox( strText, left, top, right, bottom, p.font, fontSize, gAlignCenter, 
	             app.activeDocument.width.value, app.activeDocument.height.value, 
	             app.activeDocument.resolution, GetTextColor( p.bordercolor )  );
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetMetaData
// Usage: Pull the meta data from the correct spot using the layout 
// in the File Browser "File Properties" "IPTC" "Camera Data (EXIF)" "Camera Raw"
///////////////////////////////////////////////////////////////////////////////
function GetMetaData( inString, verbose ) {
	var lString = inString.toLowerCase();
	var outTitle;
	var outData;
	// "File Properties"
	if ( 'filename' == lString ) {
		outTitle = "Filename";
		outData = app.activeDocument.name;
	} else if ( 'date created' == lString ) {
		outTitle = "Date Created";
		outData = GetXMP( 'xap:CreateDate' );
	} else if ( 'date file modified' == lString ) {
		outTitle = "Date File Modified";
		outData = GetXMP( 'xap:ModifyDate' );
	} else if ( 'document kind' == lString ) {
		outTitle = "Document Kind";
		outData = GetDocumentKind();
	} else if ( 'width' == lString ) {
		outTitle = "Width";
		outData = app.activeDocument.width;
	} else if ( 'height' == lString ) {
		outTitle = "Height";
		outData = app.activeDocument.height;
	} else if ( 'color mode' == lString ) {
		outTitle = "Color Mode";
		outData = ColorModeToString();
	} else if ( 'resolution' == lString ) {
		outTitle = "Resolution";
		outData = app.activeDocument.resolution;
	} else if ( 'color profile' == lString ) {
		outTitle = "Color Profile";
		try {
			outData = app.activeDocument.colorProfileName;
		}
		catch( e ) {
			outData = "Untagged";
		}
	} else if ( 'bit depth' == lString ) {
		outTitle = "Bit Depth";
		outData = app.activeDocument.bitsPerChannel;
	} else if ( 'documentid' == lString ) {
		outTitle = "DocumentID";
		outData = GetXMP( 'xapMM:DocumentID' );
	} else if ( 'document creator' == lString ) {
		outTitle = "Document Creator";
		outData = app.activeDocument.info.author;
	} else if ( 'copyright notice' == lString ) {
		outTitle = "Copyright Notice";
		outData = GetCopyrightNotice();
	// "IPTC"
	} else if ( 'description' == lString ) {
		outTitle = "Description";
		outData = app.activeDocument.info.caption;
	} else if ( 'description writer' == lString ) {
		outTitle = "Description Writer";
		outData = app.activeDocument.info.captionWriter;
	} else if ( 'headline' == lString ) {
		outTitle = "Headline";
		outData = app.activeDocument.info.headline;
	} else if ( 'instructions' == lString ) {
		outTitle = "Instructions";
		outData = app.activeDocument.info.instructions;
	} else if ( 'keywords' == lString ) {
		outTitle = "Keywords";
		outData = app.activeDocument.info.keywords;
	} else if ( 'author' == lString ) {
		outTitle = "Author";
		outData = app.activeDocument.info.author;
	} else if ( 'author title' == lString ) {
		outTitle = "Author Title";
		outData = app.activeDocument.info.authorPosition;
	} else if ( 'credit' == lString ) {
		outTitle = "Credit";
		outData = app.activeDocument.info.credit;
	} else if ( 'source' == lString ) {
		outTitle = "Source";
		outData = app.activeDocument.info.source;
	} else if ( 'categories' == lString ) {
		outTitle = "Categories";
		outData = app.activeDocument.info.category;
	} else if ( 'supplemental categories' == lString ) {
		outTitle = "Supplemental Categories";
		outData = app.activeDocument.info.supplementalCategories;
	} else if ( 'document title' == lString ) {
		outTitle = "Document Title";
		outData = app.activeDocument.info.title;
	} else if ( 'date subject created' == lString ) {
		outTitle = "Date Subject Created";
		outData = app.activeDocument.info.creationDate;
	} else if ( 'city' == lString ) {
		outTitle = "City";
		outData = app.activeDocument.info.city;
	} else if ( 'state/province' == lString ) {
		outTitle = "State/Province";
		outData = app.activeDocument.info.provinceState;
	} else if ( 'country' == lString ) {
		outTitle = "Country";
		outData = app.activeDocument.info.country;
	} else if ( 'transmission reference' == lString ) {
		outTitle = "Transmission Reference";
		outData = app.activeDocument.info.transmissionReference;
	} else if ( 'copyright' == lString ) {
		outTitle = "Copyright";
		outData = app.activeDocument.info.copyrightNotice;
	} else if ( 'copyright info url' == lString ) {
		outTitle = "Copyright Info URL";
		outData = app.activeDocument.info.ownerUrl;
	} else if ( 'urgency' == lString ) {
		outTitle = "Urgency";
		outData = UrgencyToString();
	} else if ( 'current date' == lString ) {
		outTitle = "Current Date";
		outData = new Date();
        if ( gShowTime ) {
			outData = outData.toLocaleString();
       	} else {
			outData = outData.toLocaleDateString();
		}
	// IPTC Core
	} else if ( 'intellectual genre' == lString ) {
		outTitle = "Intellectual Genre";
		outData = GetXMP( "Iptc4xmpCore:IntellectualGenre" );
	} else if ( 'location' == lString ) {
		outTitle = "Location";
		outData = GetXMP( "Iptc4xmpCore:Location" );
	} else if ( 'iso country code' == lString ) {
		outTitle = "ISO Country Code";
		outData = GetXMP( "Iptc4xmpCore:CountryCode" );
	} else if ( 'creator address' == lString ) {
		outTitle = "Creator Address";
		outData = GetXMP( "Iptc4xmpCore:CiAdrExtadr" );
	} else if ( 'creator city' == lString ) {
		outTitle = "Creator City";
		outData = GetXMP( "Iptc4xmpCore:CiAdrCity" );
	} else if ( 'creator state/province' == lString ) {
		outTitle = "Creator State/Province";
		outData = GetXMP( "Iptc4xmpCore:CiAdrRegion" );
	} else if ( 'creator postal code' == lString ) {
		outTitle = "Creator Postal Code";
		outData = GetXMP( "Iptc4xmpCore:CiAdrPcode" );
	} else if ( 'creator country' == lString ) {
		outTitle = "Creator Country";
		outData = GetXMP( "Iptc4xmpCore:CiAdrCtry" );
	} else if ( 'creator phone' == lString ) {
		outTitle = "Creator Phone";
		outData = GetXMP( "Iptc4xmpCore:CiTelWork" );
	} else if ( 'creator email' == lString ) {
		outTitle = "Creator Email";
		outData = GetXMP( "Iptc4xmpCore:CiEmailWork" );
	} else if ( 'creator website' == lString ) {
		outTitle = "Creator Website";
		outData = GetXMP( "Iptc4xmpCore:CiUrlWork" );
	}
	// "EXIF"
	if ( undefined == outTitle ) {
		outData = GetEXIF( inString );
		if ( undefined != outData ) {
			outTitle = inString;
		}
	}
	// "XMP"
	if ( undefined == outTitle ) {
		outData = GetXMP( inString );
		if ( undefined != outData ) {
			outTitle = inString;
		}
	}
	if ( gUsePrettyDate ) {
		outData = PrettyDate( outData );
	}
	if ( verbose ) {
		outData = outTitle + ": " + outData;
	}
	return outData;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetXMP
// Usage: Search the raw XMP for the given string, sure would be nice to have
//        an actual XML parser
///////////////////////////////////////////////////////////////////////////////
function GetXMP( inString ) {
	var xmp = app.activeDocument.xmpMetadata.rawData;
	var strCombined = '<' + inString + '>';
	var startMarker = xmp.indexOf( strCombined ) + strCombined.length;
	var endMarker = xmp.indexOf( '</' + inString + '>' );
	if ( -1 == endMarker ) return '';
	return xmp.substring( startMarker, endMarker );
}


///////////////////////////////////////////////////////////////////////////////
// Function: UrgencyToString
// Usage: Make a pretty string from the urgency enums
///////////////////////////////////////////////////////////////////////////////
function UrgencyToString() {
	switch ( app.activeDocument.info.urgency ) {
		case Urgency.FOUR:
			return 'Urgency four';
		case Urgency.HIGH:
			return 'Urgency high';
		case Urgency.LOW:
			return 'Urgency low';
		case Urgency.NONE:
			return 'Urgency none';
		case Urgency.NORMAL:
			return 'Urgency normal';
		case Urgency.SEVEN:
			return 'Urgency seven';
		case Urgency.SIX:
			return 'Urgency six';
		case Urgency.THREE:
			return 'Urgency three';
		case Urgency.TWO:
			return 'Urgency two';
	}
	return '';
}


///////////////////////////////////////////////////////////////////////////////
// Function: CopyRightedToString
// Usage: Make a pretty string from the copyright enums
///////////////////////////////////////////////////////////////////////////////
function CopyRightedToString() {
	switch ( app.activeDocument.info.copyrighted ) {
		case CopyrightedType.COPYRIGHTEDWORK:
			return 'Copyrighted Work';
		case CopyrightedType.PUBLICDOMAIN:
			return 'Public Domain';
		case CopyrightedType.UNMARKED:
			return 'Unmarked';
	}
	return '';
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetEXIF
// Usage: Exif comes in pairs, "Mode" and then the string for the Mode
///////////////////////////////////////////////////////////////////////////////
function GetEXIF( inString ) {
	var exifData = app.activeDocument.info.exif;
	for ( var i = 0; i < exifData.length; i++ ) {
		if ( exifData[ i ][ 0 ] == inString ) {
			return exifData[ i ][ 1 ];		
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetTextFromIndex
// Usage: Hand back the text or pull it from the metadata
///////////////////////////////////////////////////////////////////////////////
function GetTextFromIndex( p, verbose, index ) {
	var returnValue = '';
	if ( p.checkbox[index] ) {
		if ( p.custom[index] ) {
			returnValue += p.meta[index];
		} else {
			returnValue += GetMetaData( p.meta[index], verbose );
		}
		if ( verbose ) {
			returnValue += gVerboseSeperator;
		}
	}
	return returnValue;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetTextFromParams
// Usage: Make one big string from all the metadata assigned from the check(s)
//        We only care about the first three when in captioned mode
///////////////////////////////////////////////////////////////////////////////
function GetTextFromParams( p, verbose ) {
	var returnValue = '';
	for ( var i = 0; i < p.checkbox.length; i++ ) {
		if ( i < 3 || ! p.captioned ) {
			returnValue += GetTextFromIndex( p, verbose, i );
		}
	}
	return returnValue;
}


///////////////////////////////////////////////////////////////////////////////
// Function: MakeSelection
// Usage: easier routine to make a square selection
//        does the array work for you
///////////////////////////////////////////////////////////////////////////////
function MakeSelection( left, top, right, bottom ) {
	var selRegion = Array(Array(left, top),
		                  Array(right, top),
		                  Array(right, bottom),
		                  Array(left, bottom),
				          Array(left, top));

	app.activeDocument.selection.select( selRegion );
}


///////////////////////////////////////////////////////////////////////////////
// Function: ColorModeToString
// Usage: Return a string representing the color mode of the current document
///////////////////////////////////////////////////////////////////////////////
function ColorModeToString() {
	switch ( app.activeDocument.mode ) {
		case DocumentMode.BITMAP:
			return "Bitmap";
		case DocumentMode.CMYK:
			return "CMYK";
		case DocumentMode.DUOTONE:
			return "Duotone";
		case DocumentMode.GRAYSCALE:
			return "Grayscale";
		case DocumentMode.INDEXEDCOLOR:
			return "Indexed Color";
		case DocumentMode.LAB:
			return "Lab";
		case DocumentMode.MULTICHANNEL:
			return "Multi-channel";
		case DocumentMode.RGB:
			return "RGB";
	}
	return "";
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetDocumentKind
// Usage: Search the XMP for the document kind and return
///////////////////////////////////////////////////////////////////////////////
function GetDocumentKind() {
	var documentKind = GetXMP( 'dc:format' );
	if ( documentKind.length ) {
		documentKind = documentKind.split( '/' );
		if ( 2 == documentKind.length ) {
			documentKind = documentKind[ 1 ];
		} else {
			documentKind = '';
		}
	}
	return documentKind;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetCopyrightNotice
// Usage: Search the XMP for the copyright notice and return
// It looks like this in xmp
//         <dc:rights>
//            <rdf:Alt>
//               <rdf:li xml:lang="x-default">Russell Brown copyright notice</rdf:li>
//            </rdf:Alt>
//         </dc:rights>
///////////////////////////////////////////////////////////////////////////////
function GetCopyrightNotice() {
	// debugger;
	var copyrightNotice = GetXMP( 'dc:rights' );
	if ( copyrightNotice.length ) {

		var strCombined = '<rdf:Alt>';
		var startMarker = copyrightNotice.indexOf( strCombined ) + strCombined.length;
		var endMarker = copyrightNotice.indexOf( '</rdf:Alt>' );
		if ( -1 == endMarker ) return '';
		copyrightNotice = copyrightNotice.substring( startMarker, endMarker );

		var strCombined = '<rdf:li xml:lang="x-default">';
		var startMarker = copyrightNotice.indexOf( strCombined ) + strCombined.length;
		var endMarker = copyrightNotice.indexOf( '</rdf:li>' );

		if ( -1 == endMarker ) return '';
		copyrightNotice = copyrightNotice.substring( startMarker, endMarker );
	} else {
		copyrightNotice = '';
	}
	return copyrightNotice;
}


///////////////////////////////////////////////////////////////////////////////
// Function: PrettyDate
// Usage: Nobody liked the formatting of the date string 
// Input: inString = date in string format
// Output: convert 2004:01:01 12:00:00 into a Date object
//         or 2004-10-13T10:15:58-08:00
//         If it is not in the above format I return what was passed in
///////////////////////////////////////////////////////////////////////////////
function PrettyDate( inString ) {
	var outString = inString.toString();
	var dateTime = inString.toString().split( ' ' );
	var dateSplit = ':';
	if ( 2 != dateTime.length ) {
		dateTime = inString.toString().split( 'T' );
		if ( 2 != dateTime.length ) return outString;
		dateSplit = "-";
	}
	var dateArray = dateTime[ 0 ].split( dateSplit );
	if ( 3 != dateArray.length ) return outString;
	var timeArray = dateTime[ 1 ].split( ':' );
	if ( timeArray.length < 2 ) return outString;
	var prettyDate = new Date( parseInt( dateArray[ 0 ] ), 
							   parseInt( dateArray[ 1 ] - 1 ), // month is 0 <-> 11
							   parseInt( dateArray[ 2 ] ),
							   parseInt( timeArray[ 0 ] ), 
							   parseInt( timeArray[ 1 ] ), 
							   parseInt( timeArray[ 2 ] ) );
	if ( gShowTime ) {
		outString = prettyDate.toLocaleString();
	} else {
		outString = prettyDate.toLocaleDateString();
	}
	var addComma = outString.split( " " + dateArray[ 2 ] + " " );
	addComma[ 1 ] = ", " + addComma[ 1 ];
	outString = addComma.join( " " + dateArray[ 2 ] );
	return outString;
}


///////////////////////////////////////////////////////////////////////////////
// Function: UpdateForCustomText
// Usage: This routine gets called every time the drop down changes
//        The create/edit dialog pops, or delete command is run
//        The tooltip is also changed so long strings will show
// Input: dd = the dropdown that got changed
///////////////////////////////////////////////////////////////////////////////
function UpdateForCustomText( dd ) {
	if ( dd.selection.index == gCustomTextNewIndex ) {
		var newText = CustomTextDialog( FindDialog( dd ), dd.selection.text, 'new', '' );
		var d = FindDialog( dd );
		if ( undefined != newText ) {
			if ( newText[0] == '_' && newText[ newText.length - 1 ] == '_' ) {
				newText = newText.substr( 1, newText.length - 2 );
				d.cm.params.metadatalist.push( newText );
			} else {
				d.cm.params.addText.push( newText );
			}
			ResetAllDropDowns( d, 'text' );
			d.SetDropDown( dd, newText );
		} else {
			d.SetDropDown( dd, gLastText[ dd.tag ] );
			return;
		}
	}
	if ( dd.selection.index == gCustomTextEditIndex ) {
		var editText = gLastText[ dd.tag ];
		if ( gLastIndex[ dd.tag ] < gCustomTextNewIndex ) {
			editText = "_" + editText + "_";
		}
		editText = CustomTextDialog( FindDialog( dd ), dd.selection.text, 'edit', editText );
		var d = FindDialog( dd );
		var replaceInMeta = false;
		if ( undefined != editText ) {
			if ( editText[0] == '_' && editText[ editText.length - 1 ] == '_' ) {
				editText = editText.substr( 1, editText.length - 2 );
				replaceInMeta = true;
			}
			var newArray = [];
			var oldArray;
			if ( replaceInMeta ) {
				oldArray = d.cm.params.metadatalist;
			} else {
				oldArray = d.cm.params.addText;
			}
			for ( var i = 0; i < oldArray.length; i++ ) {
				if ( oldArray[i] == gLastText[ dd.tag ] ) {
					newArray.push( editText );
				} else {
					newArray.push( oldArray[i] );
				}
			}
			if ( replaceInMeta ) {
				d.cm.params.metadatalist = newArray;
			} else {
				d.cm.params.addText = newArray;
			}
			ResetAllDropDowns( d, 'index' );
			d.SetDropDown( dd, editText );
		} else {
			d.SetDropDown( dd, gLastText[ dd.tag ] );
			return;
		}
	}
	if ( dd.selection.index == gCustomTextDeleteIndex ) {
		var textToDelete = gLastText[ dd.tag ];
		var d = FindDialog( dd );
		if ( confirm( 'Are you sure you want to delete \'' + textToDelete + '\'?' ) ) {
			var newArray = [];
			var oldArray;
			if ( gLastIndex[ dd.tag ] < gCustomTextNewIndex ) {
				oldArray = d.cm.params.metadatalist;
			} else {
				oldArray = d.cm.params.addText;
			}
			for ( var i = 0; i < oldArray.length; i++ ) {
				if ( oldArray[i] != textToDelete ) {
					newArray.push( oldArray[i] );
				}
			}
			if ( gLastIndex[ dd.tag ] < gCustomTextNewIndex ) {
				d.cm.params.metadatalist = newArray;
			} else {
				d.cm.params.addText = newArray;
			}
			ResetAllDropDowns( FindDialog( dd ), 'text' );
		} else {
			dd.items[ gLastIndex[ dd.tag ] ].selected = true;
			dd.helpTip = dd.items[ gLastIndex[ dd.tag ] ].text;
			return;
		}
	}
	dd.helpTip = dd.selection.text;
	gLastIndex[dd.tag] = dd.selection.index;
	gLastText[dd.tag] = dd.selection.text;
}


///////////////////////////////////////////////////////////////////////////////
// Function: AddAdditionalText
// Usage: Given a drop down add all the custom text items defined by the user
// Input: dd = drop down to populate
///////////////////////////////////////////////////////////////////////////////
function AddAdditionalText( dd ) {
	var p = FindDialog( dd ).cm.params;
	for ( var i = 0; i < p.addText.length; i++ ) {
		dd.add( "item", p.addText[i] );
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetBorderColor
// Usage: Given a text string from the menu return a color
// Input: colorText = name from the dropdown
//		  ringColor = for pro prints there is an inner ring with a color
// Return: RGB color to use
///////////////////////////////////////////////////////////////////////////////
function GetBorderColor( colorText, ringColor ) {
	for ( var i = 0; i < gBorderColors.length; i++ ) {
		if ( gBorderColors[i][0] == colorText ) {
			if ( ringColor ) {
				return gBorderColors[i][2];
			} else {
				return gBorderColors[i][1];
			}
		}
	}
	return gColorWhite;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetTextColor
// Usage: Given a text string from the menu return a color
// Input: colorText = name from the dropdown
// Return: RGB color to use
///////////////////////////////////////////////////////////////////////////////
function GetTextColor( colorText ) {
	for ( var i = 0; i < gBorderColors.length; i++ ) {
		if ( gBorderColors[i][0] == colorText ) {
			return gBorderColors[i][3];
		}
	}
	return gColorBlack;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetPostScriptName
// Usage: Given a font name from the font menu look up the font post script name
// Input: fontText = name from the dropdown
//		  captionMode = numbers are different from caption mode vs. pro mode
// Return: font post script name
///////////////////////////////////////////////////////////////////////////////
function GetPostScriptName( fontText ) {
	for ( var i = 0; i < gFontList.length; i++ ) {
		if ( gFontList[i][0] == fontText ) {
			return gFontList[i][1];
		}
	}
	return 'Helvetica';
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetFontSize
// Usage: Given a name from the font size menu look up the font ratio
// Input: fontSizeName = name from the dropdown
//		  captionMode = numbers are different from caption mode vs. pro mode
// Return: Ratio to use when setting the font
///////////////////////////////////////////////////////////////////////////////
function GetFontSize( fontSizeName, captionMode ) {
	for ( var i = 0; i < gFontSizeList.length; i++ ) {
		if ( gFontSizeList[i][0] == fontSizeName ) {
			if ( captionMode ) {
				return gFontSizeList[i][1];
			} else {
				return gFontSizeList[i][2];
			}
		}
	}
	return 0.60;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetImage
// Usage: Get a file object to a specific image
// Input: imageName = name of the image
//		  imageDefault = the default image if the file does not exist
// Output: on error, 
//         pops a dialog giving the full path to the file I'm looking for
//         and then sets the image to a string 'Step1Icon' or undefined
///////////////////////////////////////////////////////////////////////////////
function GetImage( imageName, imageDefault ) {
	var f = File( app.path + '/' + strPresets + '/' + strScripts + '/' + strIcons + '/' + imageName );
	if ( ! f.exists ) {
		alert( strCouldNotFind + f.fsName );
		return imageDefault;
	}
	return f;
}


///////////////////////////////////////////////////////////////////////////////
// Function: HideAllPreview
// Usage: Hide all of the previews, I stuffed all the previews into an array
// during dialog creation time
// Input:	d = main dialog
///////////////////////////////////////////////////////////////////////////////
function HideAllPreview( d ) {
	for ( var i = 0; i < d.previews.length; i++ ) {
		d.previews[i].hide();
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: EnableOnePreview
// Usage: enable just one of the previews based on the check boxes currently on
// Input:	d = main dialog
// Note: I have "tag"ged the groups to enable this finding routine
// The 'Pro' previews only change on color
// The 'Caption' previews change on colors and the first three check boxes
///////////////////////////////////////////////////////////////////////////////
function EnableOnePreview( d ) {
	HideAllPreview( d );
	var tagString = "";
	var count = 0;
	if ( d.rbCaption.value ) {
		tagString += "Cap";
		if ( d.cbM1.value ) {
			tagString += "Lft";
			count++;
		}
		if ( d.cbM2.value ) {
			tagString += "Ctr";
			count++;
		}
		if ( d.cbM3.value ) {
			tagString += "Rt";
			count++;
		}
		if ( count == 0 ) {
			tagString += "None";
		}
	} else {
		tagString += "Pro";
	}
	// this routine gets called before the selection is an object
	// lucky for me it gets called twice!
	try {
		if ( d.ddBorderColor.selection.text == "Black" )
			tagString += "BK";
		if ( d.ddBorderColor.selection.text == "Light Gray" )
			tagString += "LG";
		if ( d.ddBorderColor.selection.text == "White" )
			tagString += "Wh";
	}
	catch(e) {
		tagString += "Wh";
	}
	for ( var i = 0; i < d.previews.length; i++ ) {
		if ( d.previews[i].tag == tagString ) {
			d.previews[i].show();
			break;
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: MetaDataCheckBoxOnClick
// Usage: enable/disable the drop down next to the check box
//        change the preview as necessary
// Input:	cb = check box that got clicked
//			index = index of the check box
//			updatePreview = true/false if the check box affects the preview
///////////////////////////////////////////////////////////////////////////////
function MetaDataCheckBoxOnClick( cb, index, updatePreview ) {
	var d = FindDialog( cb );
	if ( updatePreview ) {
		EnableOnePreview( d );
	}
	if ( cb.enabled ) {
		d.metaDDs[index].enabled = cb.value;
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: CustomTextDialog
// Usage: pop another dialog to create or edit menu items
// Input:	d = parent dialog
//			dialogTitle = title for this dialog
//			mode = 'new' or 'edit'
//			startText = '' or initial text for edit mode
// Return: a new custom text string or MetaData to look for
///////////////////////////////////////////////////////////////////////////////
function CustomTextDialog( d, dialogTitle, mode, startText ) {
	var newText = undefined;
	var dlgNewCustomText = new Window( 'dialog' );
	dlgNewCustomText.text = dialogTitle;
	dlgNewCustomText.orientation = 'row';
	dlgNewCustomText.alignChildren = 'left';
	var grpLeft = dlgNewCustomText.add( 'group' );
	grpLeft.orientation = 'column';
	grpLeft.alignChildren = 'fill';
	grpLeft.alignment = 'fill';
	var stNameStr = "Enter your custom text in this edit window. Then choose save.";
	if ( mode == 'edit' ) {
		stNameStr = "Edit the current custom text field and then choose save.";
	}
	var stName = grpLeft.add( 'statictext', undefined, stNameStr );
	var etName = grpLeft.add( 'edittext', undefined, undefined, { multiline:true } );
	etName.text = startText;
	etName.preferredSize.height = 85;
	etName.preferredSize.width = 500;
	var grpMessage = grpLeft.add( 'group' );
	grpMessage.orientation = 'row';
	grpMessage.alignChildren = 'fill';
	grpMessage.alignment = 'fill';
	var pngI = grpMessage.add( "image", undefined, 'InfoIcon' );
	var stDescription = grpMessage.add( 'statictext', undefined, undefined, {multiline:true} );
	stDescription.text = "Note: To add additional metadata items that are not found in the default list, enter your text as shown in this example. _Creator_";
	if ( mode == 'edit' ) {
		stDescription.text = "Note: Making edits to an existing custom text field will update all occurrences of this text in your selected metadata captions.";
	}
	var pnlRight = dlgNewCustomText.add( 'group' );
	pnlRight.orientation = 'column';
	pnlRight.alignChildren = 'left';
	var btnSave = pnlRight.add( 'button', undefined, "Save" );
	btnSave.enabled = false;
	var btnCancel = pnlRight.add( 'button', undefined, strButtonCancel );
	dlgNewCustomText.defaultElement = btnSave;
	dlgNewCustomText.cancelElement = btnCancel;
	dlgNewCustomText.center();
	etName.active = true;
	btnSave.onClick = function() {
		for ( var i = 0; i < d.cm.params.addText.length; i++ ) {
			if ( etName.text == d.cm.params.addText[i] ) {
				alert( 'This custom text is already in your list. To simplify processing, duplicate listings are not permitted. Please change your custom listing and select save.' );
				return;
			}
		}
		for ( var i = 0; i < d.cm.params.metadatalist.length; i++ ) {
			if ( etName.text == ( "_" + d.cm.params.metadatalist[i] + "_" ) ) {
				alert( 'This custom text is already in your list. To simplify processing, duplicate listings are not permitted. Please change your custom listing and select save.' );
				return;
			}
		}
		for ( var i = 0; i < gCustomMenuList.length; i++ ) {
			if ( gCustomMenuList[i] == etName.text || ( "_" + gCustomMenuList[i] + "_" ) == etName.text ) {
				alert( 'You cannot use \'' + etName.text + '\' as it is a special menu item.' );
				return;
			}
		}
		dlgNewCustomText.close( true );
	}
	etName.onChanging = function() {
		btnSave.enabled = ( this.text != startText );
		if ( mode == 'new' && this.text.length == 0 ) {
			btnSave.enabled = false;
		}
		if ( this.text.search( '\n' ) != -1 || this.text.search( '\r' ) != -1 ) { 
			alert('You cannot use a carriage return in this text window. Caption Maker will perform an automatic text wrap, based upon the border style you have chosen. You may continue to add additional text or select save.');
			this.text = this.text.replace( /\n/g, '' );
			this.text = this.text.replace( /\r/g, '' );
		}
	}
	if ( true == dlgNewCustomText.show() ) {
		newText = etName.text;
	}
	return newText;			
}


///////////////////////////////////////////////////////////////////////////////
// Function: IsFileOneOfThese
// Usage: Given a file name and a list of extensions determine if this file
//        is in the list of extensions
// Input: inFileName = name of the file
//        inArrayOfFileExtensions = array of all the extensions
///////////////////////////////////////////////////////////////////////////////
function IsFileOneOfThese( inFileName, inArrayOfFileExtensions ) {
	var lastDot = inFileName.toString().lastIndexOf( "." );
	if ( lastDot == -1 ) {
		return false;
	}
	var strLength = inFileName.toString().length;
	var extension = inFileName.toString().substr( lastDot + 1, strLength - lastDot );
	extension = extension.toLowerCase();
	for (var i = 0; i < inArrayOfFileExtensions.length; i++ ) {
		if ( extension == inArrayOfFileExtensions[i] ) {
			return true;
		}
	}
	return false;
}


///////////////////////////////////////////////////////////////////////////////
// Function: ResetAllDropDowns
// Usage: params have changed so initialize the drop downs content and then 
//        move it to the current setting, the initMode has three values, 
//			'text'  = set the current state to the last known text
//			'index' = set the current state to the last known index
//          'meta'  = set the current state to the params metadatalist
// Input:	d = parent dialog
//			initMode = 'text', 'index', or 'meta'
///////////////////////////////////////////////////////////////////////////////
function ResetAllDropDowns( d, initMode ) {
	var oneShot = true;
	for ( var j = 0; j < d.metaDDs.length; j++ ) {
		var oneDD = d.metaDDs[j];
		oneDD.removeAll();
		for ( var i = 0; i < d.cm.params.metadatalist.length; i++ ) {
			oneDD.add( "item", d.cm.params.metadatalist[i] );
		}
		if ( oneShot ) {
			oneShot = false;
			gCustomTextNewIndex = d.ddM1.items.length + 1;
			gCustomTextEditIndex = gCustomTextNewIndex + 1;
			gCustomTextDeleteIndex = gCustomTextEditIndex + 1;
		}
		oneDD.add( "separator", "before custom" );
		for ( var i = 0; i < gCustomMenuList.length; i++ ) {
			oneDD.add( "item", gCustomMenuList[i] );
		}
		oneDD.add( "separator", "after custom" );
		AddAdditionalText( oneDD );
		if ( 'index' == initMode ) {
			oneDD.items[ gLastIndex[ oneDD.tag ] ].selected = true;
			oneDD.helpTip = oneDD.items[ gLastIndex[ oneDD.tag ] ].text;
		} else if ( 'text' == initMode ) {
			d.SetDropDown( oneDD, gLastText[ oneDD.tag ] );
		} else if ( 'meta' == initMode ) {
			d.SetDropDown( oneDD, d.cm.params.meta[j] );
		}
	}
}


function MakePDFPresentation( fileList ) {
	var rememberDialogs = app.displayDialogs;
	app.displayDialogs = DialogModes.ALL;
	app.makePDFPresentation( fileList, File('') );
	app.displayDialogs = rememberDialogs;
}


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// script listener code below here
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
// Function: WaitForRedraw
// Usage: This slows down Photoshop to allow you to monitor what is happening
//        use it for debugging your code or for showing your users the changes
//        that are occuring
///////////////////////////////////////////////////////////////////////////////
function WaitForRedraw() {
	eventID = charIDToTypeID( "Wait" );
	keyID = charIDToTypeID( "Stte" );
	enumID = charIDToTypeID( "RdCm" );
	desc = new ActionDescriptor();
	desc.putEnumerated(keyID, keyID, enumID);
	executeAction(eventID, desc, DialogModes.NO);
}


///////////////////////////////////////////////////////////////////////////////
// Function: MakeSelectionPathAndDeselect
// Usage: Take the current selection and turn it into a path
//        This makes a work path
//        Take the inString and convert the work path to a real path
//        Finally deselect the path
///////////////////////////////////////////////////////////////////////////////
function MakeSelectionPathAndDeselect( inString ) {
	
	// make current selection a work path
	var id4712 = charIDToTypeID( "Mk  " );
    var desc808 = new ActionDescriptor();
    var id4713 = charIDToTypeID( "null" );
        var ref261 = new ActionReference();
        var id4714 = charIDToTypeID( "Path" );
        ref261.putClass( id4714 );
    desc808.putReference( id4713, ref261 );
    var id4715 = charIDToTypeID( "From" );
        var ref262 = new ActionReference();
        var id4716 = charIDToTypeID( "csel" );
        var id4717 = charIDToTypeID( "fsel" );
        ref262.putProperty( id4716, id4717 );
    desc808.putReference( id4715, ref262 );
    var id4718 = charIDToTypeID( "Tlrn" );
    var id4719 = charIDToTypeID( "#Pxl" );
    desc808.putUnitDouble( id4718, id4719, 1.000000 );
	executeAction( id4712, desc808, DialogModes.NO );

	// If there is already a 'inString' then try to make a unique one
	// and try again
	var allClear = false;
	var index = 1;
	var originalString = inString;

	while ( ! allClear ) {
		try {
			// name the work path which makes it a real path
			var id4720 = charIDToTypeID( "Mk  " );
			var desc809 = new ActionDescriptor();
			var id4721 = charIDToTypeID( "null" );
				var ref263 = new ActionReference();
				var id4722 = charIDToTypeID( "Path" );
				ref263.putClass( id4722 );
			desc809.putReference( id4721, ref263 );
			var id4723 = charIDToTypeID( "From" );
				var ref264 = new ActionReference();
				var id4724 = charIDToTypeID( "Path" );
				var id4725 = charIDToTypeID( "WrPt" );
				ref264.putProperty( id4724, id4725 );
			desc809.putReference( id4723, ref264 );
			var id4726 = charIDToTypeID( "Nm  " );
			desc809.putString( id4726, inString );
			executeAction( id4720, desc809, DialogModes.NO );
			allClear = true;
		}
		catch( e ) {
			inString = originalString + " " + index.toString();
			index++;
		}
	}

	// deselect the path
	var id4741 = charIDToTypeID( "Dslc" );
    var desc814 = new ActionDescriptor();
    var id4742 = charIDToTypeID( "null" );
        var ref268 = new ActionReference();
        var id4743 = charIDToTypeID( "Path" );
        ref268.putClass( id4743 );
    desc814.putReference( id4742, ref268 );
	executeAction( id4741, desc814, DialogModes.NO );
}


///////////////////////////////////////////////////////////////////////////////
// Function: AlignEdges
// Usage: An easy way to cheat to get two layers to lign up
// Input: alignment to use
///////////////////////////////////////////////////////////////////////////////
function AlignEdges( inAlignment ) {
	var id130 = charIDToTypeID( 'Algn' );
    var desc30 = new ActionDescriptor();
    var id131 = charIDToTypeID( 'null' );
        var ref25 = new ActionReference();
        var id132 = charIDToTypeID( 'Lyr ' );
        var id133 = charIDToTypeID( 'Ordn' );
        var id134 = charIDToTypeID( 'Lnkd' );
        ref25.putEnumerated( id132, id133, id134 );
    desc30.putReference( id131, ref25 );
    var id135 = charIDToTypeID( 'Usng' );
    var id136 = charIDToTypeID( 'ADSt' );
    desc30.putEnumerated( id135, id136, inAlignment );
	executeAction( id130, desc30, DialogModes.NO );
}


///////////////////////////////////////////////////////////////////////////////
// Function: CanvasSize
// Usage: Resize the canvas
// Input: relative = true or false, can be undefined ( false )
//		  width and height, either can be undefined, not both
//		  pixels = true or false, are the width and height in pixels ( default ), ( or percent )
//		  horizontal position = 'Left', 'Cntr', or 'Rght', can be undefined
//		  vertical position = 'Top ', 'Cntr', or 'Bttm', can be undefined
///////////////////////////////////////////////////////////////////////////////
function CanvasSize( relative, width, height, pixels, horizontal, vertical ) {
	var id245 = charIDToTypeID( 'CnvS' );
    var desc46 = new ActionDescriptor();
    if ( relative ) {
		var id246 = charIDToTypeID( 'Rltv' );
		desc46.putBoolean( id246, true );
	}
	var unitString = '#Prc';
	if ( pixels ) {
		unitString = '#Pxl';
	}
	var unitID = charIDToTypeID( unitString );
	if ( undefined != width ) {
		var id247 = charIDToTypeID( 'Wdth' );
		desc46.putUnitDouble( id247, unitID, width );
	}
	if ( undefined != height ) {
		var id249 = charIDToTypeID( 'Hght' );
		desc46.putUnitDouble( id249, unitID, height );
	}
	if ( undefined != horizontal ) {
		var id251 = charIDToTypeID( 'Hrzn' );
		var id252 = charIDToTypeID( 'HrzL' );
		var id253 = charIDToTypeID( horizontal );
	    desc46.putEnumerated( id251, id252, id253 );
	}
	if ( undefined != vertical ) {
	    var id254 = charIDToTypeID( 'Vrtc' );
		var id255 = charIDToTypeID( 'VrtL' );
		var id256 = charIDToTypeID( vertical );
	    desc46.putEnumerated( id254, id255, id256 );
	}
    var id257 = stringIDToTypeID( 'canvasExtensionColorType' );
    var id259 = charIDToTypeID( 'FrgC' );
    desc46.putEnumerated( id257, id257, id259 );
	executeAction( id245, desc46, DialogModes.NO );
}


///////////////////////////////////////////////////////////////////////////////
// Function: MakeTextBox
// Usage: Create a text box and shove the text into it
//        I have to pass in the doc dimensions because this routine
//        wants percentages
///////////////////////////////////////////////////////////////////////////////
function MakeTextBox( inText, left, top, right, bottom, fontName, fontSize, alignment, docWidth, docHeight, res, textColor ) {
	var id1724 = charIDToTypeID( "Mk  " );
    var desc166 = new ActionDescriptor();
    var id1725 = charIDToTypeID( "null" );
        var ref85 = new ActionReference();
        var id1726 = charIDToTypeID( "TxLr" );
        ref85.putClass( id1726 );
    desc166.putReference( id1725, ref85 );
    var id1727 = charIDToTypeID( "Usng" );
        var desc167 = new ActionDescriptor();
        var id1728 = charIDToTypeID( "Txt " );
        desc167.putString( id1728, inText );
        var id1729 = stringIDToTypeID( "warp" );
            var desc168 = new ActionDescriptor();
            var id1730 = stringIDToTypeID( "warpStyle" );
            var id1731 = stringIDToTypeID( "warpStyle" );
            var id1732 = stringIDToTypeID( "warpNone" );
            desc168.putEnumerated( id1730, id1731, id1732 );
            var id1733 = stringIDToTypeID( "warpValue" );
            desc168.putDouble( id1733, 0.000000 );
            var id1734 = stringIDToTypeID( "warpPerspective" );
            desc168.putDouble( id1734, 0.000000 );
            var id1735 = stringIDToTypeID( "warpPerspectiveOther" );
            desc168.putDouble( id1735, 0.000000 );
            var id1736 = stringIDToTypeID( "warpRotate" );
            var id1737 = charIDToTypeID( "Ornt" );
            var id1738 = charIDToTypeID( "Hrzn" );
            desc168.putEnumerated( id1736, id1737, id1738 );
        var id1739 = stringIDToTypeID( "warp" );
        desc167.putObject( id1729, id1739, desc168 );
        var id1740 = charIDToTypeID( "TxtC" );
			// these are in percent
            var desc169 = new ActionDescriptor();
            var id1741 = charIDToTypeID( "Hrzn" );
            var id1742 = charIDToTypeID( "#Prc" );
            desc169.putUnitDouble( id1741, id1742, ( bottom - top ) / docHeight * 100.0 );
            var id1743 = charIDToTypeID( "Vrtc" );
            var id1744 = charIDToTypeID( "#Prc" );
            desc169.putUnitDouble( id1743, id1744, ( right - left ) / docWidth * 100.0 );
        var id1745 = charIDToTypeID( "Pnt " );
        desc167.putObject( id1740, id1745, desc169 );
        var id1746 = stringIDToTypeID( "textGridding" );
        var id1747 = stringIDToTypeID( "textGridding" );
        var id1748 = charIDToTypeID( "None" );
        desc167.putEnumerated( id1746, id1747, id1748 );
        var id1749 = charIDToTypeID( "Ornt" );
        var id1750 = charIDToTypeID( "Ornt" );
        var id1751 = charIDToTypeID( "Hrzn" );
        desc167.putEnumerated( id1749, id1750, id1751 );
        var id1752 = charIDToTypeID( "AntA" );
        var id1753 = charIDToTypeID( "Annt" );
        var id1754 = charIDToTypeID( "AnCr" );
        desc167.putEnumerated( id1752, id1753, id1754 );
        var id1755 = stringIDToTypeID( "textShape" );
            var list20 = new ActionList();
                var desc170 = new ActionDescriptor();
                var id1756 = charIDToTypeID( "TEXT" );
                var id1757 = charIDToTypeID( "TEXT" );
                var id1758 = stringIDToTypeID( "box" );
                desc170.putEnumerated( id1756, id1757, id1758 );
                var id1759 = charIDToTypeID( "Ornt" );
                var id1760 = charIDToTypeID( "Ornt" );
                var id1761 = charIDToTypeID( "Hrzn" );
                desc170.putEnumerated( id1759, id1760, id1761 );
                var id1762 = charIDToTypeID( "Trnf" );
                    var desc171 = new ActionDescriptor();
                    var id1763 = stringIDToTypeID( "xx" );
                    desc171.putDouble( id1763, 1.000000 );
                    var id1764 = stringIDToTypeID( "xy" );
                    desc171.putDouble( id1764, 0.000000 );
                    var id1765 = stringIDToTypeID( "yx" );
                    desc171.putDouble( id1765, 0.000000 );
                    var id1766 = stringIDToTypeID( "yy" );
                    desc171.putDouble( id1766, 1.000000 );
                    var id1767 = stringIDToTypeID( "tx" );
                    desc171.putDouble( id1767, 0.000000 );
                    var id1768 = stringIDToTypeID( "ty" );
                    desc171.putDouble( id1768, 0.000000 );
                var id1769 = charIDToTypeID( "Trnf" );
                desc170.putObject( id1762, id1769, desc171 );
                var id1770 = stringIDToTypeID( "rowCount" );
                desc170.putInteger( id1770, 1 );
                var id1771 = stringIDToTypeID( "columnCount" );
                desc170.putInteger( id1771, 1 );
                var id1772 = stringIDToTypeID( "rowMajorOrder" );
                desc170.putBoolean( id1772, true );
                var id1773 = stringIDToTypeID( "rowGutter" );
                var id1774 = charIDToTypeID( "#Pxl" );
                desc170.putUnitDouble( id1773, id1774, 0.000000 );
                var id1775 = stringIDToTypeID( "columnGutter" );
                var id1776 = charIDToTypeID( "#Pxl" );
                desc170.putUnitDouble( id1775, id1776, 0.000000 );
                var id1777 = charIDToTypeID( "Spcn" );
                var id1778 = charIDToTypeID( "#Pxl" );
                desc170.putUnitDouble( id1777, id1778, 0.000000 );
                var id1779 = stringIDToTypeID( "frameBaselineAlignment" );
                var id1780 = stringIDToTypeID( "frameBaselineAlignment" );
                var id1781 = stringIDToTypeID( "alignByAscent" );
                desc170.putEnumerated( id1779, id1780, id1781 );
                var id1782 = stringIDToTypeID( "firstBaselineMinimum" );
                var id1783 = charIDToTypeID( "#Pxl" );
                desc170.putUnitDouble( id1782, id1783, 0.000000 );
				// these are in points
				// bounding box is 0,0 for top left
                var id1784 = stringIDToTypeID( "bounds" );
                    var desc172 = new ActionDescriptor();
                    var id1785 = charIDToTypeID( "Top " );
                    desc172.putDouble( id1785, 0 );
                    var id1786 = charIDToTypeID( "Left" );
                    desc172.putDouble( id1786, 0 );
                    var id1787 = charIDToTypeID( "Btom" );
                    desc172.putDouble( id1787, ( bottom - top ) * 72 / res );
                    var id1788 = charIDToTypeID( "Rght" );
                    desc172.putDouble( id1788, ( right - left ) * 72 / res );
                var id1789 = charIDToTypeID( "Rctn" );
                desc170.putObject( id1784, id1789, desc172 );
            var id1790 = stringIDToTypeID( "textShape" );
            list20.putObject( id1790, desc170 );
        desc167.putList( id1755, list20 );
        var id1791 = charIDToTypeID( "Txtt" );
            var list21 = new ActionList();
                var desc173 = new ActionDescriptor();
                var id1792 = charIDToTypeID( "From" );
                desc173.putInteger( id1792, 0 );
                var id1793 = charIDToTypeID( "T   " );
                desc173.putInteger( id1793, inText.length );
                var id1794 = charIDToTypeID( "TxtS" );
                    var desc174 = new ActionDescriptor();
                    var id1795 = stringIDToTypeID( "fontPostScriptName" );
                    desc174.putString( id1795, GetPostScriptName( fontName ) );
                    var id1796 = charIDToTypeID( "FntN" );
                    desc174.putString( id1796, fontName );
                    var id1797 = charIDToTypeID( "FntS" );
                    desc174.putString( id1797, "Regular" );
                    var id1798 = charIDToTypeID( "Scrp" );
                    desc174.putInteger( id1798, 0 );
                    var id1799 = charIDToTypeID( "FntT" );
                    desc174.putInteger( id1799, 0 );
                    var id1800 = charIDToTypeID( "Sz  " );
                    var id1801 = charIDToTypeID( "#Pxl" );
                    desc174.putUnitDouble( id1800, id1801, fontSize );
                    var id1802 = charIDToTypeID( "HrzS" );
                    desc174.putDouble( id1802, 100.000000 );
                    var id1803 = charIDToTypeID( "VrtS" );
                    desc174.putDouble( id1803, 100.000000 );
                    var id1804 = stringIDToTypeID( "syntheticBold" );
                    desc174.putBoolean( id1804, false );
                    var id1805 = stringIDToTypeID( "syntheticItalic" );
                    desc174.putBoolean( id1805, false );
                    var id1806 = stringIDToTypeID( "autoLeading" );
                    desc174.putBoolean( id1806, true );
                    var id1807 = charIDToTypeID( "Trck" );
                    desc174.putInteger( id1807, 0 );
                    var id1808 = charIDToTypeID( "Bsln" );
                    var id1809 = charIDToTypeID( "#Pxl" );
                    desc174.putUnitDouble( id1808, id1809, 0.000000 );
                    var id1810 = stringIDToTypeID( "characterRotation" );
                    desc174.putDouble( id1810, 0.000000 );
                    var id1811 = charIDToTypeID( "AtKr" );
                    var id1812 = charIDToTypeID( "AtKr" );
                    var id1813 = stringIDToTypeID( "metricsKern" );
                    desc174.putEnumerated( id1811, id1812, id1813 );
                    var id1814 = stringIDToTypeID( "fontCaps" );
                    var id1815 = stringIDToTypeID( "fontCaps" );
                    var id1816 = charIDToTypeID( "Nrml" );
                    desc174.putEnumerated( id1814, id1815, id1816 );
                    var id1817 = stringIDToTypeID( "baseline" );
                    var id1818 = stringIDToTypeID( "baseline" );
                    var id1819 = charIDToTypeID( "Nrml" );
                    desc174.putEnumerated( id1817, id1818, id1819 );
                    var id1820 = stringIDToTypeID( "otbaseline" );
                    var id1821 = stringIDToTypeID( "otbaseline" );
                    var id1822 = charIDToTypeID( "Nrml" );
                    desc174.putEnumerated( id1820, id1821, id1822 );
                    var id1823 = stringIDToTypeID( "strikethrough" );
                    var id1824 = stringIDToTypeID( "strikethrough" );
                    var id1825 = stringIDToTypeID( "strikethroughOff" );
                    desc174.putEnumerated( id1823, id1824, id1825 );
                    var id1826 = charIDToTypeID( "Undl" );
                    var id1827 = charIDToTypeID( "Undl" );
                    var id1828 = stringIDToTypeID( "underlineOff" );
                    desc174.putEnumerated( id1826, id1827, id1828 );
                    var id1829 = stringIDToTypeID( "underlineOffset" );
                    var id1830 = charIDToTypeID( "#Pxl" );
                    desc174.putUnitDouble( id1829, id1830, 0.000000 );
                    var id1831 = stringIDToTypeID( "ligature" );
                    desc174.putBoolean( id1831, true );
                    var id1832 = stringIDToTypeID( "altligature" );
                    desc174.putBoolean( id1832, false );
                    var id1833 = stringIDToTypeID( "contextualLigatures" );
                    desc174.putBoolean( id1833, false );
                    var id1834 = stringIDToTypeID( "alternateLigatures" );
                    desc174.putBoolean( id1834, false );
                    var id1835 = stringIDToTypeID( "oldStyle" );
                    desc174.putBoolean( id1835, false );
                    var id1836 = stringIDToTypeID( "fractions" );
                    desc174.putBoolean( id1836, false );
                    var id1837 = stringIDToTypeID( "ordinals" );
                    desc174.putBoolean( id1837, false );
                    var id1838 = stringIDToTypeID( "swash" );
                    desc174.putBoolean( id1838, false );
                    var id1839 = stringIDToTypeID( "titling" );
                    desc174.putBoolean( id1839, false );
                    var id1840 = stringIDToTypeID( "connectionForms" );
                    desc174.putBoolean( id1840, false );
                    var id1841 = stringIDToTypeID( "stylisticAlternates" );
                    desc174.putBoolean( id1841, false );
                    var id1842 = stringIDToTypeID( "ornaments" );
                    desc174.putBoolean( id1842, false );
                    var id1843 = stringIDToTypeID( "figureStyle" );
                    var id1844 = stringIDToTypeID( "figureStyle" );
                    var id1845 = charIDToTypeID( "Nrml" );
                    desc174.putEnumerated( id1843, id1844, id1845 );
                    var id1846 = stringIDToTypeID( "proportionalMetrics" );
                    desc174.putBoolean( id1846, false );
                    var id1847 = stringIDToTypeID( "kana" );
                    desc174.putBoolean( id1847, false );
                    var id1848 = stringIDToTypeID( "italics" );
                    desc174.putBoolean( id1848, false );
                    var id1849 = stringIDToTypeID( "ruby" );
                    desc174.putBoolean( id1849, false );
                    var id1850 = stringIDToTypeID( "baselineDirection" );
                    var id1851 = stringIDToTypeID( "baselineDirection" );
                    var id1852 = charIDToTypeID( "Rtt " );
                    desc174.putEnumerated( id1850, id1851, id1852 );
                    var id1853 = stringIDToTypeID( "textLanguage" );
                    var id1854 = stringIDToTypeID( "textLanguage" );
                    var id1855 = stringIDToTypeID( "englishLanguage" );
                    desc174.putEnumerated( id1853, id1854, id1855 );
                    var id1856 = stringIDToTypeID( "japaneseAlternate" );
                    var id1857 = stringIDToTypeID( "japaneseAlternate" );
                    var id1858 = stringIDToTypeID( "defaultForm" );
                    desc174.putEnumerated( id1856, id1857, id1858 );
                    var id1859 = stringIDToTypeID( "mojiZume" );
                    desc174.putDouble( id1859, 0.000000 );
                    var id1860 = stringIDToTypeID( "gridAlignment" );
                    var id1861 = stringIDToTypeID( "gridAlignment" );
                    var id1862 = stringIDToTypeID( "roman" );
                    desc174.putEnumerated( id1860, id1861, id1862 );
                    var id1863 = stringIDToTypeID( "enableWariChu" );
                    desc174.putBoolean( id1863, false );
                    var id1864 = stringIDToTypeID( "wariChuCount" );
                    desc174.putInteger( id1864, 2 );
                    var id1865 = stringIDToTypeID( "wariChuLineGap" );
                    desc174.putInteger( id1865, 0 );
                    var id1866 = stringIDToTypeID( "wariChuScale" );
                    desc174.putDouble( id1866, 0.500000 );
                    var id1867 = stringIDToTypeID( "wariChuWidow" );
                    desc174.putInteger( id1867, 2 );
                    var id1868 = stringIDToTypeID( "wariChuOrphan" );
                    desc174.putInteger( id1868, 2 );
                    var id1869 = stringIDToTypeID( "wariChuJustification" );
                    var id1870 = stringIDToTypeID( "wariChuJustification" );
                    var id1871 = stringIDToTypeID( "wariChuAutoJustify" );
                    desc174.putEnumerated( id1869, id1870, id1871 );
                    var id1872 = stringIDToTypeID( "tcyUpDown" );
                    desc174.putInteger( id1872, 0 );
                    var id1873 = stringIDToTypeID( "tcyLeftRight" );
                    desc174.putInteger( id1873, 0 );
                    var id1874 = stringIDToTypeID( "leftAki" );
                    var id1875 = charIDToTypeID( "#Pxl" );
                    desc174.putUnitDouble( id1874, id1875, -1.000000 );
                    var id1876 = stringIDToTypeID( "rightAki" );
                    var id1877 = charIDToTypeID( "#Pxl" );
                    desc174.putUnitDouble( id1876, id1877, -1.000000 );
                    var id1878 = stringIDToTypeID( "jiDori" );
                    desc174.putInteger( id1878, 0 );
                    var id1879 = stringIDToTypeID( "noBreak" );
                    desc174.putBoolean( id1879, false );
                    var id1880 = charIDToTypeID( "Clr " );
                        var desc175 = new ActionDescriptor();
                        var id1881 = charIDToTypeID( "Rd  " );
                        desc175.putDouble( id1881, textColor.rgb.red );
                        var id1882 = charIDToTypeID( "Grn " );
                        desc175.putDouble( id1882, textColor.rgb.green );
                        var id1883 = charIDToTypeID( "Bl  " );
                        desc175.putDouble( id1883, textColor.rgb.blue );
                    var id1884 = charIDToTypeID( "RGBC" );
                    desc174.putObject( id1880, id1884, desc175 );
                    var id1885 = stringIDToTypeID( "strokeColor" );
                        var desc176 = new ActionDescriptor();
                        var id1886 = charIDToTypeID( "Rd  " );
                        desc176.putDouble( id1886, 0.000000 );
                        var id1887 = charIDToTypeID( "Grn " );
                        desc176.putDouble( id1887, 0.000000 );
                        var id1888 = charIDToTypeID( "Bl  " );
                        desc176.putDouble( id1888, 0.000000 );
                    var id1889 = charIDToTypeID( "RGBC" );
                    desc174.putObject( id1885, id1889, desc176 );
                    var id1890 = charIDToTypeID( "Fl  " );
                    desc174.putBoolean( id1890, true );
                    var id1891 = charIDToTypeID( "Strk" );
                    desc174.putBoolean( id1891, false );
                    var id1892 = stringIDToTypeID( "fillFirst" );
                    desc174.putBoolean( id1892, true );
                    var id1893 = stringIDToTypeID( "fillOverPrint" );
                    desc174.putBoolean( id1893, false );
                    var id1894 = stringIDToTypeID( "strokeOverPrint" );
                    desc174.putBoolean( id1894, false );
                    var id1895 = stringIDToTypeID( "lineCap" );
                    var id1896 = stringIDToTypeID( "lineCap" );
                    var id1897 = stringIDToTypeID( "buttCap" );
                    desc174.putEnumerated( id1895, id1896, id1897 );
                    var id1898 = stringIDToTypeID( "lineJoin" );
                    var id1899 = stringIDToTypeID( "lineJoin" );
                    var id1900 = stringIDToTypeID( "miterJoin" );
                    desc174.putEnumerated( id1898, id1899, id1900 );
                    var id1901 = stringIDToTypeID( "lineWidth" );
                    var id1902 = charIDToTypeID( "#Pxl" );
                    desc174.putUnitDouble( id1901, id1902, 1.000000 );
                    var id1903 = stringIDToTypeID( "miterLimit" );
                    var id1904 = charIDToTypeID( "#Pxl" );
                    desc174.putUnitDouble( id1903, id1904, 4.000000 );
                    var id1905 = stringIDToTypeID( "lineDashoffset" );
                    desc174.putDouble( id1905, 0.000000 );
                var id1906 = charIDToTypeID( "TxtS" );
                desc173.putObject( id1794, id1906, desc174 );
            var id1907 = charIDToTypeID( "Txtt" );
            list21.putObject( id1907, desc173 );
        desc167.putList( id1791, list21 );
        var id1908 = stringIDToTypeID( "paragraphStyleRange" );
            var list22 = new ActionList();
                var desc177 = new ActionDescriptor();
                var id1909 = charIDToTypeID( "From" );
                desc177.putInteger( id1909, 0 );
                var id1910 = charIDToTypeID( "T   " );
                desc177.putInteger( id1910, inText.length );
                var id1911 = stringIDToTypeID( "paragraphStyle" );
                    var desc178 = new ActionDescriptor();
                    var id1912 = charIDToTypeID( "Algn" );
                    var id1913 = charIDToTypeID( "Alg " );
                    desc178.putEnumerated( id1912, id1913, alignment );
                    var id1915 = stringIDToTypeID( "firstLineIndent" );
                    var id1916 = charIDToTypeID( "#Pxl" );
                    desc178.putUnitDouble( id1915, id1916, 0.000000 );
                    var id1917 = stringIDToTypeID( "startIndent" );
                    var id1918 = charIDToTypeID( "#Pxl" );
                    desc178.putUnitDouble( id1917, id1918, 0.000000 );
                    var id1919 = stringIDToTypeID( "endIndent" );
                    var id1920 = charIDToTypeID( "#Pxl" );
                    desc178.putUnitDouble( id1919, id1920, 0.000000 );
                    var id1921 = stringIDToTypeID( "spaceBefore" );
                    var id1922 = charIDToTypeID( "#Pxl" );
                    desc178.putUnitDouble( id1921, id1922, 0.000000 );
                    var id1923 = stringIDToTypeID( "spaceAfter" );
                    var id1924 = charIDToTypeID( "#Pxl" );
                    desc178.putUnitDouble( id1923, id1924, 0.000000 );
                    var id1925 = stringIDToTypeID( "dropCapMultiplier" );
                    desc178.putInteger( id1925, 1 );
                    var id1926 = stringIDToTypeID( "autoLeadingPercentage" );
                    desc178.putDouble( id1926, 1.200000 );
                    var id1927 = stringIDToTypeID( "leadingType" );
                    var id1928 = stringIDToTypeID( "leadingType" );
                    var id1929 = stringIDToTypeID( "leadingBelow" );
                    desc178.putEnumerated( id1927, id1928, id1929 );
                    var id1930 = stringIDToTypeID( "hyphenate" );
                    desc178.putBoolean( id1930, false ); // was true
                    var id1931 = stringIDToTypeID( "hyphenateWordSize" );
                    desc178.putInteger( id1931, 6 );
                    var id1932 = stringIDToTypeID( "hyphenatePreLength" );
                    desc178.putInteger( id1932, 2 );
                    var id1933 = stringIDToTypeID( "hyphenatePostLength" );
                    desc178.putInteger( id1933, 2 );
                    var id1934 = stringIDToTypeID( "hyphenateLimit" );
                    desc178.putInteger( id1934, 0 );
                    var id1935 = stringIDToTypeID( "hyphenationZone" );
                    desc178.putDouble( id1935, 36.000000 );
                    var id1936 = stringIDToTypeID( "hyphenateCapitalized" );
                    desc178.putBoolean( id1936, true );
                    var id1937 = stringIDToTypeID( "hyphenationPreference" );
                    desc178.putDouble( id1937, 0.500000 );
                    var id1938 = stringIDToTypeID( "justificationWordMinimum" );
                    desc178.putDouble( id1938, 0.800000 );
                    var id1939 = stringIDToTypeID( "justificationWordDesired" );
                    desc178.putDouble( id1939, 1.000000 );
                    var id1940 = stringIDToTypeID( "justificationWordMaximum" );
                    desc178.putDouble( id1940, 1.330000 );
                    var id1941 = stringIDToTypeID( "justificationLetterMinimum" );
                    desc178.putDouble( id1941, 0.000000 );
                    var id1942 = stringIDToTypeID( "justificationLetterDesired" );
                    desc178.putDouble( id1942, 0.000000 );
                    var id1943 = stringIDToTypeID( "justificationLetterMaximum" );
                    desc178.putDouble( id1943, 0.000000 );
                    var id1944 = stringIDToTypeID( "justificationGlyphMinimum" );
                    desc178.putDouble( id1944, 1.000000 );
                    var id1945 = stringIDToTypeID( "justificationGlyphDesired" );
                    desc178.putDouble( id1945, 1.000000 );
                    var id1946 = stringIDToTypeID( "justificationGlyphMaximum" );
                    desc178.putDouble( id1946, 1.000000 );
                    var id1947 = stringIDToTypeID( "singleWordJustification" );
                    var id1948 = charIDToTypeID( "Alg " );
                    var id1949 = charIDToTypeID( "JstA" );
                    desc178.putEnumerated( id1947, id1948, id1949 );
                    var id1950 = stringIDToTypeID( "hangingRoman" );
                    desc178.putBoolean( id1950, false );
                    var id1951 = stringIDToTypeID( "autoTCY" );
                    desc178.putInteger( id1951, 1 );
                    var id1952 = stringIDToTypeID( "keepTogether" );
                    desc178.putBoolean( id1952, false );
                    var id1953 = stringIDToTypeID( "burasagari" );
                    var id1954 = stringIDToTypeID( "burasagari" );
                    var id1955 = stringIDToTypeID( "burasagariNone" );
                    desc178.putEnumerated( id1953, id1954, id1955 );
                    var id1956 = stringIDToTypeID( "preferredKinsokuOrder" );
                    var id1957 = stringIDToTypeID( "preferredKinsokuOrder" );
                    var id1958 = stringIDToTypeID( "pushIn" );
                    desc178.putEnumerated( id1956, id1957, id1958 );
                    var id1959 = stringIDToTypeID( "kurikaeshiMojiShori" );
                    desc178.putBoolean( id1959, false );
                    var id1960 = stringIDToTypeID( "mojiKumiName" );
                    desc178.putString( id1960, "None" );
                    var id1961 = stringIDToTypeID( "textEveryLineComposer" );
                    desc178.putBoolean( id1961, false );
                    var id1962 = stringIDToTypeID( "defaultTabWidth" );
                    desc178.putDouble( id1962, 36.000000 );
                    var id1963 = stringIDToTypeID( "defaultStyle" );
                        var desc179 = new ActionDescriptor();
                        var id1964 = stringIDToTypeID( "fontPostScriptName" );
                        desc179.putString( id1964, GetPostScriptName( fontName ) );
                        var id1965 = charIDToTypeID( "FntN" );
                        desc179.putString( id1965, fontName );
                        var id1966 = charIDToTypeID( "FntS" );
                        desc179.putString( id1966, "Medium" );
                        var id1967 = charIDToTypeID( "Scrp" );
                        desc179.putInteger( id1967, 0 );
                        var id1968 = charIDToTypeID( "FntT" );
                        desc179.putInteger( id1968, 0 );
                        var id1969 = charIDToTypeID( "Sz  " );
                        var id1970 = charIDToTypeID( "#Pxl" );
                        desc179.putUnitDouble( id1969, id1970, 12.000000 );
                        var id1971 = charIDToTypeID( "HrzS" );
                        desc179.putDouble( id1971, 100.000000 );
                        var id1972 = charIDToTypeID( "VrtS" );
                        desc179.putDouble( id1972, 100.000000 );
                        var id1973 = stringIDToTypeID( "syntheticBold" );
                        desc179.putBoolean( id1973, false );
                        var id1974 = stringIDToTypeID( "syntheticItalic" );
                        desc179.putBoolean( id1974, false );
                        var id1975 = stringIDToTypeID( "autoLeading" );
                        desc179.putBoolean( id1975, true );
                        var id1976 = charIDToTypeID( "Trck" );
                        desc179.putInteger( id1976, 0 );
                        var id1977 = charIDToTypeID( "Bsln" );
                        var id1978 = charIDToTypeID( "#Pxl" );
                        desc179.putUnitDouble( id1977, id1978, 0.000000 );
                        var id1979 = stringIDToTypeID( "characterRotation" );
                        desc179.putDouble( id1979, 0.000000 );
                        var id1980 = stringIDToTypeID( "fontCaps" );
                        var id1981 = stringIDToTypeID( "fontCaps" );
                        var id1982 = charIDToTypeID( "Nrml" );
                        desc179.putEnumerated( id1980, id1981, id1982 );
                        var id1983 = stringIDToTypeID( "baseline" );
                        var id1984 = stringIDToTypeID( "baseline" );
                        var id1985 = charIDToTypeID( "Nrml" );
                        desc179.putEnumerated( id1983, id1984, id1985 );
                        var id1986 = stringIDToTypeID( "otbaseline" );
                        var id1987 = stringIDToTypeID( "otbaseline" );
                        var id1988 = charIDToTypeID( "Nrml" );
                        desc179.putEnumerated( id1986, id1987, id1988 );
                        var id1989 = stringIDToTypeID( "strikethrough" );
                        var id1990 = stringIDToTypeID( "strikethrough" );
                        var id1991 = stringIDToTypeID( "strikethroughOff" );
                        desc179.putEnumerated( id1989, id1990, id1991 );
                        var id1992 = charIDToTypeID( "Undl" );
                        var id1993 = charIDToTypeID( "Undl" );
                        var id1994 = stringIDToTypeID( "underlineOff" );
                        desc179.putEnumerated( id1992, id1993, id1994 );
                        var id1995 = stringIDToTypeID( "underlineOffset" );
                        var id1996 = charIDToTypeID( "#Pxl" );
                        desc179.putUnitDouble( id1995, id1996, 0.000000 );
                        var id1997 = stringIDToTypeID( "ligature" );
                        desc179.putBoolean( id1997, true );
                        var id1998 = stringIDToTypeID( "altligature" );
                        desc179.putBoolean( id1998, false );
                        var id1999 = stringIDToTypeID( "contextualLigatures" );
                        desc179.putBoolean( id1999, false );
                        var id2000 = stringIDToTypeID( "alternateLigatures" );
                        desc179.putBoolean( id2000, false );
                        var id2001 = stringIDToTypeID( "oldStyle" );
                        desc179.putBoolean( id2001, false );
                        var id2002 = stringIDToTypeID( "fractions" );
                        desc179.putBoolean( id2002, false );
                        var id2003 = stringIDToTypeID( "ordinals" );
                        desc179.putBoolean( id2003, false );
                        var id2004 = stringIDToTypeID( "swash" );
                        desc179.putBoolean( id2004, false );
                        var id2005 = stringIDToTypeID( "titling" );
                        desc179.putBoolean( id2005, false );
                        var id2006 = stringIDToTypeID( "connectionForms" );
                        desc179.putBoolean( id2006, false );
                        var id2007 = stringIDToTypeID( "stylisticAlternates" );
                        desc179.putBoolean( id2007, false );
                        var id2008 = stringIDToTypeID( "ornaments" );
                        desc179.putBoolean( id2008, false );
                        var id2009 = stringIDToTypeID( "figureStyle" );
                        var id2010 = stringIDToTypeID( "figureStyle" );
                        var id2011 = charIDToTypeID( "Nrml" );
                        desc179.putEnumerated( id2009, id2010, id2011 );
                        var id2012 = stringIDToTypeID( "proportionalMetrics" );
                        desc179.putBoolean( id2012, false );
                        var id2013 = stringIDToTypeID( "kana" );
                        desc179.putBoolean( id2013, false );
                        var id2014 = stringIDToTypeID( "italics" );
                        desc179.putBoolean( id2014, false );
                        var id2015 = stringIDToTypeID( "ruby" );
                        desc179.putBoolean( id2015, false );
                        var id2016 = stringIDToTypeID( "baselineDirection" );
                        var id2017 = stringIDToTypeID( "baselineDirection" );
                        var id2018 = charIDToTypeID( "Rtt " );
                        desc179.putEnumerated( id2016, id2017, id2018 );
                        var id2019 = stringIDToTypeID( "textLanguage" );
                        var id2020 = stringIDToTypeID( "textLanguage" );
                        var id2021 = stringIDToTypeID( "englishLanguage" );
                        desc179.putEnumerated( id2019, id2020, id2021 );
                        var id2022 = stringIDToTypeID( "mojiZume" );
                        desc179.putDouble( id2022, 0.000000 );
                        var id2023 = stringIDToTypeID( "gridAlignment" );
                        var id2024 = stringIDToTypeID( "gridAlignment" );
                        var id2025 = stringIDToTypeID( "roman" );
                        desc179.putEnumerated( id2023, id2024, id2025 );
                        var id2026 = stringIDToTypeID( "enableWariChu" );
                        desc179.putBoolean( id2026, false );
                        var id2027 = stringIDToTypeID( "wariChuCount" );
                        desc179.putInteger( id2027, 2 );
                        var id2028 = stringIDToTypeID( "wariChuLineGap" );
                        desc179.putInteger( id2028, 0 );
                        var id2029 = stringIDToTypeID( "wariChuScale" );
                        desc179.putDouble( id2029, 0.500000 );
                        var id2030 = stringIDToTypeID( "wariChuWidow" );
                        desc179.putInteger( id2030, 2 );
                        var id2031 = stringIDToTypeID( "wariChuOrphan" );
                        desc179.putInteger( id2031, 2 );
                        var id2032 = stringIDToTypeID( "wariChuJustification" );
                        var id2033 = stringIDToTypeID( "wariChuJustification" );
                        var id2034 = stringIDToTypeID( "wariChuAutoJustify" );
                        desc179.putEnumerated( id2032, id2033, id2034 );
                        var id2035 = stringIDToTypeID( "tcyUpDown" );
                        desc179.putInteger( id2035, 0 );
                        var id2036 = stringIDToTypeID( "tcyLeftRight" );
                        desc179.putInteger( id2036, 0 );
                        var id2037 = stringIDToTypeID( "leftAki" );
                        var id2038 = charIDToTypeID( "#Pxl" );
                        desc179.putUnitDouble( id2037, id2038, -1.000000 );
                        var id2039 = stringIDToTypeID( "rightAki" );
                        var id2040 = charIDToTypeID( "#Pxl" );
                        desc179.putUnitDouble( id2039, id2040, -1.000000 );
                        var id2041 = stringIDToTypeID( "jiDori" );
                        desc179.putInteger( id2041, 0 );
                        var id2042 = stringIDToTypeID( "noBreak" );
                        desc179.putBoolean( id2042, false );
                        var id2043 = charIDToTypeID( "Clr " );
                            var desc180 = new ActionDescriptor();
                            var id2044 = charIDToTypeID( "Rd  " );
                            desc180.putDouble( id2044, textColor.rgb.red );
                            var id2045 = charIDToTypeID( "Grn " );
                            desc180.putDouble( id2045, textColor.rgb.green );
                            var id2046 = charIDToTypeID( "Bl  " );
                            desc180.putDouble( id2046, textColor.rgb.blue );
                        var id2047 = charIDToTypeID( "RGBC" );
                        desc179.putObject( id2043, id2047, desc180 );
                        var id2048 = stringIDToTypeID( "strokeColor" );
                            var desc181 = new ActionDescriptor();
                            var id2049 = charIDToTypeID( "Rd  " );
                            desc181.putDouble( id2049, 0.000000 );
                            var id2050 = charIDToTypeID( "Grn " );
                            desc181.putDouble( id2050, 0.000000 );
                            var id2051 = charIDToTypeID( "Bl  " );
                            desc181.putDouble( id2051, 0.000000 );
                        var id2052 = charIDToTypeID( "RGBC" );
                        desc179.putObject( id2048, id2052, desc181 );
                        var id2053 = charIDToTypeID( "Fl  " );
                        desc179.putBoolean( id2053, true );
                        var id2054 = charIDToTypeID( "Strk" );
                        desc179.putBoolean( id2054, false );
                        var id2055 = stringIDToTypeID( "fillFirst" );
                        desc179.putBoolean( id2055, true );
                        var id2056 = stringIDToTypeID( "fillOverPrint" );
                        desc179.putBoolean( id2056, false );
                        var id2057 = stringIDToTypeID( "strokeOverPrint" );
                        desc179.putBoolean( id2057, false );
                        var id2058 = stringIDToTypeID( "lineCap" );
                        var id2059 = stringIDToTypeID( "lineCap" );
                        var id2060 = stringIDToTypeID( "buttCap" );
                        desc179.putEnumerated( id2058, id2059, id2060 );
                        var id2061 = stringIDToTypeID( "lineJoin" );
                        var id2062 = stringIDToTypeID( "lineJoin" );
                        var id2063 = stringIDToTypeID( "miterJoin" );
                        desc179.putEnumerated( id2061, id2062, id2063 );
                        var id2064 = stringIDToTypeID( "lineWidth" );
                        var id2065 = charIDToTypeID( "#Pxl" );
                        desc179.putUnitDouble( id2064, id2065, 1.000000 );
                        var id2066 = stringIDToTypeID( "miterLimit" );
                        var id2067 = charIDToTypeID( "#Pxl" );
                        desc179.putUnitDouble( id2066, id2067, 4.000000 );
                        var id2068 = stringIDToTypeID( "lineDashoffset" );
                        desc179.putDouble( id2068, 0.000000 );
                    var id2069 = charIDToTypeID( "TxtS" );
                    desc178.putObject( id1963, id2069, desc179 );
                var id2070 = stringIDToTypeID( "paragraphStyle" );
                desc177.putObject( id1911, id2070, desc178 );
            var id2071 = stringIDToTypeID( "paragraphStyleRange" );
            list22.putObject( id2071, desc177 );
        desc167.putList( id1908, list22 );
        var id2072 = stringIDToTypeID( "kerningRange" );
            var list23 = new ActionList();
        desc167.putList( id2072, list23 );
    var id2073 = charIDToTypeID( "TxLr" );
    desc166.putObject( id1727, id2073, desc167 );
	executeAction( id1724, desc166, DialogModes.NO );
}


///////////////////////////////////////////////////////////////////////////////
// Function: ConditionalModeChangeToRGB
// Usage: Switch the mode to RGB using the automation plug-in
///////////////////////////////////////////////////////////////////////////////
function ConditionalModeChangeToRGB() {
	var eventModeChange = stringIDToTypeID( "8cba8cd6-cb66-11d1-bc43-0060b0a13dc4" );
	var descSource = new ActionDescriptor();
	var keySourceMode = charIDToTypeID( "SrcM" );
	var list = new ActionList();
	var keyCondition = charIDToTypeID( "Cndn" );
	var keyBitmap = charIDToTypeID( "UBtm" );
	var keyGrayscale = charIDToTypeID( "UGry" );
	var keyDuotone = charIDToTypeID( "UDtn" );
	var keyIndex = charIDToTypeID( "UInd" );
	var keyRGB = charIDToTypeID( "URGB" );
	var keyCMYK = charIDToTypeID( "UCMY" );
	var keyLab = charIDToTypeID( "ULab" );
	var keyMultichannel = charIDToTypeID( "UMlt" );
	list.putEnumerated( keyCondition, keyBitmap );
	list.putEnumerated( keyCondition, keyGrayscale );
	list.putEnumerated( keyCondition, keyDuotone );
	list.putEnumerated( keyCondition, keyIndex );
	list.putEnumerated( keyCondition, keyRGB );
	list.putEnumerated( keyCondition, keyCMYK );
	list.putEnumerated( keyCondition, keyLab );
	list.putEnumerated( keyCondition, keyMultichannel );
	descSource.putList( keySourceMode, list );
	var keyDestination = charIDToTypeID( "DstM" );
	var descDest = new ActionDescriptor();
	var keyRGB = charIDToTypeID( "RGBM" );
	descSource.putObject( keyDestination, keyRGB, descDest );
	executeAction( eventModeChange, descSource, DialogModes.NO );
}


/////////////////////////////////////////////////////////////////////
// Function: ConvertTosRGBProfile
// Input: Change the current profile to sRGB
/////////////////////////////////////////////////////////////////////
function ConvertTosRGBProfile() {
	app.activeDocument.convertProfile("sRGB IEC61966-2.1", Intent.RELATIVECOLORIMETRIC, true, true);
}


/////////////////////////////////////////////////////////////////////
// Function: FitImage
// Input: use the fit image automation plug-in to do this work for me
/////////////////////////////////////////////////////////////////////
function FitImage( p ) {
	var sizes = [[640, 480], [1024, 768], [1800, 1200], [3000, 2400]];
	var index = 0;
	if ( p.px[0] )
		index = 0;
	else if ( p.px[1] )
		index = 1;
	else if ( p.px[2] )
		index = 2;
	else if ( p.px[3] )
		index = 3;
	var desc = new ActionDescriptor();
	var unitPixels = charIDToTypeID( '#Pxl' );
	if ( app.activeDocument.width.value < app.activeDocument.height.value ) {
		var temp = sizes[index][0];
		sizes[index][0] = sizes[index][1];
		sizes[index][1] = temp;
	}
	desc.putUnitDouble( charIDToTypeID( 'Wdth' ), unitPixels, sizes[index][0] );
	desc.putUnitDouble( charIDToTypeID( 'Hght' ), unitPixels, sizes[index][1] );
	var runtimeEventID = stringIDToTypeID( '3caa3434-cb67-11d1-bc43-0060b0a13dc4' );	
	executeAction( runtimeEventID, desc, DialogModes.NO );
	return sizes[index];
}
// End Dr. Brown's Caption Maker.jsx
