// c2007 Adobe Systems, Inc. All rights reserved
// Written by Mike Shaw
// UI design by Dr. Russell Brown ( a.k.a. Russell Preston Brown) and Mike Shaw
// 10/27/2007 14:51
// 10/15/2007 changed default setting for interlace to off (line78)

/*
@@@BUILDINFO@@@ Dr. Brown's Fit Video to Audio.jsx 1.0.0.0
*/

/*
<javascriptresource>
<about>$$$/JavaScripts/DrBrownFitVideoToAudio/About=Dr. Brown's Fit Video to Audio^r^rCopyright 2007 Adobe Systems Incorporated. All rights reserved.^r^rMake a video file the same length as an audio file.^r</about>
<category>DrBrown</category>
</javascriptresource>
*/

try {



	if ( ! app.featureEnabled("photoshop/extended") ) {
		
		throw("You need the Extended version of Adobe Photoshop CS3 to run this script.");
	
	}

	var drBrown = app.path+"/Presets/Scripts/icons/DrBrownImageLeft.png";
	var drBrownPath = new File(app.path+"/Presets/Scripts/icons/DrBrownImageLeft.png");

	MaybeShowWarningDialog();

	main();
}
catch(e){
		alert(e);
		}

function main() {
	var audioFile = PickAFile("Please open the audio file");
	if (null == audioFile) return;

	var audioDoc = audioFile.name

	var videoFile = PickAFile("Please open the video file");
	if (null == videoFile) return;
	var videoDoc = videoFile.name
	
	

	app.activeDocument =  app.documents.getByName(audioDoc)
	app.activeDocument.activeLayer.name= "Audio"
	var audioFrameCount =  GetFrameCount()
	var audioFrameRate = GetDocFrameRate()
	var audioTime = audioFrameCount / audioFrameRate

	app.activeDocument = app.documents.getByName(videoDoc)
	app.activeDocument.activeLayer.name= "Video"
	var videoFrameCount =  GetFrameCount()
	var videoFrameRate = GetDocFrameRate()
	var videoTime = videoFrameCount / videoFrameCount

	frameRateToFit = videoFrameCount/audioTime
	//frameRateToFit = videoFrameRate / frameRateMult


	var doInterlace = false
	var interpMethod = "x"
	var useField = "Upper"

		////////////////Interlace dialog start/////////////////////////////////

		var dlg = new Window('dialog',"Do you want to De-Interlace your video?");
			
		var uiPnl = dlg.uiPnl =dlg.add("group",undefined);

		var maingroup = dlg.uiPnl.maingroup=dlg.uiPnl.add("group",undefined);
		maingroup.orientation = ["column"];
		maingroup.alignment="top";

		var interBox = maingroup.add("checkbox",undefined, "De-Interlace");
		interBox.value = false;
		var doInterlace = interBox.value;
		interBox.alignment ="left";
		interBox.onClick = function(){deIntOpt.enabled = this.value; doInterlace = this.value;}
		
		var deIntOpt = maingroup.add("panel", undefined,"De-Interlace Options");
		deIntOpt.enabled = interBox.value;
		

		deIntOpt.fieldGrp = deIntOpt.add("group", undefined);
		deIntOpt.fieldGrp.orientation = "row";
		deIntOpt.fieldGrp.alignment = "right";
		deIntOpt.fieldGrp.useTxt = deIntOpt.fieldGrp.add("statictext",undefined,"Use:");
		deIntOpt.fieldGrp.dropList = deIntOpt.fieldGrp.add("dropdownlist", undefined,["Upper Field", "Lower Field"])
		var useField = deIntOpt.fieldGrp.dropList.items[0].text;
		deIntOpt.fieldGrp.dropList.items[0].selected=true;
		deIntOpt.fieldGrp.dropList.onChange = function(){ useField = this.selection.text}

		deIntOpt.methGrp = deIntOpt.add("group",undefined);
		deIntOpt.methGrp.methTxt = deIntOpt.methGrp.add("statictext", undefined, "Method:");
		deIntOpt.methGrp.methDropList = deIntOpt.methGrp.add("dropdownlist", undefined,["Duplicate", "Interpolation"]);
		deIntOpt.methGrp.methDropList.items[1].selected=true;
		var interpMethod = deIntOpt.methGrp.methDropList.items[1].text;
		deIntOpt.methGrp.methDropList.onChange = function(){ interpMethod = this.selection.text}


		dlg.panel3=dlg.uiPnl.add("group");
		dlg.panel3.orientation = "column";
		dlg.panel3.alignment = "top";
		dlg.panel3.buildBtn = dlg.panel3.add('button', undefined, 'OK',
		{name:'ok'});
		dlg.panel3.cancelBtn = dlg.panel3.add('button', undefined, 'Cancel',
		{name:'cancel'});
		
		if (drBrownPath.exists == true){
		dlg.imageDisplay = dlg.panel3.add('image',undefined,drBrown   )}
	////////////////////////////////End of Interlace dialog//////////////////////////////////

			if ( 1 == dlg.show() ) {	
				
					if ( useField == "Upper Field"){useField = "Upr "}
					else useField = "Lwr ";
					
					InterpretFootage(doInterlace, interpMethod, useField, frameRateToFit)

					var newFrameCount = (videoFrameRate / frameRateToFit) *  videoFrameCount;
							
							if (newFrameCount < videoFrameCount){
								var frameNumber = newFrameCount;
								SetFrame(frameNumber - 1)
								SetWorkOutTime(videoFrameRate)
								SetFrameCount(newFrameCount)
								}
							
							if (newFrameCount > videoFrameCount){
								var frameRange = newFrameCount;
								SetFrameCount(frameRange)
								}

					app.activeDocument =  app.documents.getByName(audioDoc)
					var destination = videoDoc;
					DupeLayer(destination)

					app.activeDocument.close(SaveOptions.DONOTSAVECHANGES)
					SetFrame(0)
			}

}// end of main

/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////

function InterpretFootage(doInterlace, interpMethod, useField, frameRateToFit){
// =======================================================
var id522 = stringIDToTypeID( "interpretFootage" );
    var desc101 = new ActionDescriptor();
    var id523 = charIDToTypeID( "Vrsn" );
    desc101.putInteger( id523, 1 );
    var id524 = stringIDToTypeID( "interpretAlpha" );
    var id525 = stringIDToTypeID( "alphaInterpretation" );
    var id526 = charIDToTypeID( "Ignr" );
    desc101.putEnumerated( id524, id525, id526 );
	
	if (doInterlace == true){
		if (interpMethod == "Interpolation"){
		var id527 = stringIDToTypeID( "deinterlaceMethod" );
		var id528 = stringIDToTypeID( "deinterlaceMethod" );
		var id529 = charIDToTypeID( "Intr" );}
		
		if(interpMethod =="Duplicate"){
		var id527 = stringIDToTypeID( "deinterlaceMethod" );
		var id528 = stringIDToTypeID( "deinterlaceMethod" );
		var id529 = stringIDToTypeID( "duplication" );}
		
		desc101.putEnumerated( id527, id528, id529 );
		var id530 = stringIDToTypeID( "useField" );
		var id531 = stringIDToTypeID( "videoField" );
		var id532 = charIDToTypeID( useField );
		desc101.putEnumerated( id530, id531, id532 );

	}
	
    var id533 = stringIDToTypeID( "frameRate" );
    desc101.putDouble( id533, frameRateToFit );
    var id534 = stringIDToTypeID( "colorConvertAlterations" );
    desc101.putBoolean( id534, false );
executeAction( id522, desc101, DialogModes.NO );}




function GetFrameCount()
/*this function gets the document length 
    in number of frames and returns value.
*/
{
	var getID = charIDToTypeID( 'getd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var frameCountID = stringIDToTypeID( "frameCount" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, frameCountID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	
	var resultDesc = executeAction( getID, descriptor, DialogModes.NO );
	
	return resultDesc.getInteger( frameCountID );
}



function GetDocFrameRate()
/* Gets frame rate of the current document.
	*/
{
	var getID = charIDToTypeID( 'getd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var frameRateID = stringIDToTypeID( "frameRate" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, frameRateID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	
	var resultDesc = executeAction( getID, descriptor, DialogModes.NO );
	
	return resultDesc.getDouble( frameRateID );
}


// ==DupeLayer=====================================
function DupeLayer(destination){
var id467 = charIDToTypeID( "Dplc" );
    var desc106 = new ActionDescriptor();
    var id468 = charIDToTypeID( "null" );
        var ref41 = new ActionReference();
        var id469 = charIDToTypeID( "Lyr " );
        var id470 = charIDToTypeID( "Ordn" );
        var id471 = charIDToTypeID( "Trgt" );
        ref41.putEnumerated( id469, id470, id471 );
    desc106.putReference( id468, ref41 );
    var id472 = charIDToTypeID( "T   " );
        var ref42 = new ActionReference();
        var id473 = charIDToTypeID( "Dcmn" );
        ref42.putName( id473, destination );
    desc106.putReference( id472, ref42 );
    var id474 = charIDToTypeID( "Vrsn" );
    desc106.putInteger( id474, 2 );
executeAction( id467, desc106, DialogModes.NO );}


function SetFrame(frameNumber)
{
	var setID = charIDToTypeID( 'setd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var currentFrameID = stringIDToTypeID( "currentFrame" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, currentFrameID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	descriptor.putInteger( currentFrameID, frameNumber );
	
	executeAction( setID, descriptor, DialogModes.NO );
}

function SetWorkOutTime(origframeRate){
		

	//alert("Current Time:"+GetCurrentTime())

	//Get timecode values for current time.
	var timecode = new Array ()
	timecode = GetCurrentTime()

	//force variables to numbers by adding zero
	var hours=timecode[0]+0
	var minutes =timecode[1]+0
	var seconds = timecode[2]+0
	var frame = timecode[3]+0

	//alert("hours"+timecode[0])
	SetWorkOutTime(hours, minutes, seconds, frame)


	function GetCurrentTime()
	{
		var getID = charIDToTypeID( 'getd' );
		var nullID = charIDToTypeID( 'null' );
		var propID = charIDToTypeID( 'Prpr' );
		
		var timelineID = stringIDToTypeID( "timeline" );
		var timeID = stringIDToTypeID( "time" );
		
		var actionRef = new ActionReference();

		actionRef.putProperty( propID, timeID );
		actionRef.putClass( timelineID );

		var descriptor = new ActionDescriptor();
		descriptor.putReference( nullID, actionRef );
		
		var resultDesc = executeAction( getID, descriptor, DialogModes.NO );
		
			//Use this to display result as Timecode display. Note values of zero only show one zero, not two
		return TimecodeDisplay(resultDesc.getObjectValue( timeID ));
		
		//Use this to display result as Seconds.
		//return TimecodeToSeconds(resultDesc.getObjectValue( durationID ));

		//Use this to display result as Frames.
		//return TimecodeToFrames(resultDesc.getObjectValue( durationID ));
	}

	function TimecodeDisplay(timecodeDesc)
	{
		// We have to use all these try blocks because some values may not be present.
		// For example, for documents with a duration under an hour, the hour value will be omitted.

		var frame = 00;
		try {
			var frameID = stringIDToTypeID( "frame" );
			frame = timecodeDesc.getInteger(frameID);
		}
		catch(e) {
		}

		var seconds = 00;
		try {
			var secondsID = stringIDToTypeID( "seconds" );
			seconds = timecodeDesc.getInteger(secondsID);
		}
		catch(e) {
		}

		var minutes = 00;
		try {
			var minutesID = stringIDToTypeID( "minutes" );
			minutes = timecodeDesc.getInteger(minutesID);
		}
		catch(e) {
		}

		var hours = 00;
		try {
			var hoursID = stringIDToTypeID( "hours" );
			hours = timecodeDesc.getInteger(hoursID);
		}
		catch(e) {
		}

		var frameRate = origframeRate;
		try {
			var frameRateID = stringIDToTypeID( "frameRate" );
			frameRate = timecodeDesc.getDouble(frameRateID);
		}
		catch(e) {
		}
		
		var timecode = new Array()
		timecode = [hours, minutes, seconds, frame]	
		//var timecode = hours +":" + minutes +":" + seconds  +":" + frame
		return timecode
	}

	// ==============Set Work Out Point====================
	// Note data is in timecode (hour,min,sec,frame)
	// use CurrentTimecode.jsx for currrent timecode


	function SetWorkOutTime(hours, minutes, seconds, frame)
	{
			var id566 = charIDToTypeID( "setd" );
			var desc152 = new ActionDescriptor();
			var id567 = charIDToTypeID( "null" );
			var ref39 = new ActionReference();
			var id568 = charIDToTypeID( "Prpr" );
			var id569 = stringIDToTypeID( "workOutTime" );
			ref39.putProperty( id568, id569 );
			var id570 = stringIDToTypeID( "timeline" );
			ref39.putClass( id570 );
			desc152.putReference( id567, ref39 );
			var id571 = charIDToTypeID( "T   " );
			var timecodeDescriptor = new ActionDescriptor();
			var hoursID = stringIDToTypeID ("hours")
			timecodeDescriptor.putInteger( hoursID, hours);
			var minutesID = stringIDToTypeID ("minutes")
			timecodeDescriptor.putInteger( minutesID, minutes);
			var secondsID = stringIDToTypeID( "seconds" );
			timecodeDescriptor.putInteger( secondsID, seconds );
			var frameID = stringIDToTypeID( "frame" );
			timecodeDescriptor.putInteger( frameID, frame);
			var framerateID = stringIDToTypeID( "frameRate" );
			timecodeDescriptor.putDouble( framerateID, 30.000000 );
		var timecodeID = stringIDToTypeID( "timecode" );
		desc152.putObject( id571, timecodeID, timecodeDescriptor );
	executeAction( id566, desc152, DialogModes.NO );
	}
}


function SetFrameCount(frameRange)
{
	var setID = charIDToTypeID( 'setd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var rangeID = stringIDToTypeID( "frameCount" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, rangeID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	descriptor.putInteger( rangeID, frameRange );
	
	executeAction( setID, descriptor, DialogModes.NO );
}


function MaybeShowWarningDialog() {
	
	// a unique value for our don't show again dialog
	var uniqueID = "30d0517e-d13c-452a-9059-f089011b352b";
	var doNotShowAgain = false;
	var havePreference = false;
	
	try { 
		var d = app.getCustomOptions( uniqueID );
		var doNotShowAgain = d.getBoolean( app.stringIDToTypeID( "doNotShowAgain" ) );
		havePreference = true;
	}
	catch( e ) {
		; // may not have the key that is ok
	}

	if ( ! havePreference  || ! doNotShowAgain ) {
		
		var drBrownPath = new File(app.path+"/Presets/Scripts/icons/DrBrownImageLeft.png");

		var dlg = new Window('dialog'," A message from Dr. Brown");
		dlg.orientation = "row"

		var uiPnl = dlg.uiPnl =dlg.add("group",undefined)
		uiPnl.alignment = "top"
	
		var textgroup = dlg.uiPnl.textgroup=dlg.uiPnl.add("group",undefined)
	
		var textPanel = textgroup.add("panel",undefined)
	
		var textBlock = textPanel.add("statictext", undefined, undefined,{multiline:true})

		//textBlock.text = "Welcome to Dr. Brown's \n"+"Fit Video to Audio script. \r"+ "\r"+
		//					"First, I will ask you to choose the audio file that you want to use.  \r"+ "\r"+
		//					"I will then ask you to select the video file we are going to fit to the audio. \r"+ "\r"+
		//					"Finally, I will ask you to choose the video De-Interlace options you want to use, if any.";
																					
		textBlock.text = "Welcome to Dr. Brown's \n"+"Fit Video to Audio script. \r"+ "\r"+
							"Step #1: In the first dialog, select the audio file for your project.  \r"+ "\r"+
							"Step #2: In the second dialog, select the video file that will be fit to the audio. \r"+ "\r"+
							"Step #3: In the third dialog, select video De-Interlace options if necessary.";
															
		var buttonBlock = uiPnl.buttonBlock=uiPnl.add("group",undefined)											
		buttonBlock.orientation = ["column"]
	
		buttonBlock.okBtn = buttonBlock.add('button', undefined, 'OK', {name:'ok'});
		buttonBlock.okBtn.alignment="center"

		if (drBrownPath.exists == true) {
			dlg.imageDisplay = buttonBlock.add('image',undefined,drBrownPath   )
			dlg.imageDisplay.alignment =[ "bottom", 'right']
		}
	
		var doNotShowAgainBtn = buttonBlock.add("checkbox",undefined, "Don't show again");
		doNotShowAgainBtn.value = doNotShowAgain;
		doNotShowAgainBtn.alignment ="bottom"
			
		dlg.show()
		
		doNotShowAgain = doNotShowAgainBtn.value;
		
		var d = new ActionDescriptor();
		d.putBoolean( app.stringIDToTypeID( "doNotShowAgain" ), doNotShowAgain );
		app.putCustomOptions( uniqueID, d );

	}
}

function PickAFile(dialogText) {
	var goodfile = false
	while (goodfile == false){	
		try {
			var aFile = File.openDialog (dialogText)
			if (null == aFile) return aFile;
			var aFile = app.open(aFile);
			if ( activeDocument.activeLayer.kind != LayerKind.VIDEO ) {

				alert ("You need a video/audio file, please pick again");
						
				app.activeDocument.close(SaveOptions.DONOTSAVECHANGES)

			} else { 
				goodfile = true
			}
		}
		catch(e) {
			alert('That was not a valid file, please try again.'); // do nothing and try again
		}
	}
	return aFile;
}

// end Dr. Brown's Fit Video to Audio.jsx
