//c2007 Adobe Systems, Inc. All rights reserved
// Written by Mike Shaw
// UI design by Dr. Russell Brown ( a.k.a. Russell Preston Brown) and Mike Shaw
// 10/26/2007 14:51
// 10/15/2007 set interlace default to false, added line 77 to dim interlace options on initial launch

/*
@@@BUILDINFO@@@ Dr. Brown's Interpret Footage.jsx 1.0.0.0
*/

/*
<javascriptresource>
<about>$$$/JavaScripts/DrBrownInterpretFootage/About=Dr. Brown's Interpret Footage^r^rCopyright 2007 Adobe Systems Incorporated. All rights reserved.^r^rAn easier to use dialog for interpreting your video footage.^r</about>
<category>DrBrown</category>
</javascriptresource>
*/


try {



	if ( ! app.featureEnabled("photoshop/extended") ) {
		
		throw("You need the Extended version of Adobe Photoshop CS3 to run this script.");
	
	}

	if ( documents.length == 0 ) {

		throw("You need a file open and a movie layer selected.");

	}

	
	if ( activeDocument.activeLayer.kind != LayerKind.VIDEO ) {

		throw("You need a video layer.");

	}


	var drBrown = app.path+"/Presets/Scripts/icons/DrBrownImageLeft.png";
	var drBrownPath = new File(app.path+"/Presets/Scripts/icons/DrBrownImageLeft.png");



	var frameRate = 30

	var dlg = new Window('dialog',"Dr. Brown's Interpret Footage");
	//dlg.orientation = "stack"
	
	//dlg.orientation = "stack";
	//dlg.imageDisplay = dlg.add('image',undefined,backImage  )

	var uiPnl = dlg.uiPnl =dlg.add("group",undefined)
	//uiPnl.alignment = "top"

	//create a main group to hold the rest of the items so we can stack on top of the image
	var maingroup = dlg.uiPnl.maingroup=dlg.uiPnl.add("group",undefined)
	maingroup.alignment = "top"
	maingroup.orientation = "column"

	var frameR = maingroup.add("group", undefined);
	frameR.orientation = "row";
	frameR.alignment ="left"
	frameR.frText = frameR.add("statictext",undefined, "Frame Rate:");
	frameR.frField = frameR.add("edittext");
	frameR.frField.minimumSize.width = 50;
	frameR.frField.active = true
	frameR.frField.text = frameRate
	frameR.frField.onChange = function(){ frameRate = this.text;}

	frameR.frText2 = frameR.add("statictext",undefined, "fps");

	var interBox = maingroup.add("checkbox",undefined, "De-Interlace");
	interBox.value =false;
	var doInterlace = interBox.value
	interBox.alignment ="left"
	interBox.onClick = function(){deIntOpt.enabled = this.value; doInterlace = this.value;}
	var deIntOpt = maingroup.add("panel", undefined,"De-Interlace Options")
	deIntOpt.enabled = interBox.value;

	deIntOpt.fieldGrp = deIntOpt.add("group", undefined)
	deIntOpt.fieldGrp.orientation = "row"
	deIntOpt.fieldGrp.alignment = "right"
	deIntOpt.fieldGrp.useTxt = deIntOpt.fieldGrp.add("statictext",undefined,"Use:");
	deIntOpt.fieldGrp.dropList = deIntOpt.fieldGrp.add("dropdownlist", undefined,["Upper Field", "Lower Field"])
	var useField = deIntOpt.fieldGrp.dropList.items[0].text
	deIntOpt.fieldGrp.dropList.items[0].selected=true
	deIntOpt.fieldGrp.dropList.onChange = function(){ useField = this.selection.text}

	deIntOpt.methGrp = deIntOpt.add("group",undefined)
	deIntOpt.methGrp.methTxt = deIntOpt.methGrp.add("statictext", undefined, "Method:")
	deIntOpt.methGrp.methDropList = deIntOpt.methGrp.add("dropdownlist", undefined,["Duplicate", "Interpolation"])
	deIntOpt.methGrp.methDropList.items[1].selected=true
	var interpMethod = deIntOpt.methGrp.methDropList.items[1].text
	deIntOpt.methGrp.methDropList.onChange = function(){ interpMethod = this.selection.text}


	dlg.panel3=dlg.uiPnl.add("group")
	dlg.panel3.orientation = "column"
	dlg.panel3.alignment = "top"
	dlg.panel3.buildBtn = dlg.panel3.add('button', undefined, 'OK',
	{name:'ok'});
	dlg.panel3.cancelBtn = dlg.panel3.add('button', undefined, 'Cancel',
	{name:'cancel'});
	
	if (drBrownPath.exists == true){
	dlg.imageDisplay = dlg.panel3.add('image',undefined,drBrown   )}

	dlg.panel3.buildBtn.onClick = function() {
		if ( isNaN(Number(frameRate))) {
			frameR.frField.active = true
			var goodvalue= false
			alert('Please enter a number for Frame Rate');
			return
		}
		
		if(0>=(Number(frameRate))){
			frameR.frField.active = true
			var goodvalue= false
			alert('Please enter a number greater than zero for Frame Rate');
			return
		}

	
		dlg.close(1);
	}

	if ( 1 == dlg.show() ) {
		
		//alert( "frameRate"+frameRate+ "  "+"UseField "+useField+" "+"interpMethod "+interpMethod+"  "+"doInterlace "+doInterlace)



		///////////////////////////////////////////


		if ( useField == "Upper Field"){useField = "Upr "}
		else useField = "Lwr "

		var origFrameCount = GetFrameCount()
		var origframeRate = GetDocFrameRate()
		InterpretFootage( doInterlace, interpMethod, useField, frameRate)
		var newFrameCount = (origframeRate / frameRate) *  origFrameCount
		
		if (newFrameCount < origFrameCount){
			var frameNumber = newFrameCount
			SetFrame(frameNumber - 1)
			SetWorkOutTime(origframeRate)
			SetFrameCount(newFrameCount)

			}
		
		if (newFrameCount > origFrameCount){
			var frameRange = newFrameCount
			SetFrameCount(frameRange)
			}
		}
}// end of try block
catch(e){
		alert(e);
		}
	
//////////////////////////////////////////////////////////////	
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////


// =================Video Interpret Footage======================
function InterpretFootage(doInterlace, interpMethod, useField, frameRate){
// =======================================================
var id522 = stringIDToTypeID( "interpretFootage" );
    var desc101 = new ActionDescriptor();
    var id523 = charIDToTypeID( "Vrsn" );
    desc101.putInteger( id523, 1 );
    var id524 = stringIDToTypeID( "interpretAlpha" );
    var id525 = stringIDToTypeID( "alphaInterpretation" );
    var id526 = charIDToTypeID( "Ignr" );
    desc101.putEnumerated( id524, id525, id526 );
	
	if (doInterlace == true){
		if (interpMethod == "Interpolation"){
		var id527 = stringIDToTypeID( "deinterlaceMethod" );
		var id528 = stringIDToTypeID( "deinterlaceMethod" );
		var id529 = charIDToTypeID( "Intr" );}
		
		if(interpMethod =="Duplicate"){
		var id527 = stringIDToTypeID( "deinterlaceMethod" );
		var id528 = stringIDToTypeID( "deinterlaceMethod" );
		var id529 = stringIDToTypeID( "duplication" );}
		
		desc101.putEnumerated( id527, id528, id529 );
		var id530 = stringIDToTypeID( "useField" );
		var id531 = stringIDToTypeID( "videoField" );
		var id532 = charIDToTypeID( useField );
		desc101.putEnumerated( id530, id531, id532 );

	}
	
    var id533 = stringIDToTypeID( "frameRate" );
    desc101.putDouble( id533, frameRate );
    var id534 = stringIDToTypeID( "colorConvertAlterations" );
    desc101.putBoolean( id534, false );
executeAction( id522, desc101, DialogModes.NO );}







function GetFrameCount()
/*this function gets the document length 
    in number of frames and returns value.
*/
{
	var getID = charIDToTypeID( 'getd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var frameCountID = stringIDToTypeID( "frameCount" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, frameCountID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	
	var resultDesc = executeAction( getID, descriptor, DialogModes.NO );
	
	return resultDesc.getInteger( frameCountID );
}


function SetFrame(frameNumber)
{
	var setID = charIDToTypeID( 'setd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var currentFrameID = stringIDToTypeID( "currentFrame" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, currentFrameID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	descriptor.putInteger( currentFrameID, frameNumber );
	
	executeAction( setID, descriptor, DialogModes.NO );
}



function GetDocFrameRate()
/* Gets frame rate of the current document.
	*/
{
	var getID = charIDToTypeID( 'getd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var frameRateID = stringIDToTypeID( "frameRate" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, frameRateID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	
	var resultDesc = executeAction( getID, descriptor, DialogModes.NO );
	
	return resultDesc.getDouble( frameRateID );
}

function SetWorkOutTime(origframeRate){
		

	//alert("Current Time:"+GetCurrentTime())

	//Get timecode values for current time.
	var timecode = new Array ()
	timecode = GetCurrentTime()

	//force variables to numbers by adding zero
	var hours=timecode[0]+0
	var minutes =timecode[1]+0
	var seconds = timecode[2]+0
	var frame = timecode[3]+0

	//alert("hours"+timecode[0])
	SetWorkOutTime(hours, minutes, seconds, frame)


	function GetCurrentTime()
	{
		var getID = charIDToTypeID( 'getd' );
		var nullID = charIDToTypeID( 'null' );
		var propID = charIDToTypeID( 'Prpr' );
		
		var timelineID = stringIDToTypeID( "timeline" );
		var timeID = stringIDToTypeID( "time" );
		
		var actionRef = new ActionReference();

		actionRef.putProperty( propID, timeID );
		actionRef.putClass( timelineID );

		var descriptor = new ActionDescriptor();
		descriptor.putReference( nullID, actionRef );
		
		var resultDesc = executeAction( getID, descriptor, DialogModes.NO );
		
			//Use this to display result as Timecode display. Note values of zero only show one zero, not two
		return TimecodeDisplay(resultDesc.getObjectValue( timeID ));
		
		//Use this to display result as Seconds.
		//return TimecodeToSeconds(resultDesc.getObjectValue( durationID ));

		//Use this to display result as Frames.
		//return TimecodeToFrames(resultDesc.getObjectValue( durationID ));
	}

	function TimecodeDisplay(timecodeDesc)
	{
		// We have to use all these try blocks because some values may not be present.
		// For example, for documents with a duration under an hour, the hour value will be omitted.

		var frame = 00;
		try {
			var frameID = stringIDToTypeID( "frame" );
			frame = timecodeDesc.getInteger(frameID);
		}
		catch(e) {
		}

		var seconds = 00;
		try {
			var secondsID = stringIDToTypeID( "seconds" );
			seconds = timecodeDesc.getInteger(secondsID);
		}
		catch(e) {
		}

		var minutes = 00;
		try {
			var minutesID = stringIDToTypeID( "minutes" );
			minutes = timecodeDesc.getInteger(minutesID);
		}
		catch(e) {
		}

		var hours = 00;
		try {
			var hoursID = stringIDToTypeID( "hours" );
			hours = timecodeDesc.getInteger(hoursID);
		}
		catch(e) {
		}

		var frameRate = origframeRate;
		try {
			var frameRateID = stringIDToTypeID( "frameRate" );
			frameRate = timecodeDesc.getDouble(frameRateID);
		}
		catch(e) {
		}
		
		var timecode = new Array()
		timecode = [hours, minutes, seconds, frame]	
		//var timecode = hours +":" + minutes +":" + seconds  +":" + frame
		return timecode
	}

	// ==============Set Work Out Point====================
	// Note data is in timecode (hour,min,sec,frame)
	// use CurrentTimecode.jsx for currrent timecode


	function SetWorkOutTime(hours, minutes, seconds, frame)
	{
			var id566 = charIDToTypeID( "setd" );
			var desc152 = new ActionDescriptor();
			var id567 = charIDToTypeID( "null" );
			var ref39 = new ActionReference();
			var id568 = charIDToTypeID( "Prpr" );
			var id569 = stringIDToTypeID( "workOutTime" );
			ref39.putProperty( id568, id569 );
			var id570 = stringIDToTypeID( "timeline" );
			ref39.putClass( id570 );
			desc152.putReference( id567, ref39 );
			var id571 = charIDToTypeID( "T   " );
			var timecodeDescriptor = new ActionDescriptor();
			var hoursID = stringIDToTypeID ("hours")
			timecodeDescriptor.putInteger( hoursID, hours);
			var minutesID = stringIDToTypeID ("minutes")
			timecodeDescriptor.putInteger( minutesID, minutes);
			var secondsID = stringIDToTypeID( "seconds" );
			timecodeDescriptor.putInteger( secondsID, seconds );
			var frameID = stringIDToTypeID( "frame" );
			timecodeDescriptor.putInteger( frameID, frame);
			var framerateID = stringIDToTypeID( "frameRate" );
			timecodeDescriptor.putDouble( framerateID, 30.000000 );
		var timecodeID = stringIDToTypeID( "timecode" );
		desc152.putObject( id571, timecodeID, timecodeDescriptor );
	executeAction( id566, desc152, DialogModes.NO );
	}
}


//this function sets the document length 
//to the number of frames set for frameRange variable.
function SetFrameCount(frameRange)
{
	var setID = charIDToTypeID( 'setd' );
	var nullID = charIDToTypeID( 'null' );
	var propID = charIDToTypeID( 'Prpr' );
	
	var timelineID = stringIDToTypeID( "timeline" );
	var rangeID = stringIDToTypeID( "frameCount" );
	
	var actionRef = new ActionReference();

	actionRef.putProperty( propID, rangeID );
	actionRef.putClass( timelineID );

	var descriptor = new ActionDescriptor();
	descriptor.putReference( nullID, actionRef );
	descriptor.putInteger( rangeID, frameRange );
	
	executeAction( setID, descriptor, DialogModes.NO );
}